(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('browser-stdout'), require('escape-string-regexp'), require('tty'), require('diff'), require('ms'), require('util'), require('he'), require('object.assign'), require('events'), require('debug'), require('mkdirp'), require('os'), require('which'), require('growl')) :
	typeof define === 'function' && define.amd ? define(['browser-stdout', 'escape-string-regexp', 'tty', 'diff', 'ms', 'util', 'he', 'object.assign', 'events', 'debug', 'mkdirp', 'os', 'which', 'growl'], factory) :
	(global = global || self, global.mocha = factory(global.browserStdout, global.escapeStringRegexp, global.tty, global.diff$1, global.ms, global.util, global.he, global.object, global.events, global.debug$2, global.mkdirp, global.os, global.which$1, global.growl$1));
}(this, function (browserStdout, escapeStringRegexp, tty, diff$1, ms, util, he, object, events, debug$2, mkdirp, os, which$1, growl$1) { 'use strict';

	browserStdout = browserStdout && browserStdout.hasOwnProperty('default') ? browserStdout['default'] : browserStdout;
	escapeStringRegexp = escapeStringRegexp && escapeStringRegexp.hasOwnProperty('default') ? escapeStringRegexp['default'] : escapeStringRegexp;
	tty = tty && tty.hasOwnProperty('default') ? tty['default'] : tty;
	diff$1 = diff$1 && diff$1.hasOwnProperty('default') ? diff$1['default'] : diff$1;
	ms = ms && ms.hasOwnProperty('default') ? ms['default'] : ms;
	util = util && util.hasOwnProperty('default') ? util['default'] : util;
	he = he && he.hasOwnProperty('default') ? he['default'] : he;
	object = object && object.hasOwnProperty('default') ? object['default'] : object;
	events = events && events.hasOwnProperty('default') ? events['default'] : events;
	debug$2 = debug$2 && debug$2.hasOwnProperty('default') ? debug$2['default'] : debug$2;
	mkdirp = mkdirp && mkdirp.hasOwnProperty('default') ? mkdirp['default'] : mkdirp;
	os = os && os.hasOwnProperty('default') ? os['default'] : os;
	which$1 = which$1 && which$1.hasOwnProperty('default') ? which$1['default'] : which$1;
	growl$1 = growl$1 && growl$1.hasOwnProperty('default') ? growl$1['default'] : growl$1;

	var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	function getCjsExportFromNamespace (n) {
		return n && n.default || n;
	}

	var _empty_module = {};

	var _empty_module$1 = /*#__PURE__*/Object.freeze({
		'default': _empty_module
	});

	/**
	 * @module Errors
	 */
	/**
	 * Factory functions to create throwable error objects
	 */

	/**
	 * Creates an error object to be thrown when no files to be tested could be found using specified pattern.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} pattern - User-specified argument value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createNoFilesMatchPatternError(message, pattern) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_NO_FILES_MATCH_PATTERN';
	  err.pattern = pattern;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when the reporter specified in the options was not found.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} reporter - User-specified reporter value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidReporterError(message, reporter) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_REPORTER';
	  err.reporter = reporter;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when the interface specified in the options was not found.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} ui - User-specified interface value.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidInterfaceError(message, ui) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_INVALID_INTERFACE';
	  err.interface = ui;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when a behavior, option, or parameter is unsupported.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @returns {Error} instance detailing the error condition
	 */
	function createUnsupportedError(message) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_UNSUPPORTED';
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an argument is missing.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} expected - Expected argument datatype.
	 * @returns {Error} instance detailing the error condition
	 */
	function createMissingArgumentError(message, argument, expected) {
	  return createInvalidArgumentTypeError(message, argument, expected);
	}

	/**
	 * Creates an error object to be thrown when an argument did not use the supported type
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} expected - Expected argument datatype.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidArgumentTypeError(message, argument, expected) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_ARG_TYPE';
	  err.argument = argument;
	  err.expected = expected;
	  err.actual = typeof argument;
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an argument did not use the supported value
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @param {string} argument - Argument name.
	 * @param {string} value - Argument value.
	 * @param {string} [reason] - Why value is invalid.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidArgumentValueError(message, argument, value, reason) {
	  var err = new TypeError(message);
	  err.code = 'ERR_MOCHA_INVALID_ARG_VALUE';
	  err.argument = argument;
	  err.value = value;
	  err.reason = typeof reason !== 'undefined' ? reason : 'is invalid';
	  return err;
	}

	/**
	 * Creates an error object to be thrown when an exception was caught, but the `Error` is falsy or undefined.
	 *
	 * @public
	 * @param {string} message - Error message to be displayed.
	 * @returns {Error} instance detailing the error condition
	 */
	function createInvalidExceptionError(message, value) {
	  var err = new Error(message);
	  err.code = 'ERR_MOCHA_INVALID_EXCEPTION';
	  err.valueType = typeof value;
	  err.value = value;
	  return err;
	}

	var errors = {
	  createInvalidArgumentTypeError: createInvalidArgumentTypeError,
	  createInvalidArgumentValueError: createInvalidArgumentValueError,
	  createInvalidExceptionError: createInvalidExceptionError,
	  createInvalidInterfaceError: createInvalidInterfaceError,
	  createInvalidReporterError: createInvalidReporterError,
	  createMissingArgumentError: createMissingArgumentError,
	  createNoFilesMatchPatternError: createNoFilesMatchPatternError,
	  createUnsupportedError: createUnsupportedError
	};

	var path = getCjsExportFromNamespace(_empty_module$1);

	var utils = createCommonjsModule(function (module, exports) {

	/**
	 * Various utility functions used throughout Mocha's codebase.
	 * @module utils
	 */

	/**
	 * Module dependencies.
	 */







	var createNoFilesMatchPatternError = errors.createNoFilesMatchPatternError;
	var createMissingArgumentError = errors.createMissingArgumentError;

	var assign = (exports.assign = object.getPolyfill());

	/**
	 * Inherit the prototype methods from one constructor into another.
	 *
	 * @param {function} ctor - Constructor function which needs to inherit the
	 *     prototype.
	 * @param {function} superCtor - Constructor function to inherit prototype from.
	 * @throws {TypeError} if either constructor is null, or if super constructor
	 *     lacks a prototype.
	 */
	exports.inherits = util.inherits;

	/**
	 * Escape special characters in the given string of html.
	 *
	 * @private
	 * @param  {string} html
	 * @return {string}
	 */
	exports.escape = function(html) {
	  return he.encode(String(html), {useNamedReferences: false});
	};

	/**
	 * Test if the given obj is type of string.
	 *
	 * @private
	 * @param {Object} obj
	 * @return {boolean}
	 */
	exports.isString = function(obj) {
	  return typeof obj === 'string';
	};

	/**
	 * Compute a slug from the given `str`.
	 *
	 * @private
	 * @param {string} str
	 * @return {string}
	 */
	exports.slug = function(str) {
	  return str
	    .toLowerCase()
	    .replace(/ +/g, '-')
	    .replace(/[^-\w]/g, '');
	};

	/**
	 * Strip the function definition from `str`, and re-indent for pre whitespace.
	 *
	 * @param {string} str
	 * @return {string}
	 */
	exports.clean = function(str) {
	  str = str
	    .replace(/\r\n?|[\n\u2028\u2029]/g, '\n')
	    .replace(/^\uFEFF/, '')
	    // (traditional)->  space/name     parameters    body     (lambda)-> parameters       body   multi-statement/single          keep body content
	    .replace(
	      /^function(?:\s*|\s+[^(]*)\([^)]*\)\s*\{((?:.|\n)*?)\s*\}$|^\([^)]*\)\s*=>\s*(?:\{((?:.|\n)*?)\s*\}|((?:.|\n)*))$/,
	      '$1$2$3'
	    );

	  var spaces = str.match(/^\n?( *)/)[1].length;
	  var tabs = str.match(/^\n?(\t*)/)[1].length;
	  var re = new RegExp(
	    '^\n?' + (tabs ? '\t' : ' ') + '{' + (tabs || spaces) + '}',
	    'gm'
	  );

	  str = str.replace(re, '');

	  return str.trim();
	};

	/**
	 * Parse the given `qs`.
	 *
	 * @private
	 * @param {string} qs
	 * @return {Object}
	 */
	exports.parseQuery = function(qs) {
	  return qs
	    .replace('?', '')
	    .split('&')
	    .reduce(function(obj, pair) {
	      var i = pair.indexOf('=');
	      var key = pair.slice(0, i);
	      var val = pair.slice(++i);

	      // Due to how the URLSearchParams API treats spaces
	      obj[key] = decodeURIComponent(val.replace(/\+/g, '%20'));

	      return obj;
	    }, {});
	};

	/**
	 * Highlight the given string of `js`.
	 *
	 * @private
	 * @param {string} js
	 * @return {string}
	 */
	function highlight(js) {
	  return js
	    .replace(/</g, '&lt;')
	    .replace(/>/g, '&gt;')
	    .replace(/\/\/(.*)/gm, '<span class="comment">//$1</span>')
	    .replace(/('.*?')/gm, '<span class="string">$1</span>')
	    .replace(/(\d+\.\d+)/gm, '<span class="number">$1</span>')
	    .replace(/(\d+)/gm, '<span class="number">$1</span>')
	    .replace(
	      /\bnew[ \t]+(\w+)/gm,
	      '<span class="keyword">new</span> <span class="init">$1</span>'
	    )
	    .replace(
	      /\b(function|new|throw|return|var|if|else)\b/gm,
	      '<span class="keyword">$1</span>'
	    );
	}

	/**
	 * Highlight the contents of tag `name`.
	 *
	 * @private
	 * @param {string} name
	 */
	exports.highlightTags = function(name) {
	  var code = document.getElementById('mocha').getElementsByTagName(name);
	  for (var i = 0, len = code.length; i < len; ++i) {
	    code[i].innerHTML = highlight(code[i].innerHTML);
	  }
	};

	/**
	 * If a value could have properties, and has none, this function is called,
	 * which returns a string representation of the empty value.
	 *
	 * Functions w/ no properties return `'[Function]'`
	 * Arrays w/ length === 0 return `'[]'`
	 * Objects w/ no properties return `'{}'`
	 * All else: return result of `value.toString()`
	 *
	 * @private
	 * @param {*} value The value to inspect.
	 * @param {string} typeHint The type of the value
	 * @returns {string}
	 */
	function emptyRepresentation(value, typeHint) {
	  switch (typeHint) {
	    case 'function':
	      return '[Function]';
	    case 'object':
	      return '{}';
	    case 'array':
	      return '[]';
	    default:
	      return value.toString();
	  }
	}

	/**
	 * Takes some variable and asks `Object.prototype.toString()` what it thinks it
	 * is.
	 *
	 * @private
	 * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toString
	 * @param {*} value The value to test.
	 * @returns {string} Computed type
	 * @example
	 * type({}) // 'object'
	 * type([]) // 'array'
	 * type(1) // 'number'
	 * type(false) // 'boolean'
	 * type(Infinity) // 'number'
	 * type(null) // 'null'
	 * type(new Date()) // 'date'
	 * type(/foo/) // 'regexp'
	 * type('type') // 'string'
	 * type(global) // 'global'
	 * type(new String('foo') // 'object'
	 */
	var type = (exports.type = function type(value) {
	  if (value === undefined) {
	    return 'undefined';
	  } else if (value === null) {
	    return 'null';
	  } else if (Buffer.isBuffer(value)) {
	    return 'buffer';
	  }
	  return Object.prototype.toString
	    .call(value)
	    .replace(/^\[.+\s(.+?)]$/, '$1')
	    .toLowerCase();
	});

	/**
	 * Stringify `value`. Different behavior depending on type of value:
	 *
	 * - If `value` is undefined or null, return `'[undefined]'` or `'[null]'`, respectively.
	 * - If `value` is not an object, function or array, return result of `value.toString()` wrapped in double-quotes.
	 * - If `value` is an *empty* object, function, or array, return result of function
	 *   {@link emptyRepresentation}.
	 * - If `value` has properties, call {@link exports.canonicalize} on it, then return result of
	 *   JSON.stringify().
	 *
	 * @private
	 * @see exports.type
	 * @param {*} value
	 * @return {string}
	 */
	exports.stringify = function(value) {
	  var typeHint = type(value);

	  if (!~['object', 'array', 'function'].indexOf(typeHint)) {
	    if (typeHint === 'buffer') {
	      var json = Buffer.prototype.toJSON.call(value);
	      // Based on the toJSON result
	      return jsonStringify(
	        json.data && json.type ? json.data : json,
	        2
	      ).replace(/,(\n|$)/g, '$1');
	    }

	    // IE7/IE8 has a bizarre String constructor; needs to be coerced
	    // into an array and back to obj.
	    if (typeHint === 'string' && typeof value === 'object') {
	      value = value.split('').reduce(function(acc, char, idx) {
	        acc[idx] = char;
	        return acc;
	      }, {});
	      typeHint = 'object';
	    } else {
	      return jsonStringify(value);
	    }
	  }

	  for (var prop in value) {
	    if (Object.prototype.hasOwnProperty.call(value, prop)) {
	      return jsonStringify(
	        exports.canonicalize(value, null, typeHint),
	        2
	      ).replace(/,(\n|$)/g, '$1');
	    }
	  }

	  return emptyRepresentation(value, typeHint);
	};

	/**
	 * like JSON.stringify but more sense.
	 *
	 * @private
	 * @param {Object}  object
	 * @param {number=} spaces
	 * @param {number=} depth
	 * @returns {*}
	 */
	function jsonStringify(object, spaces, depth) {
	  if (typeof spaces === 'undefined') {
	    // primitive types
	    return _stringify(object);
	  }

	  depth = depth || 1;
	  var space = spaces * depth;
	  var str = Array.isArray(object) ? '[' : '{';
	  var end = Array.isArray(object) ? ']' : '}';
	  var length =
	    typeof object.length === 'number'
	      ? object.length
	      : Object.keys(object).length;
	  // `.repeat()` polyfill
	  function repeat(s, n) {
	    return new Array(n).join(s);
	  }

	  function _stringify(val) {
	    switch (type(val)) {
	      case 'null':
	      case 'undefined':
	        val = '[' + val + ']';
	        break;
	      case 'array':
	      case 'object':
	        val = jsonStringify(val, spaces, depth + 1);
	        break;
	      case 'boolean':
	      case 'regexp':
	      case 'symbol':
	      case 'number':
	        val =
	          val === 0 && 1 / val === -Infinity // `-0`
	            ? '-0'
	            : val.toString();
	        break;
	      case 'date':
	        var sDate = isNaN(val.getTime()) ? val.toString() : val.toISOString();
	        val = '[Date: ' + sDate + ']';
	        break;
	      case 'buffer':
	        var json = val.toJSON();
	        // Based on the toJSON result
	        json = json.data && json.type ? json.data : json;
	        val = '[Buffer: ' + jsonStringify(json, 2, depth + 1) + ']';
	        break;
	      default:
	        val =
	          val === '[Function]' || val === '[Circular]'
	            ? val
	            : JSON.stringify(val); // string
	    }
	    return val;
	  }

	  for (var i in object) {
	    if (!Object.prototype.hasOwnProperty.call(object, i)) {
	      continue; // not my business
	    }
	    --length;
	    str +=
	      '\n ' +
	      repeat(' ', space) +
	      (Array.isArray(object) ? '' : '"' + i + '": ') + // key
	      _stringify(object[i]) + // value
	      (length ? ',' : ''); // comma
	  }

	  return (
	    str +
	    // [], {}
	    (str.length !== 1 ? '\n' + repeat(' ', --space) + end : end)
	  );
	}

	/**
	 * Return a new Thing that has the keys in sorted order. Recursive.
	 *
	 * If the Thing...
	 * - has already been seen, return string `'[Circular]'`
	 * - is `undefined`, return string `'[undefined]'`
	 * - is `null`, return value `null`
	 * - is some other primitive, return the value
	 * - is not a primitive or an `Array`, `Object`, or `Function`, return the value of the Thing's `toString()` method
	 * - is a non-empty `Array`, `Object`, or `Function`, return the result of calling this function again.
	 * - is an empty `Array`, `Object`, or `Function`, return the result of calling `emptyRepresentation()`
	 *
	 * @private
	 * @see {@link exports.stringify}
	 * @param {*} value Thing to inspect.  May or may not have properties.
	 * @param {Array} [stack=[]] Stack of seen values
	 * @param {string} [typeHint] Type hint
	 * @return {(Object|Array|Function|string|undefined)}
	 */
	exports.canonicalize = function canonicalize(value, stack, typeHint) {
	  var canonicalizedObj;
	  /* eslint-disable no-unused-vars */
	  var prop;
	  /* eslint-enable no-unused-vars */
	  typeHint = typeHint || type(value);
	  function withStack(value, fn) {
	    stack.push(value);
	    fn();
	    stack.pop();
	  }

	  stack = stack || [];

	  if (stack.indexOf(value) !== -1) {
	    return '[Circular]';
	  }

	  switch (typeHint) {
	    case 'undefined':
	    case 'buffer':
	    case 'null':
	      canonicalizedObj = value;
	      break;
	    case 'array':
	      withStack(value, function() {
	        canonicalizedObj = value.map(function(item) {
	          return exports.canonicalize(item, stack);
	        });
	      });
	      break;
	    case 'function':
	      /* eslint-disable guard-for-in */
	      for (prop in value) {
	        canonicalizedObj = {};
	        break;
	      }
	      /* eslint-enable guard-for-in */
	      if (!canonicalizedObj) {
	        canonicalizedObj = emptyRepresentation(value, typeHint);
	        break;
	      }
	    /* falls through */
	    case 'object':
	      canonicalizedObj = canonicalizedObj || {};
	      withStack(value, function() {
	        Object.keys(value)
	          .sort()
	          .forEach(function(key) {
	            canonicalizedObj[key] = exports.canonicalize(value[key], stack);
	          });
	      });
	      break;
	    case 'date':
	    case 'number':
	    case 'regexp':
	    case 'boolean':
	    case 'symbol':
	      canonicalizedObj = value;
	      break;
	    default:
	      canonicalizedObj = value + '';
	  }

	  return canonicalizedObj;
	};

	/**
	 * Determines if pathname has a matching file extension.
	 *
	 * @private
	 * @param {string} pathname - Pathname to check for match.
	 * @param {string[]} exts - List of file extensions (sans period).
	 * @return {boolean} whether file extension matches.
	 * @example
	 * hasMatchingExtname('foo.html', ['js', 'css']); // => false
	 */
	function hasMatchingExtname(pathname, exts) {
	  var suffix = path.extname(pathname).slice(1);
	  return exts.some(function(element) {
	    return suffix === element;
	  });
	}

	/**
	 * Determines if pathname would be a "hidden" file (or directory) on UN*X.
	 *
	 * @description
	 * On UN*X, pathnames beginning with a full stop (aka dot) are hidden during
	 * typical usage. Dotfiles, plain-text configuration files, are prime examples.
	 *
	 * @see {@link http://xahlee.info/UnixResource_dir/writ/unix_origin_of_dot_filename.html|Origin of Dot File Names}
	 *
	 * @private
	 * @param {string} pathname - Pathname to check for match.
	 * @return {boolean} whether pathname would be considered a hidden file.
	 * @example
	 * isHiddenOnUnix('.profile'); // => true
	 */
	function isHiddenOnUnix(pathname) {
	  return path.basename(pathname)[0] === '.';
	}

	/**
	 * Lookup file names at the given `path`.
	 *
	 * @description
	 * Filenames are returned in _traversal_ order by the OS/filesystem.
	 * **Make no assumption that the names will be sorted in any fashion.**
	 *
	 * @public
	 * @memberof Mocha.utils
	 * @param {string} filepath - Base path to start searching from.
	 * @param {string[]} [extensions=[]] - File extensions to look for.
	 * @param {boolean} [recursive=false] - Whether to recurse into subdirectories.
	 * @return {string[]} An array of paths.
	 * @throws {Error} if no files match pattern.
	 * @throws {TypeError} if `filepath` is directory and `extensions` not provided.
	 */
	exports.lookupFiles = function lookupFiles(filepath, extensions, recursive) {
	  extensions = extensions || [];
	  recursive = recursive || false;
	  var files = [];
	  var stat;

	  if (!path.existsSync(filepath)) {
	    var pattern;
	    if (path.hasMagic(filepath)) {
	      // Handle glob as is without extensions
	      pattern = filepath;
	    } else {
	      // glob pattern e.g. 'filepath+(.js|.ts)'
	      var strExtensions = extensions
	        .map(function(v) {
	          return '.' + v;
	        })
	        .join('|');
	      pattern = filepath + '+(' + strExtensions + ')';
	    }
	    files = path.sync(pattern, {nodir: true});
	    if (!files.length) {
	      throw createNoFilesMatchPatternError(
	        'Cannot find any files matching pattern ' + exports.dQuote(filepath),
	        filepath
	      );
	    }
	    return files;
	  }

	  // Handle file
	  try {
	    stat = path.statSync(filepath);
	    if (stat.isFile()) {
	      return filepath;
	    }
	  } catch (err) {
	    // ignore error
	    return;
	  }

	  // Handle directory
	  path.readdirSync(filepath).forEach(function(dirent) {
	    var pathname = path.join(filepath, dirent);
	    var stat;

	    try {
	      stat = path.statSync(pathname);
	      if (stat.isDirectory()) {
	        if (recursive) {
	          files = files.concat(lookupFiles(pathname, extensions, recursive));
	        }
	        return;
	      }
	    } catch (err) {
	      // ignore error
	      return;
	    }
	    if (!extensions.length) {
	      throw createMissingArgumentError(
	        util.format(
	          'Argument %s required when argument %s is a directory',
	          exports.sQuote('extensions'),
	          exports.sQuote('filepath')
	        ),
	        'extensions',
	        'array'
	      );
	    }

	    if (
	      !stat.isFile() ||
	      !hasMatchingExtname(pathname, extensions) ||
	      isHiddenOnUnix(pathname)
	    ) {
	      return;
	    }
	    files.push(pathname);
	  });

	  return files;
	};

	/**
	 * process.emitWarning or a polyfill
	 * @see https://nodejs.org/api/process.html#process_process_emitwarning_warning_options
	 * @ignore
	 */
	function emitWarning(msg, type) {
	  if (process.emitWarning) {
	    process.emitWarning(msg, type);
	  } else {
	    process.nextTick(function() {
	      console.warn(type + ': ' + msg);
	    });
	  }
	}

	/**
	 * Show a deprecation warning. Each distinct message is only displayed once.
	 * Ignores empty messages.
	 *
	 * @param {string} [msg] - Warning to print
	 * @private
	 */
	exports.deprecate = function deprecate(msg) {
	  msg = String(msg);
	  if (msg && !deprecate.cache[msg]) {
	    deprecate.cache[msg] = true;
	    emitWarning(msg, 'DeprecationWarning');
	  }
	};
	exports.deprecate.cache = {};

	/**
	 * Show a generic warning.
	 * Ignores empty messages.
	 *
	 * @param {string} [msg] - Warning to print
	 * @private
	 */
	exports.warn = function warn(msg) {
	  if (msg) {
	    emitWarning(msg);
	  }
	};

	/**
	 * @summary
	 * This Filter based on `mocha-clean` module.(see: `github.com/rstacruz/mocha-clean`)
	 * @description
	 * When invoking this function you get a filter function that get the Error.stack as an input,
	 * and return a prettify output.
	 * (i.e: strip Mocha and internal node functions from stack trace).
	 * @returns {Function}
	 */
	exports.stackTraceFilter = function() {
	  // TODO: Replace with `process.browser`
	  var is = typeof document === 'undefined' ? {node: true} : {browser: true};
	  var slash = path.sep;
	  var cwd;
	  if (is.node) {
	    cwd = process.cwd() + slash;
	  } else {
	    cwd = (typeof location === 'undefined'
	      ? window.location
	      : location
	    ).href.replace(/\/[^/]*$/, '/');
	    slash = '/';
	  }

	  function isMochaInternal(line) {
	    return (
	      ~line.indexOf('node_modules' + slash + 'mocha' + slash) ||
	      ~line.indexOf(slash + 'mocha.js') ||
	      ~line.indexOf(slash + 'mocha.min.js')
	    );
	  }

	  function isNodeInternal(line) {
	    return (
	      ~line.indexOf('(timers.js:') ||
	      ~line.indexOf('(events.js:') ||
	      ~line.indexOf('(node.js:') ||
	      ~line.indexOf('(module.js:') ||
	      ~line.indexOf('GeneratorFunctionPrototype.next (native)') ||
	      false
	    );
	  }

	  return function(stack) {
	    stack = stack.split('\n');

	    stack = stack.reduce(function(list, line) {
	      if (isMochaInternal(line)) {
	        return list;
	      }

	      if (is.node && isNodeInternal(line)) {
	        return list;
	      }

	      // Clean up cwd(absolute)
	      if (/:\d+:\d+\)?$/.test(line)) {
	        line = line.replace('(' + cwd, '(');
	      }

	      list.push(line);
	      return list;
	    }, []);

	    return stack.join('\n');
	  };
	};

	/**
	 * Crude, but effective.
	 * @public
	 * @param {*} value
	 * @returns {boolean} Whether or not `value` is a Promise
	 */
	exports.isPromise = function isPromise(value) {
	  return (
	    typeof value === 'object' &&
	    value !== null &&
	    typeof value.then === 'function'
	  );
	};

	/**
	 * Clamps a numeric value to an inclusive range.
	 *
	 * @param {number} value - Value to be clamped.
	 * @param {numer[]} range - Two element array specifying [min, max] range.
	 * @returns {number} clamped value
	 */
	exports.clamp = function clamp(value, range) {
	  return Math.min(Math.max(value, range[0]), range[1]);
	};

	/**
	 * Single quote text by combining with undirectional ASCII quotation marks.
	 *
	 * @description
	 * Provides a simple means of markup for quoting text to be used in output.
	 * Use this to quote names of variables, methods, and packages.
	 *
	 * <samp>package 'foo' cannot be found</samp>
	 *
	 * @private
	 * @param {string} str - Value to be quoted.
	 * @returns {string} quoted value
	 * @example
	 * sQuote('n') // => 'n'
	 */
	exports.sQuote = function(str) {
	  return "'" + str + "'";
	};

	/**
	 * Double quote text by combining with undirectional ASCII quotation marks.
	 *
	 * @description
	 * Provides a simple means of markup for quoting text to be used in output.
	 * Use this to quote names of datatypes, classes, pathnames, and strings.
	 *
	 * <samp>argument 'value' must be "string" or "number"</samp>
	 *
	 * @private
	 * @param {string} str - Value to be quoted.
	 * @returns {string} quoted value
	 * @example
	 * dQuote('number') // => "number"
	 */
	exports.dQuote = function(str) {
	  return '"' + str + '"';
	};

	/**
	 * Provides simplistic message translation for dealing with plurality.
	 *
	 * @description
	 * Use this to create messages which need to be singular or plural.
	 * Some languages have several plural forms, so _complete_ message clauses
	 * are preferable to generating the message on the fly.
	 *
	 * @private
	 * @param {number} n - Non-negative integer
	 * @param {string} msg1 - Message to be used in English for `n = 1`
	 * @param {string} msg2 - Message to be used in English for `n = 0, 2, 3, ...`
	 * @returns {string} message corresponding to value of `n`
	 * @example
	 * var sprintf = require('util').format;
	 * var pkgs = ['one', 'two'];
	 * var msg = sprintf(
	 *   ngettext(
	 *     pkgs.length,
	 *     'cannot load package: %s',
	 *     'cannot load packages: %s'
	 *   ),
	 *   pkgs.map(sQuote).join(', ')
	 * );
	 * console.log(msg); // => cannot load packages: 'one', 'two'
	 */
	exports.ngettext = function(n, msg1, msg2) {
	  if (typeof n === 'number' && n >= 0) {
	    return n === 1 ? msg1 : msg2;
	  }
	};

	/**
	 * It's a noop.
	 * @public
	 */
	exports.noop = function() {};

	/**
	 * Creates a map-like object.
	 *
	 * @description
	 * A "map" is an object with no prototype, for our purposes. In some cases
	 * this would be more appropriate than a `Map`, especially if your environment
	 * doesn't support it. Recommended for use in Mocha's public APIs.
	 *
	 * @public
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map|MDN:Map}
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/create#Custom_and_Null_objects|MDN:Object.create - Custom objects}
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/assign|MDN:Object.assign}
	 * @param {...*} [obj] - Arguments to `Object.assign()`.
	 * @returns {Object} An object with no prototype, having `...obj` properties
	 */
	exports.createMap = function(obj) {
	  return assign.apply(
	    null,
	    [Object.create(null)].concat(Array.prototype.slice.call(arguments))
	  );
	};

	/**
	 * Creates a read-only map-like object.
	 *
	 * @description
	 * This differs from {@link module:utils.createMap createMap} only in that
	 * the argument must be non-empty, because the result is frozen.
	 *
	 * @see {@link module:utils.createMap createMap}
	 * @param {...*} [obj] - Arguments to `Object.assign()`.
	 * @returns {Object} A frozen object with no prototype, having `...obj` properties
	 * @throws {TypeError} if argument is not a non-empty object.
	 */
	exports.defineConstants = function(obj) {
	  if (type(obj) !== 'object' || !Object.keys(obj).length) {
	    throw new TypeError('Invalid argument; expected a non-empty object');
	  }
	  return Object.freeze(exports.createMap(obj));
	};
	});
	var utils_1 = utils.assign;
	var utils_2 = utils.inherits;
	var utils_3 = utils.escape;
	var utils_4 = utils.isString;
	var utils_5 = utils.slug;
	var utils_6 = utils.clean;
	var utils_7 = utils.parseQuery;
	var utils_8 = utils.highlightTags;
	var utils_9 = utils.type;
	var utils_10 = utils.stringify;
	var utils_11 = utils.canonicalize;
	var utils_12 = utils.lookupFiles;
	var utils_13 = utils.deprecate;
	var utils_14 = utils.warn;
	var utils_15 = utils.stackTraceFilter;
	var utils_16 = utils.isPromise;
	var utils_17 = utils.clamp;
	var utils_18 = utils.sQuote;
	var utils_19 = utils.dQuote;
	var utils_20 = utils.ngettext;
	var utils_21 = utils.noop;
	var utils_22 = utils.createMap;
	var utils_23 = utils.defineConstants;

	var pending = Pending;

	/**
	 * Initialize a new `Pending` error with the given message.
	 *
	 * @param {string} message
	 */
	function Pending(message) {
	  this.message = message;
	}

	var EventEmitter = events.EventEmitter;

	var debug = debug$2('mocha:runnable');


	var createInvalidExceptionError$1 = errors
	  .createInvalidExceptionError;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */
	var Date = commonjsGlobal.Date;
	var setTimeout = commonjsGlobal.setTimeout;
	var clearTimeout = commonjsGlobal.clearTimeout;
	var toString = Object.prototype.toString;

	var runnable = Runnable;

	/**
	 * Initialize a new `Runnable` with the given `title` and callback `fn`.
	 *
	 * @class
	 * @extends external:EventEmitter
	 * @public
	 * @param {String} title
	 * @param {Function} fn
	 */
	function Runnable(title, fn) {
	  this.title = title;
	  this.fn = fn;
	  this.body = (fn || '').toString();
	  this.async = fn && fn.length;
	  this.sync = !this.async;
	  this._timeout = 2000;
	  this._slow = 75;
	  this._enableTimeouts = true;
	  this.timedOut = false;
	  this._retries = -1;
	  this._currentRetry = 0;
	  this.pending = false;
	}

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	utils.inherits(Runnable, EventEmitter);

	/**
	 * Get current timeout value in msecs.
	 *
	 * @private
	 * @returns {number} current timeout threshold value
	 */
	/**
	 * @summary
	 * Set timeout threshold value (msecs).
	 *
	 * @description
	 * A string argument can use shorthand (e.g., "2s") and will be converted.
	 * The value will be clamped to range [<code>0</code>, <code>2^<sup>31</sup>-1</code>].
	 * If clamped value matches either range endpoint, timeouts will be disabled.
	 *
	 * @private
	 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/WindowOrWorkerGlobalScope/setTimeout#Maximum_delay_value}
	 * @param {number|string} ms - Timeout threshold value.
	 * @returns {Runnable} this
	 * @chainable
	 */
	Runnable.prototype.timeout = function(ms$1) {
	  if (!arguments.length) {
	    return this._timeout;
	  }
	  if (typeof ms$1 === 'string') {
	    ms$1 = ms(ms$1);
	  }

	  // Clamp to range
	  var INT_MAX = Math.pow(2, 31) - 1;
	  var range = [0, INT_MAX];
	  ms$1 = utils.clamp(ms$1, range);

	  // see #1652 for reasoning
	  if (ms$1 === range[0] || ms$1 === range[1]) {
	    this._enableTimeouts = false;
	  }
	  debug('timeout %d', ms$1);
	  this._timeout = ms$1;
	  if (this.timer) {
	    this.resetTimeout();
	  }
	  return this;
	};

	/**
	 * Set or get slow `ms`.
	 *
	 * @private
	 * @param {number|string} ms
	 * @return {Runnable|number} ms or Runnable instance.
	 */
	Runnable.prototype.slow = function(ms$1) {
	  if (!arguments.length || typeof ms$1 === 'undefined') {
	    return this._slow;
	  }
	  if (typeof ms$1 === 'string') {
	    ms$1 = ms(ms$1);
	  }
	  debug('slow %d', ms$1);
	  this._slow = ms$1;
	  return this;
	};

	/**
	 * Set and get whether timeout is `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Runnable|boolean} enabled or Runnable instance.
	 */
	Runnable.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this._enableTimeouts;
	  }
	  debug('enableTimeouts %s', enabled);
	  this._enableTimeouts = enabled;
	  return this;
	};

	/**
	 * Halt and mark as pending.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 */
	Runnable.prototype.skip = function() {
	  this.pending = true;
	  throw new pending('sync skip; aborting execution');
	};

	/**
	 * Check if this runnable or its parent suite is marked as pending.
	 *
	 * @private
	 */
	Runnable.prototype.isPending = function() {
	  return this.pending || (this.parent && this.parent.isPending());
	};

	/**
	 * Return `true` if this Runnable has failed.
	 * @return {boolean}
	 * @private
	 */
	Runnable.prototype.isFailed = function() {
	  return !this.isPending() && this.state === constants.STATE_FAILED;
	};

	/**
	 * Return `true` if this Runnable has passed.
	 * @return {boolean}
	 * @private
	 */
	Runnable.prototype.isPassed = function() {
	  return !this.isPending() && this.state === constants.STATE_PASSED;
	};

	/**
	 * Set or get number of retries.
	 *
	 * @private
	 */
	Runnable.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this._retries;
	  }
	  this._retries = n;
	};

	/**
	 * Set or get current retry
	 *
	 * @private
	 */
	Runnable.prototype.currentRetry = function(n) {
	  if (!arguments.length) {
	    return this._currentRetry;
	  }
	  this._currentRetry = n;
	};

	/**
	 * Return the full title generated by recursively concatenating the parent's
	 * full title.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 * @return {string}
	 */
	Runnable.prototype.fullTitle = function() {
	  return this.titlePath().join(' ');
	};

	/**
	 * Return the title path generated by concatenating the parent's title path with the title.
	 *
	 * @memberof Mocha.Runnable
	 * @public
	 * @return {string}
	 */
	Runnable.prototype.titlePath = function() {
	  return this.parent.titlePath().concat([this.title]);
	};

	/**
	 * Clear the timeout.
	 *
	 * @private
	 */
	Runnable.prototype.clearTimeout = function() {
	  clearTimeout(this.timer);
	};

	/**
	 * Inspect the runnable void of private properties.
	 *
	 * @private
	 * @return {string}
	 */
	Runnable.prototype.inspect = function() {
	  return JSON.stringify(
	    this,
	    function(key, val) {
	      if (key[0] === '_') {
	        return;
	      }
	      if (key === 'parent') {
	        return '#<Suite>';
	      }
	      if (key === 'ctx') {
	        return '#<Context>';
	      }
	      return val;
	    },
	    2
	  );
	};

	/**
	 * Reset the timeout.
	 *
	 * @private
	 */
	Runnable.prototype.resetTimeout = function() {
	  var self = this;
	  var ms = this.timeout() || 1e9;

	  if (!this._enableTimeouts) {
	    return;
	  }
	  this.clearTimeout();
	  this.timer = setTimeout(function() {
	    if (!self._enableTimeouts) {
	      return;
	    }
	    self.callback(self._timeoutError(ms));
	    self.timedOut = true;
	  }, ms);
	};

	/**
	 * Set or get a list of whitelisted globals for this test run.
	 *
	 * @private
	 * @param {string[]} globals
	 */
	Runnable.prototype.globals = function(globals) {
	  if (!arguments.length) {
	    return this._allowedGlobals;
	  }
	  this._allowedGlobals = globals;
	};

	/**
	 * Run the test and invoke `fn(err)`.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runnable.prototype.run = function(fn) {
	  var self = this;
	  var start = new Date();
	  var ctx = this.ctx;
	  var finished;
	  var emitted;

	  // Sometimes the ctx exists, but it is not runnable
	  if (ctx && ctx.runnable) {
	    ctx.runnable(this);
	  }

	  // called multiple times
	  function multiple(err) {
	    if (emitted) {
	      return;
	    }
	    emitted = true;
	    var msg = 'done() called multiple times';
	    if (err && err.message) {
	      err.message += " (and Mocha's " + msg + ')';
	      self.emit('error', err);
	    } else {
	      self.emit('error', new Error(msg));
	    }
	  }

	  // finished
	  function done(err) {
	    var ms = self.timeout();
	    if (self.timedOut) {
	      return;
	    }

	    if (finished) {
	      return multiple(err);
	    }

	    self.clearTimeout();
	    self.duration = new Date() - start;
	    finished = true;
	    if (!err && self.duration > ms && self._enableTimeouts) {
	      err = self._timeoutError(ms);
	    }
	    fn(err);
	  }

	  // for .resetTimeout() and Runner#uncaught()
	  this.callback = done;

	  if (this.fn && typeof this.fn.call !== 'function') {
	    done(
	      new TypeError(
	        'A runnable must be passed a function as its second argument.'
	      )
	    );
	    return;
	  }

	  // explicit async with `done` argument
	  if (this.async) {
	    this.resetTimeout();

	    // allows skip() to be used in an explicit async context
	    this.skip = function asyncSkip() {
	      this.pending = true;
	      done();
	      // halt execution, the uncaught handler will ignore the failure.
	      throw new pending('async skip; aborting execution');
	    };

	    try {
	      callFnAsync(this.fn);
	    } catch (err) {
	      // handles async runnables which actually run synchronously
	      emitted = true;
	      if (err instanceof pending) {
	        return; // done() is already called in this.skip()
	      } else if (this.allowUncaught) {
	        throw err;
	      }
	      done(Runnable.toValueOrError(err));
	    }
	    return;
	  }

	  // sync or promise-returning
	  try {
	    if (this.isPending()) {
	      done();
	    } else {
	      callFn(this.fn);
	    }
	  } catch (err) {
	    emitted = true;
	    if (err instanceof pending) {
	      return done();
	    } else if (this.allowUncaught) {
	      throw err;
	    }
	    done(Runnable.toValueOrError(err));
	  }

	  function callFn(fn) {
	    var result = fn.call(ctx);
	    if (result && typeof result.then === 'function') {
	      self.resetTimeout();
	      result.then(
	        function() {
	          done();
	          // Return null so libraries like bluebird do not warn about
	          // subsequently constructed Promises.
	          return null;
	        },
	        function(reason) {
	          done(reason || new Error('Promise rejected with no or falsy reason'));
	        }
	      );
	    } else {
	      if (self.asyncOnly) {
	        return done(
	          new Error(
	            '--async-only option in use without declaring `done()` or returning a promise'
	          )
	        );
	      }

	      done();
	    }
	  }

	  function callFnAsync(fn) {
	    var result = fn.call(ctx, function(err) {
	      if (err instanceof Error || toString.call(err) === '[object Error]') {
	        return done(err);
	      }
	      if (err) {
	        if (Object.prototype.toString.call(err) === '[object Object]') {
	          return done(
	            new Error('done() invoked with non-Error: ' + JSON.stringify(err))
	          );
	        }
	        return done(new Error('done() invoked with non-Error: ' + err));
	      }
	      if (result && utils.isPromise(result)) {
	        return done(
	          new Error(
	            'Resolution method is overspecified. Specify a callback *or* return a Promise; not both.'
	          )
	        );
	      }

	      done();
	    });
	  }
	};

	/**
	 * Instantiates a "timeout" error
	 *
	 * @param {number} ms - Timeout (in milliseconds)
	 * @returns {Error} a "timeout" error
	 * @private
	 */
	Runnable.prototype._timeoutError = function(ms) {
	  var msg =
	    'Timeout of ' +
	    ms +
	    'ms exceeded. For async tests and hooks, ensure "done()" is called; if returning a Promise, ensure it resolves.';
	  if (this.file) {
	    msg += ' (' + this.file + ')';
	  }
	  return new Error(msg);
	};

	var constants = utils.defineConstants(
	  /**
	   * {@link Runnable}-related constants.
	   * @public
	   * @memberof Runnable
	   * @readonly
	   * @static
	   * @alias constants
	   * @enum {string}
	   */
	  {
	    /**
	     * Value of `state` prop when a `Runnable` has failed
	     */
	    STATE_FAILED: 'failed',
	    /**
	     * Value of `state` prop when a `Runnable` has passed
	     */
	    STATE_PASSED: 'passed'
	  }
	);

	/**
	 * Given `value`, return identity if truthy, otherwise create an "invalid exception" error and return that.
	 * @param {*} [value] - Value to return, if present
	 * @returns {*|Error} `value`, otherwise an `Error`
	 * @private
	 */
	Runnable.toValueOrError = function(value) {
	  return (
	    value ||
	    createInvalidExceptionError$1(
	      'Runnable failed with falsy or undefined exception. Please throw an Error instead.',
	      value
	    )
	  );
	};

	Runnable.constants = constants;

	var inherits = utils.inherits;

	/**
	 * Expose `Hook`.
	 */

	var hook = Hook;

	/**
	 * Initialize a new `Hook` with the given `title` and callback `fn`
	 *
	 * @class
	 * @extends Runnable
	 * @param {String} title
	 * @param {Function} fn
	 */
	function Hook(title, fn) {
	  runnable.call(this, title, fn);
	  this.type = 'hook';
	}

	/**
	 * Inherit from `Runnable.prototype`.
	 */
	inherits(Hook, runnable);

	/**
	 * Get or set the test `err`.
	 *
	 * @memberof Hook
	 * @public
	 * @param {Error} err
	 * @return {Error}
	 */
	Hook.prototype.error = function(err) {
	  if (!arguments.length) {
	    err = this._error;
	    this._error = null;
	    return err;
	  }

	  this._error = err;
	};

	var suite = createCommonjsModule(function (module, exports) {

	/**
	 * Module dependencies.
	 */
	var EventEmitter = events.EventEmitter;


	var inherits = utils.inherits;
	var debug = debug$2('mocha:suite');


	var createInvalidArgumentTypeError = errors.createInvalidArgumentTypeError;

	/**
	 * Expose `Suite`.
	 */

	exports = module.exports = Suite;

	/**
	 * Create a new `Suite` with the given `title` and parent `Suite`.
	 *
	 * @public
	 * @param {Suite} parent - Parent suite (required!)
	 * @param {string} title - Title
	 * @return {Suite}
	 */
	Suite.create = function(parent, title) {
	  var suite = new Suite(title, parent.ctx);
	  suite.parent = parent;
	  title = suite.fullTitle();
	  parent.addSuite(suite);
	  return suite;
	};

	/**
	 * Constructs a new `Suite` instance with the given `title`, `ctx`, and `isRoot`.
	 *
	 * @public
	 * @class
	 * @extends EventEmitter
	 * @see {@link https://nodejs.org/api/events.html#events_class_eventemitter|EventEmitter}
	 * @param {string} title - Suite title.
	 * @param {Context} parentContext - Parent context instance.
	 * @param {boolean} [isRoot=false] - Whether this is the root suite.
	 */
	function Suite(title, parentContext, isRoot) {
	  if (!utils.isString(title)) {
	    throw createInvalidArgumentTypeError(
	      'Suite argument "title" must be a string. Received type "' +
	        typeof title +
	        '"',
	      'title',
	      'string'
	    );
	  }
	  this.title = title;
	  function Context() {}
	  Context.prototype = parentContext;
	  this.ctx = new Context();
	  this.suites = [];
	  this.tests = [];
	  this.pending = false;
	  this._beforeEach = [];
	  this._beforeAll = [];
	  this._afterEach = [];
	  this._afterAll = [];
	  this.root = isRoot === true;
	  this._timeout = 2000;
	  this._enableTimeouts = true;
	  this._slow = 75;
	  this._bail = false;
	  this._retries = -1;
	  this._onlyTests = [];
	  this._onlySuites = [];
	  this.delayed = false;

	  this.on('newListener', function(event) {
	    if (deprecatedEvents[event]) {
	      utils.deprecate(
	        'Event "' +
	          event +
	          '" is deprecated.  Please let the Mocha team know about your use case: https://git.io/v6Lwm'
	      );
	    }
	  });
	}

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	inherits(Suite, EventEmitter);

	/**
	 * Return a clone of this `Suite`.
	 *
	 * @private
	 * @return {Suite}
	 */
	Suite.prototype.clone = function() {
	  var suite = new Suite(this.title);
	  debug('clone');
	  suite.ctx = this.ctx;
	  suite.root = this.root;
	  suite.timeout(this.timeout());
	  suite.retries(this.retries());
	  suite.enableTimeouts(this.enableTimeouts());
	  suite.slow(this.slow());
	  suite.bail(this.bail());
	  return suite;
	};

	/**
	 * Set or get timeout `ms` or short-hand such as "2s".
	 *
	 * @private
	 * @todo Do not attempt to set value if `ms` is undefined
	 * @param {number|string} ms
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.timeout = function(ms$1) {
	  if (!arguments.length) {
	    return this._timeout;
	  }
	  if (ms$1.toString() === '0') {
	    this._enableTimeouts = false;
	  }
	  if (typeof ms$1 === 'string') {
	    ms$1 = ms(ms$1);
	  }
	  debug('timeout %d', ms$1);
	  this._timeout = parseInt(ms$1, 10);
	  return this;
	};

	/**
	 * Set or get number of times to retry a failed test.
	 *
	 * @private
	 * @param {number|string} n
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this._retries;
	  }
	  debug('retries %d', n);
	  this._retries = parseInt(n, 10) || 0;
	  return this;
	};

	/**
	 * Set or get timeout to `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Suite|boolean} self or enabled
	 */
	Suite.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this._enableTimeouts;
	  }
	  debug('enableTimeouts %s', enabled);
	  this._enableTimeouts = enabled;
	  return this;
	};

	/**
	 * Set or get slow `ms` or short-hand such as "2s".
	 *
	 * @private
	 * @param {number|string} ms
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.slow = function(ms$1) {
	  if (!arguments.length) {
	    return this._slow;
	  }
	  if (typeof ms$1 === 'string') {
	    ms$1 = ms(ms$1);
	  }
	  debug('slow %d', ms$1);
	  this._slow = ms$1;
	  return this;
	};

	/**
	 * Set or get whether to bail after first error.
	 *
	 * @private
	 * @param {boolean} bail
	 * @return {Suite|number} for chaining
	 */
	Suite.prototype.bail = function(bail) {
	  if (!arguments.length) {
	    return this._bail;
	  }
	  debug('bail %s', bail);
	  this._bail = bail;
	  return this;
	};

	/**
	 * Check if this suite or its parent suite is marked as pending.
	 *
	 * @private
	 */
	Suite.prototype.isPending = function() {
	  return this.pending || (this.parent && this.parent.isPending());
	};

	/**
	 * Generic hook-creator.
	 * @private
	 * @param {string} title - Title of hook
	 * @param {Function} fn - Hook callback
	 * @returns {Hook} A new hook
	 */
	Suite.prototype._createHook = function(title, fn) {
	  var hook$1 = new hook(title, fn);
	  hook$1.parent = this;
	  hook$1.timeout(this.timeout());
	  hook$1.retries(this.retries());
	  hook$1.enableTimeouts(this.enableTimeouts());
	  hook$1.slow(this.slow());
	  hook$1.ctx = this.ctx;
	  hook$1.file = this.file;
	  return hook$1;
	};

	/**
	 * Run `fn(test[, done])` before running tests.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.beforeAll = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"before all" hook' + (title ? ': ' + title : '');

	  var hook = this._createHook(title, fn);
	  this._beforeAll.push(hook);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_BEFORE_ALL, hook);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` after running tests.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.afterAll = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"after all" hook' + (title ? ': ' + title : '');

	  var hook = this._createHook(title, fn);
	  this._afterAll.push(hook);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_AFTER_ALL, hook);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` before each test case.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.beforeEach = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"before each" hook' + (title ? ': ' + title : '');

	  var hook = this._createHook(title, fn);
	  this._beforeEach.push(hook);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_BEFORE_EACH, hook);
	  return this;
	};

	/**
	 * Run `fn(test[, done])` after each test case.
	 *
	 * @private
	 * @param {string} title
	 * @param {Function} fn
	 * @return {Suite} for chaining
	 */
	Suite.prototype.afterEach = function(title, fn) {
	  if (this.isPending()) {
	    return this;
	  }
	  if (typeof title === 'function') {
	    fn = title;
	    title = fn.name;
	  }
	  title = '"after each" hook' + (title ? ': ' + title : '');

	  var hook = this._createHook(title, fn);
	  this._afterEach.push(hook);
	  this.emit(constants.EVENT_SUITE_ADD_HOOK_AFTER_EACH, hook);
	  return this;
	};

	/**
	 * Add a test `suite`.
	 *
	 * @private
	 * @param {Suite} suite
	 * @return {Suite} for chaining
	 */
	Suite.prototype.addSuite = function(suite) {
	  suite.parent = this;
	  suite.root = false;
	  suite.timeout(this.timeout());
	  suite.retries(this.retries());
	  suite.enableTimeouts(this.enableTimeouts());
	  suite.slow(this.slow());
	  suite.bail(this.bail());
	  this.suites.push(suite);
	  this.emit(constants.EVENT_SUITE_ADD_SUITE, suite);
	  return this;
	};

	/**
	 * Add a `test` to this suite.
	 *
	 * @private
	 * @param {Test} test
	 * @return {Suite} for chaining
	 */
	Suite.prototype.addTest = function(test) {
	  test.parent = this;
	  test.timeout(this.timeout());
	  test.retries(this.retries());
	  test.enableTimeouts(this.enableTimeouts());
	  test.slow(this.slow());
	  test.ctx = this.ctx;
	  this.tests.push(test);
	  this.emit(constants.EVENT_SUITE_ADD_TEST, test);
	  return this;
	};

	/**
	 * Return the full title generated by recursively concatenating the parent's
	 * full title.
	 *
	 * @memberof Suite
	 * @public
	 * @return {string}
	 */
	Suite.prototype.fullTitle = function() {
	  return this.titlePath().join(' ');
	};

	/**
	 * Return the title path generated by recursively concatenating the parent's
	 * title path.
	 *
	 * @memberof Suite
	 * @public
	 * @return {string}
	 */
	Suite.prototype.titlePath = function() {
	  var result = [];
	  if (this.parent) {
	    result = result.concat(this.parent.titlePath());
	  }
	  if (!this.root) {
	    result.push(this.title);
	  }
	  return result;
	};

	/**
	 * Return the total number of tests.
	 *
	 * @memberof Suite
	 * @public
	 * @return {number}
	 */
	Suite.prototype.total = function() {
	  return (
	    this.suites.reduce(function(sum, suite) {
	      return sum + suite.total();
	    }, 0) + this.tests.length
	  );
	};

	/**
	 * Iterates through each suite recursively to find all tests. Applies a
	 * function in the format `fn(test)`.
	 *
	 * @private
	 * @param {Function} fn
	 * @return {Suite}
	 */
	Suite.prototype.eachTest = function(fn) {
	  this.tests.forEach(fn);
	  this.suites.forEach(function(suite) {
	    suite.eachTest(fn);
	  });
	  return this;
	};

	/**
	 * This will run the root suite if we happen to be running in delayed mode.
	 * @private
	 */
	Suite.prototype.run = function run() {
	  if (this.root) {
	    this.emit(constants.EVENT_ROOT_SUITE_RUN);
	  }
	};

	/**
	 * Determines whether a suite has an `only` test or suite as a descendant.
	 *
	 * @private
	 * @returns {Boolean}
	 */
	Suite.prototype.hasOnly = function hasOnly() {
	  return (
	    this._onlyTests.length > 0 ||
	    this._onlySuites.length > 0 ||
	    this.suites.some(function(suite) {
	      return suite.hasOnly();
	    })
	  );
	};

	/**
	 * Filter suites based on `isOnly` logic.
	 *
	 * @private
	 * @returns {Boolean}
	 */
	Suite.prototype.filterOnly = function filterOnly() {
	  if (this._onlyTests.length) {
	    // If the suite contains `only` tests, run those and ignore any nested suites.
	    this.tests = this._onlyTests;
	    this.suites = [];
	  } else {
	    // Otherwise, do not run any of the tests in this suite.
	    this.tests = [];
	    this._onlySuites.forEach(function(onlySuite) {
	      // If there are other `only` tests/suites nested in the current `only` suite, then filter that `only` suite.
	      // Otherwise, all of the tests on this `only` suite should be run, so don't filter it.
	      if (onlySuite.hasOnly()) {
	        onlySuite.filterOnly();
	      }
	    });
	    // Run the `only` suites, as well as any other suites that have `only` tests/suites as descendants.
	    var onlySuites = this._onlySuites;
	    this.suites = this.suites.filter(function(childSuite) {
	      return onlySuites.indexOf(childSuite) !== -1 || childSuite.filterOnly();
	    });
	  }
	  // Keep the suite only if there is something to run
	  return this.tests.length > 0 || this.suites.length > 0;
	};

	/**
	 * Adds a suite to the list of subsuites marked `only`.
	 *
	 * @private
	 * @param {Suite} suite
	 */
	Suite.prototype.appendOnlySuite = function(suite) {
	  this._onlySuites.push(suite);
	};

	/**
	 * Adds a test to the list of tests marked `only`.
	 *
	 * @private
	 * @param {Test} test
	 */
	Suite.prototype.appendOnlyTest = function(test) {
	  this._onlyTests.push(test);
	};

	/**
	 * Returns the array of hooks by hook name; see `HOOK_TYPE_*` constants.
	 * @private
	 */
	Suite.prototype.getHooks = function getHooks(name) {
	  return this['_' + name];
	};

	/**
	 * Cleans up the references to all the deferred functions
	 * (before/after/beforeEach/afterEach) and tests of a Suite.
	 * These must be deleted otherwise a memory leak can happen,
	 * as those functions may reference variables from closures,
	 * thus those variables can never be garbage collected as long
	 * as the deferred functions exist.
	 *
	 * @private
	 */
	Suite.prototype.cleanReferences = function cleanReferences() {
	  function cleanArrReferences(arr) {
	    for (var i = 0; i < arr.length; i++) {
	      delete arr[i].fn;
	    }
	  }

	  if (Array.isArray(this._beforeAll)) {
	    cleanArrReferences(this._beforeAll);
	  }

	  if (Array.isArray(this._beforeEach)) {
	    cleanArrReferences(this._beforeEach);
	  }

	  if (Array.isArray(this._afterAll)) {
	    cleanArrReferences(this._afterAll);
	  }

	  if (Array.isArray(this._afterEach)) {
	    cleanArrReferences(this._afterEach);
	  }

	  for (var i = 0; i < this.tests.length; i++) {
	    delete this.tests[i].fn;
	  }
	};

	var constants = utils.defineConstants(
	  /**
	   * {@link Suite}-related constants.
	   * @public
	   * @memberof Suite
	   * @alias constants
	   * @readonly
	   * @static
	   * @enum {string}
	   */
	  {
	    /**
	     * Event emitted after a test file has been loaded Not emitted in browser.
	     */
	    EVENT_FILE_POST_REQUIRE: 'post-require',
	    /**
	     * Event emitted before a test file has been loaded. In browser, this is emitted once an interface has been selected.
	     */
	    EVENT_FILE_PRE_REQUIRE: 'pre-require',
	    /**
	     * Event emitted immediately after a test file has been loaded. Not emitted in browser.
	     */
	    EVENT_FILE_REQUIRE: 'require',
	    /**
	     * Event emitted when `global.run()` is called (use with `delay` option)
	     */
	    EVENT_ROOT_SUITE_RUN: 'run',

	    /**
	     * Namespace for collection of a `Suite`'s "after all" hooks
	     */
	    HOOK_TYPE_AFTER_ALL: 'afterAll',
	    /**
	     * Namespace for collection of a `Suite`'s "after each" hooks
	     */
	    HOOK_TYPE_AFTER_EACH: 'afterEach',
	    /**
	     * Namespace for collection of a `Suite`'s "before all" hooks
	     */
	    HOOK_TYPE_BEFORE_ALL: 'beforeAll',
	    /**
	     * Namespace for collection of a `Suite`'s "before all" hooks
	     */
	    HOOK_TYPE_BEFORE_EACH: 'beforeEach',

	    // the following events are all deprecated

	    /**
	     * Emitted after an "after all" `Hook` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_AFTER_ALL: 'afterAll',
	    /**
	     * Emitted after an "after each" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_AFTER_EACH: 'afterEach',
	    /**
	     * Emitted after an "before all" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_BEFORE_ALL: 'beforeAll',
	    /**
	     * Emitted after an "before each" `Hook` has been added to a `Suite` Deprecated
	     */
	    EVENT_SUITE_ADD_HOOK_BEFORE_EACH: 'beforeEach',
	    /**
	     * Emitted after a child `Suite` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_SUITE: 'suite',
	    /**
	     * Emitted after a `Test` has been added to a `Suite`. Deprecated
	     */
	    EVENT_SUITE_ADD_TEST: 'test'
	  }
	);

	/**
	 * @summary There are no known use cases for these events.
	 * @desc This is a `Set`-like object having all keys being the constant's string value and the value being `true`.
	 * @todo Remove eventually
	 * @type {Object<string,boolean>}
	 * @ignore
	 */
	var deprecatedEvents = Object.keys(constants)
	  .filter(function(constant) {
	    return constant.substring(0, 15) === 'EVENT_SUITE_ADD';
	  })
	  .reduce(function(acc, constant) {
	    acc[constants[constant]] = true;
	    return acc;
	  }, utils.createMap());

	Suite.constants = constants;
	});

	/**
	 * Module dependencies.
	 */

	var EventEmitter$1 = events.EventEmitter;


	var inherits$1 = utils.inherits;
	var debug$1 = debug$2('mocha:runner');


	var HOOK_TYPE_BEFORE_EACH = suite.constants.HOOK_TYPE_BEFORE_EACH;
	var HOOK_TYPE_AFTER_EACH = suite.constants.HOOK_TYPE_AFTER_EACH;
	var HOOK_TYPE_AFTER_ALL = suite.constants.HOOK_TYPE_AFTER_ALL;
	var HOOK_TYPE_BEFORE_ALL = suite.constants.HOOK_TYPE_BEFORE_ALL;
	var EVENT_ROOT_SUITE_RUN = suite.constants.EVENT_ROOT_SUITE_RUN;
	var STATE_FAILED = runnable.constants.STATE_FAILED;
	var STATE_PASSED = runnable.constants.STATE_PASSED;
	var dQuote = utils.dQuote;
	var ngettext = utils.ngettext;
	var sQuote = utils.sQuote;
	var stackFilter = utils.stackTraceFilter();
	var stringify = utils.stringify;
	var type = utils.type;

	var createInvalidExceptionError$2 = errors.createInvalidExceptionError;
	var createUnsupportedError$1 = errors.createUnsupportedError;

	/**
	 * Non-enumerable globals.
	 * @readonly
	 */
	var globals = [
	  'setTimeout',
	  'clearTimeout',
	  'setInterval',
	  'clearInterval',
	  'XMLHttpRequest',
	  'Date',
	  'setImmediate',
	  'clearImmediate'
	];

	var constants$1 = utils.defineConstants(
	  /**
	   * {@link Runner}-related constants.
	   * @public
	   * @memberof Runner
	   * @readonly
	   * @alias constants
	   * @static
	   * @enum {string}
	   */
	  {
	    /**
	     * Emitted when {@link Hook} execution begins
	     */
	    EVENT_HOOK_BEGIN: 'hook',
	    /**
	     * Emitted when {@link Hook} execution ends
	     */
	    EVENT_HOOK_END: 'hook end',
	    /**
	     * Emitted when Root {@link Suite} execution begins (all files have been parsed and hooks/tests are ready for execution)
	     */
	    EVENT_RUN_BEGIN: 'start',
	    /**
	     * Emitted when Root {@link Suite} execution has been delayed via `delay` option
	     */
	    EVENT_DELAY_BEGIN: 'waiting',
	    /**
	     * Emitted when delayed Root {@link Suite} execution is triggered by user via `global.run()`
	     */
	    EVENT_DELAY_END: 'ready',
	    /**
	     * Emitted when Root {@link Suite} execution ends
	     */
	    EVENT_RUN_END: 'end',
	    /**
	     * Emitted when {@link Suite} execution begins
	     */
	    EVENT_SUITE_BEGIN: 'suite',
	    /**
	     * Emitted when {@link Suite} execution ends
	     */
	    EVENT_SUITE_END: 'suite end',
	    /**
	     * Emitted when {@link Test} execution begins
	     */
	    EVENT_TEST_BEGIN: 'test',
	    /**
	     * Emitted when {@link Test} execution ends
	     */
	    EVENT_TEST_END: 'test end',
	    /**
	     * Emitted when {@link Test} execution fails
	     */
	    EVENT_TEST_FAIL: 'fail',
	    /**
	     * Emitted when {@link Test} execution succeeds
	     */
	    EVENT_TEST_PASS: 'pass',
	    /**
	     * Emitted when {@link Test} becomes pending
	     */
	    EVENT_TEST_PENDING: 'pending',
	    /**
	     * Emitted when {@link Test} execution has failed, but will retry
	     */
	    EVENT_TEST_RETRY: 'retry'
	  }
	);

	var runner = Runner;

	/**
	 * Initialize a `Runner` at the Root {@link Suite}, which represents a hierarchy of {@link Suite|Suites} and {@link Test|Tests}.
	 *
	 * @extends external:EventEmitter
	 * @public
	 * @class
	 * @param {Suite} suite Root suite
	 * @param {boolean} [delay] Whether or not to delay execution of root suite
	 * until ready.
	 */
	function Runner(suite, delay) {
	  var self = this;
	  this._globals = [];
	  this._abort = false;
	  this._delay = delay;
	  this.suite = suite;
	  this.started = false;
	  this.total = suite.total();
	  this.failures = 0;
	  this.on(constants$1.EVENT_TEST_END, function(test) {
	    self.checkGlobals(test);
	  });
	  this.on(constants$1.EVENT_HOOK_END, function(hook) {
	    self.checkGlobals(hook);
	  });
	  this._defaultGrep = /.*/;
	  this.grep(this._defaultGrep);
	  this.globals(this.globalProps());
	}

	/**
	 * Wrapper for setImmediate, process.nextTick, or browser polyfill.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runner.immediately = commonjsGlobal.setImmediate || process.nextTick;

	/**
	 * Inherit from `EventEmitter.prototype`.
	 */
	inherits$1(Runner, EventEmitter$1);

	/**
	 * Run tests with full titles matching `re`. Updates runner.total
	 * with number of tests matched.
	 *
	 * @public
	 * @memberof Runner
	 * @param {RegExp} re
	 * @param {boolean} invert
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.grep = function(re, invert) {
	  debug$1('grep %s', re);
	  this._grep = re;
	  this._invert = invert;
	  this.total = this.grepTotal(this.suite);
	  return this;
	};

	/**
	 * Returns the number of tests matching the grep search for the
	 * given suite.
	 *
	 * @memberof Runner
	 * @public
	 * @param {Suite} suite
	 * @return {number}
	 */
	Runner.prototype.grepTotal = function(suite) {
	  var self = this;
	  var total = 0;

	  suite.eachTest(function(test) {
	    var match = self._grep.test(test.fullTitle());
	    if (self._invert) {
	      match = !match;
	    }
	    if (match) {
	      total++;
	    }
	  });

	  return total;
	};

	/**
	 * Return a list of global properties.
	 *
	 * @return {Array}
	 * @private
	 */
	Runner.prototype.globalProps = function() {
	  var props = Object.keys(commonjsGlobal);

	  // non-enumerables
	  for (var i = 0; i < globals.length; ++i) {
	    if (~props.indexOf(globals[i])) {
	      continue;
	    }
	    props.push(globals[i]);
	  }

	  return props;
	};

	/**
	 * Allow the given `arr` of globals.
	 *
	 * @public
	 * @memberof Runner
	 * @param {Array} arr
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.globals = function(arr) {
	  if (!arguments.length) {
	    return this._globals;
	  }
	  debug$1('globals %j', arr);
	  this._globals = this._globals.concat(arr);
	  return this;
	};

	/**
	 * Check for global variable leaks.
	 *
	 * @private
	 */
	Runner.prototype.checkGlobals = function(test) {
	  if (!this.checkLeaks) {
	    return;
	  }
	  var ok = this._globals;

	  var globals = this.globalProps();
	  var leaks;

	  if (test) {
	    ok = ok.concat(test._allowedGlobals || []);
	  }

	  if (this.prevGlobalsLength === globals.length) {
	    return;
	  }
	  this.prevGlobalsLength = globals.length;

	  leaks = filterLeaks(ok, globals);
	  this._globals = this._globals.concat(leaks);

	  if (leaks.length) {
	    var format = ngettext(
	      leaks.length,
	      'global leak detected: %s',
	      'global leaks detected: %s'
	    );
	    var error = new Error(util.format(format, leaks.map(sQuote).join(', ')));
	    this.fail(test, error);
	  }
	};

	/**
	 * Fail the given `test`.
	 *
	 * @private
	 * @param {Test} test
	 * @param {Error} err
	 */
	Runner.prototype.fail = function(test, err) {
	  if (test.isPending()) {
	    return;
	  }

	  ++this.failures;
	  test.state = STATE_FAILED;

	  if (!isError(err)) {
	    err = thrown2Error(err);
	  }

	  try {
	    err.stack =
	      this.fullStackTrace || !err.stack ? err.stack : stackFilter(err.stack);
	  } catch (ignore) {
	    // some environments do not take kindly to monkeying with the stack
	  }

	  this.emit(constants$1.EVENT_TEST_FAIL, test, err);
	};

	/**
	 * Fail the given `hook` with `err`.
	 *
	 * Hook failures work in the following pattern:
	 * - If bail, run corresponding `after each` and `after` hooks,
	 *   then exit
	 * - Failed `before` hook skips all tests in a suite and subsuites,
	 *   but jumps to corresponding `after` hook
	 * - Failed `before each` hook skips remaining tests in a
	 *   suite and jumps to corresponding `after each` hook,
	 *   which is run only once
	 * - Failed `after` hook does not alter execution order
	 * - Failed `after each` hook skips remaining tests in a
	 *   suite and subsuites, but executes other `after each`
	 *   hooks
	 *
	 * @private
	 * @param {Hook} hook
	 * @param {Error} err
	 */
	Runner.prototype.failHook = function(hook, err) {
	  hook.originalTitle = hook.originalTitle || hook.title;
	  if (hook.ctx && hook.ctx.currentTest) {
	    hook.title =
	      hook.originalTitle + ' for ' + dQuote(hook.ctx.currentTest.title);
	  } else {
	    var parentTitle;
	    if (hook.parent.title) {
	      parentTitle = hook.parent.title;
	    } else {
	      parentTitle = hook.parent.root ? '{root}' : '';
	    }
	    hook.title = hook.originalTitle + ' in ' + dQuote(parentTitle);
	  }

	  this.fail(hook, err);
	};

	/**
	 * Run hook `name` callbacks and then invoke `fn()`.
	 *
	 * @private
	 * @param {string} name
	 * @param {Function} fn
	 */

	Runner.prototype.hook = function(name, fn) {
	  var suite = this.suite;
	  var hooks = suite.getHooks(name);
	  var self = this;

	  function next(i) {
	    var hook = hooks[i];
	    if (!hook) {
	      return fn();
	    }
	    self.currentRunnable = hook;

	    if (name === HOOK_TYPE_BEFORE_ALL) {
	      hook.ctx.currentTest = hook.parent.tests[0];
	    } else if (name === HOOK_TYPE_AFTER_ALL) {
	      hook.ctx.currentTest = hook.parent.tests[hook.parent.tests.length - 1];
	    } else {
	      hook.ctx.currentTest = self.test;
	    }

	    hook.allowUncaught = self.allowUncaught;

	    self.emit(constants$1.EVENT_HOOK_BEGIN, hook);

	    if (!hook.listeners('error').length) {
	      hook.on('error', function(err) {
	        self.failHook(hook, err);
	      });
	    }

	    hook.run(function(err) {
	      var testError = hook.error();
	      if (testError) {
	        self.fail(self.test, testError);
	      }
	      // conditional skip
	      if (hook.pending) {
	        if (name === HOOK_TYPE_AFTER_EACH) {
	          // TODO define and implement use case
	          if (self.test) {
	            self.test.pending = true;
	          }
	        } else if (name === HOOK_TYPE_BEFORE_EACH) {
	          if (self.test) {
	            self.test.pending = true;
	          }
	          self.emit(constants$1.EVENT_HOOK_END, hook);
	          hook.pending = false; // activates hook for next test
	          return fn(new Error('abort hookDown'));
	        } else if (name === HOOK_TYPE_BEFORE_ALL) {
	          suite.tests.forEach(function(test) {
	            test.pending = true;
	          });
	          suite.suites.forEach(function(suite) {
	            suite.pending = true;
	          });
	        } else {
	          hook.pending = false;
	          var errForbid = createUnsupportedError$1('`this.skip` forbidden');
	          self.failHook(hook, errForbid);
	          return fn(errForbid);
	        }
	      } else if (err) {
	        self.failHook(hook, err);
	        // stop executing hooks, notify callee of hook err
	        return fn(err);
	      }
	      self.emit(constants$1.EVENT_HOOK_END, hook);
	      delete hook.ctx.currentTest;
	      next(++i);
	    });
	  }

	  Runner.immediately(function() {
	    next(0);
	  });
	};

	/**
	 * Run hook `name` for the given array of `suites`
	 * in order, and callback `fn(err, errSuite)`.
	 *
	 * @private
	 * @param {string} name
	 * @param {Array} suites
	 * @param {Function} fn
	 */
	Runner.prototype.hooks = function(name, suites, fn) {
	  var self = this;
	  var orig = this.suite;

	  function next(suite) {
	    self.suite = suite;

	    if (!suite) {
	      self.suite = orig;
	      return fn();
	    }

	    self.hook(name, function(err) {
	      if (err) {
	        var errSuite = self.suite;
	        self.suite = orig;
	        return fn(err, errSuite);
	      }

	      next(suites.pop());
	    });
	  }

	  next(suites.pop());
	};

	/**
	 * Run hooks from the top level down.
	 *
	 * @param {String} name
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.hookUp = function(name, fn) {
	  var suites = [this.suite].concat(this.parents()).reverse();
	  this.hooks(name, suites, fn);
	};

	/**
	 * Run hooks from the bottom up.
	 *
	 * @param {String} name
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.hookDown = function(name, fn) {
	  var suites = [this.suite].concat(this.parents());
	  this.hooks(name, suites, fn);
	};

	/**
	 * Return an array of parent Suites from
	 * closest to furthest.
	 *
	 * @return {Array}
	 * @private
	 */
	Runner.prototype.parents = function() {
	  var suite = this.suite;
	  var suites = [];
	  while (suite.parent) {
	    suite = suite.parent;
	    suites.push(suite);
	  }
	  return suites;
	};

	/**
	 * Run the current test and callback `fn(err)`.
	 *
	 * @param {Function} fn
	 * @private
	 */
	Runner.prototype.runTest = function(fn) {
	  var self = this;
	  var test = this.test;

	  if (!test) {
	    return;
	  }

	  var suite = this.parents().reverse()[0] || this.suite;
	  if (this.forbidOnly && suite.hasOnly()) {
	    fn(new Error('`.only` forbidden'));
	    return;
	  }
	  if (this.asyncOnly) {
	    test.asyncOnly = true;
	  }
	  test.on('error', function(err) {
	    if (err instanceof pending) {
	      return;
	    }
	    self.fail(test, err);
	  });
	  if (this.allowUncaught) {
	    test.allowUncaught = true;
	    return test.run(fn);
	  }
	  try {
	    test.run(fn);
	  } catch (err) {
	    fn(err);
	  }
	};

	/**
	 * Run tests in the given `suite` and invoke the callback `fn()` when complete.
	 *
	 * @private
	 * @param {Suite} suite
	 * @param {Function} fn
	 */
	Runner.prototype.runTests = function(suite, fn) {
	  var self = this;
	  var tests = suite.tests.slice();
	  var test;

	  function hookErr(_, errSuite, after) {
	    // before/after Each hook for errSuite failed:
	    var orig = self.suite;

	    // for failed 'after each' hook start from errSuite parent,
	    // otherwise start from errSuite itself
	    self.suite = after ? errSuite.parent : errSuite;

	    if (self.suite) {
	      // call hookUp afterEach
	      self.hookUp(HOOK_TYPE_AFTER_EACH, function(err2, errSuite2) {
	        self.suite = orig;
	        // some hooks may fail even now
	        if (err2) {
	          return hookErr(err2, errSuite2, true);
	        }
	        // report error suite
	        fn(errSuite);
	      });
	    } else {
	      // there is no need calling other 'after each' hooks
	      self.suite = orig;
	      fn(errSuite);
	    }
	  }

	  function next(err, errSuite) {
	    // if we bail after first err
	    if (self.failures && suite._bail) {
	      tests = [];
	    }

	    if (self._abort) {
	      return fn();
	    }

	    if (err) {
	      return hookErr(err, errSuite, true);
	    }

	    // next test
	    test = tests.shift();

	    // all done
	    if (!test) {
	      return fn();
	    }

	    // grep
	    var match = self._grep.test(test.fullTitle());
	    if (self._invert) {
	      match = !match;
	    }
	    if (!match) {
	      // Run immediately only if we have defined a grep. When we
	      // define a grep — It can cause maximum callstack error if
	      // the grep is doing a large recursive loop by neglecting
	      // all tests. The run immediately function also comes with
	      // a performance cost. So we don't want to run immediately
	      // if we run the whole test suite, because running the whole
	      // test suite don't do any immediate recursive loops. Thus,
	      // allowing a JS runtime to breathe.
	      if (self._grep !== self._defaultGrep) {
	        Runner.immediately(next);
	      } else {
	        next();
	      }
	      return;
	    }

	    // static skip, no hooks are executed
	    if (test.isPending()) {
	      if (self.forbidPending) {
	        test.isPending = alwaysFalse;
	        self.fail(test, new Error('Pending test forbidden'));
	        delete test.isPending;
	      } else {
	        self.emit(constants$1.EVENT_TEST_PENDING, test);
	      }
	      self.emit(constants$1.EVENT_TEST_END, test);
	      return next();
	    }

	    // execute test and hook(s)
	    self.emit(constants$1.EVENT_TEST_BEGIN, (self.test = test));
	    self.hookDown(HOOK_TYPE_BEFORE_EACH, function(err, errSuite) {
	      // conditional skip within beforeEach
	      if (test.isPending()) {
	        if (self.forbidPending) {
	          test.isPending = alwaysFalse;
	          self.fail(test, new Error('Pending test forbidden'));
	          delete test.isPending;
	        } else {
	          self.emit(constants$1.EVENT_TEST_PENDING, test);
	        }
	        self.emit(constants$1.EVENT_TEST_END, test);
	        // skip inner afterEach hooks below errSuite level
	        var origSuite = self.suite;
	        self.suite = errSuite || self.suite;
	        return self.hookUp(HOOK_TYPE_AFTER_EACH, function(e, eSuite) {
	          self.suite = origSuite;
	          next(e, eSuite);
	        });
	      }
	      if (err) {
	        return hookErr(err, errSuite, false);
	      }
	      self.currentRunnable = self.test;
	      self.runTest(function(err) {
	        test = self.test;
	        // conditional skip within it
	        if (test.pending) {
	          if (self.forbidPending) {
	            test.isPending = alwaysFalse;
	            self.fail(test, new Error('Pending test forbidden'));
	            delete test.isPending;
	          } else {
	            self.emit(constants$1.EVENT_TEST_PENDING, test);
	          }
	          self.emit(constants$1.EVENT_TEST_END, test);
	          return self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	        } else if (err) {
	          var retry = test.currentRetry();
	          if (retry < test.retries()) {
	            var clonedTest = test.clone();
	            clonedTest.currentRetry(retry + 1);
	            tests.unshift(clonedTest);

	            self.emit(constants$1.EVENT_TEST_RETRY, test, err);

	            // Early return + hook trigger so that it doesn't
	            // increment the count wrong
	            return self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	          } else {
	            self.fail(test, err);
	          }
	          self.emit(constants$1.EVENT_TEST_END, test);
	          return self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	        }

	        test.state = STATE_PASSED;
	        self.emit(constants$1.EVENT_TEST_PASS, test);
	        self.emit(constants$1.EVENT_TEST_END, test);
	        self.hookUp(HOOK_TYPE_AFTER_EACH, next);
	      });
	    });
	  }

	  this.next = next;
	  this.hookErr = hookErr;
	  next();
	};

	function alwaysFalse() {
	  return false;
	}

	/**
	 * Run the given `suite` and invoke the callback `fn()` when complete.
	 *
	 * @private
	 * @param {Suite} suite
	 * @param {Function} fn
	 */
	Runner.prototype.runSuite = function(suite, fn) {
	  var i = 0;
	  var self = this;
	  var total = this.grepTotal(suite);

	  debug$1('run suite %s', suite.fullTitle());

	  if (!total || (self.failures && suite._bail)) {
	    return fn();
	  }

	  this.emit(constants$1.EVENT_SUITE_BEGIN, (this.suite = suite));

	  function next(errSuite) {
	    if (errSuite) {
	      // current suite failed on a hook from errSuite
	      if (errSuite === suite) {
	        // if errSuite is current suite
	        // continue to the next sibling suite
	        return done();
	      }
	      // errSuite is among the parents of current suite
	      // stop execution of errSuite and all sub-suites
	      return done(errSuite);
	    }

	    if (self._abort) {
	      return done();
	    }

	    var curr = suite.suites[i++];
	    if (!curr) {
	      return done();
	    }

	    // Avoid grep neglecting large number of tests causing a
	    // huge recursive loop and thus a maximum call stack error.
	    // See comment in `this.runTests()` for more information.
	    if (self._grep !== self._defaultGrep) {
	      Runner.immediately(function() {
	        self.runSuite(curr, next);
	      });
	    } else {
	      self.runSuite(curr, next);
	    }
	  }

	  function done(errSuite) {
	    self.suite = suite;
	    self.nextSuite = next;

	    // remove reference to test
	    delete self.test;

	    self.hook(HOOK_TYPE_AFTER_ALL, function() {
	      self.emit(constants$1.EVENT_SUITE_END, suite);
	      fn(errSuite);
	    });
	  }

	  this.nextSuite = next;

	  this.hook(HOOK_TYPE_BEFORE_ALL, function(err) {
	    if (err) {
	      return done();
	    }
	    self.runTests(suite, next);
	  });
	};

	/**
	 * Handle uncaught exceptions within runner.
	 *
	 * @param {Error} err
	 * @private
	 */
	Runner.prototype.uncaught = function(err) {
	  if (err instanceof pending) {
	    return;
	  }
	  if (this.allowUncaught) {
	    throw err;
	  }

	  if (err) {
	    debug$1('uncaught exception %O', err);
	  } else {
	    debug$1('uncaught undefined/falsy exception');
	    err = createInvalidExceptionError$2(
	      'Caught falsy/undefined exception which would otherwise be uncaught. No stack trace found; try a debugger',
	      err
	    );
	  }

	  if (!isError(err)) {
	    err = thrown2Error(err);
	  }
	  err.uncaught = true;

	  var runnable$1 = this.currentRunnable;

	  if (!runnable$1) {
	    runnable$1 = new runnable('Uncaught error outside test suite');
	    runnable$1.parent = this.suite;

	    if (this.started) {
	      this.fail(runnable$1, err);
	    } else {
	      // Can't recover from this failure
	      this.emit(constants$1.EVENT_RUN_BEGIN);
	      this.fail(runnable$1, err);
	      this.emit(constants$1.EVENT_RUN_END);
	    }

	    return;
	  }

	  runnable$1.clearTimeout();

	  if (runnable$1.isFailed()) {
	    // Ignore error if already failed
	    return;
	  } else if (runnable$1.isPending()) {
	    // report 'pending test' retrospectively as failed
	    runnable$1.isPending = alwaysFalse;
	    this.fail(runnable$1, err);
	    delete runnable$1.isPending;
	    return;
	  }

	  // we cannot recover gracefully if a Runnable has already passed
	  // then fails asynchronously
	  if (runnable$1.isPassed()) {
	    this.fail(runnable$1, err);
	    this.abort();
	  } else {
	    debug$1(runnable$1);
	    return runnable$1.callback(err);
	  }
	};

	/**
	 * Handle uncaught exceptions after runner's end event.
	 *
	 * @param {Error} err
	 * @private
	 */
	Runner.prototype.uncaughtEnd = function uncaughtEnd(err) {
	  if (err instanceof pending) { return; }
	  throw err;
	};

	/**
	 * Run the root suite and invoke `fn(failures)`
	 * on completion.
	 *
	 * @public
	 * @memberof Runner
	 * @param {Function} fn
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.run = function(fn) {
	  var self = this;
	  var rootSuite = this.suite;

	  fn = fn || function() {};

	  function uncaught(err) {
	    self.uncaught(err);
	  }

	  function start() {
	    // If there is an `only` filter
	    if (rootSuite.hasOnly()) {
	      rootSuite.filterOnly();
	    }
	    self.started = true;
	    if (self._delay) {
	      self.emit(constants$1.EVENT_DELAY_END);
	    }
	    self.emit(constants$1.EVENT_RUN_BEGIN);

	    self.runSuite(rootSuite, function() {
	      debug$1('finished running');
	      self.emit(constants$1.EVENT_RUN_END);
	    });
	  }

	  debug$1(constants$1.EVENT_RUN_BEGIN);

	  // references cleanup to avoid memory leaks
	  this.on(constants$1.EVENT_SUITE_END, function(suite) {
	    suite.cleanReferences();
	  });

	  // callback
	  this.on(constants$1.EVENT_RUN_END, function() {
	    debug$1(constants$1.EVENT_RUN_END);
	    process.removeListener('uncaughtException', uncaught);
	    process.on('uncaughtException', self.uncaughtEnd);
	    fn(self.failures);
	  });

	  // uncaught exception
	  process.removeListener('uncaughtException', self.uncaughtEnd);
	  process.on('uncaughtException', uncaught);

	  if (this._delay) {
	    // for reporters, I guess.
	    // might be nice to debounce some dots while we wait.
	    this.emit(constants$1.EVENT_DELAY_BEGIN, rootSuite);
	    rootSuite.once(EVENT_ROOT_SUITE_RUN, start);
	  } else {
	    start();
	  }

	  return this;
	};

	/**
	 * Cleanly abort execution.
	 *
	 * @memberof Runner
	 * @public
	 * @return {Runner} Runner instance.
	 */
	Runner.prototype.abort = function() {
	  debug$1('aborting');
	  this._abort = true;

	  return this;
	};

	/**
	 * Filter leaks with the given globals flagged as `ok`.
	 *
	 * @private
	 * @param {Array} ok
	 * @param {Array} globals
	 * @return {Array}
	 */
	function filterLeaks(ok, globals) {
	  return globals.filter(function(key) {
	    // Firefox and Chrome exposes iframes as index inside the window object
	    if (/^\d+/.test(key)) {
	      return false;
	    }

	    // in firefox
	    // if runner runs in an iframe, this iframe's window.getInterface method
	    // not init at first it is assigned in some seconds
	    if (commonjsGlobal.navigator && /^getInterface/.test(key)) {
	      return false;
	    }

	    // an iframe could be approached by window[iframeIndex]
	    // in ie6,7,8 and opera, iframeIndex is enumerable, this could cause leak
	    if (commonjsGlobal.navigator && /^\d+/.test(key)) {
	      return false;
	    }

	    // Opera and IE expose global variables for HTML element IDs (issue #243)
	    if (/^mocha-/.test(key)) {
	      return false;
	    }

	    var matched = ok.filter(function(ok) {
	      if (~ok.indexOf('*')) {
	        return key.indexOf(ok.split('*')[0]) === 0;
	      }
	      return key === ok;
	    });
	    return !matched.length && (!commonjsGlobal.navigator || key !== 'onerror');
	  });
	}

	/**
	 * Check if argument is an instance of Error object or a duck-typed equivalent.
	 *
	 * @private
	 * @param {Object} err - object to check
	 * @param {string} err.message - error message
	 * @returns {boolean}
	 */
	function isError(err) {
	  return err instanceof Error || (err && typeof err.message === 'string');
	}

	/**
	 *
	 * Converts thrown non-extensible type into proper Error.
	 *
	 * @private
	 * @param {*} thrown - Non-extensible type thrown by code
	 * @return {Error}
	 */
	function thrown2Error(err) {
	  return new Error(
	    'the ' + type(err) + ' ' + stringify(err) + ' was thrown, throw an Error :)'
	  );
	}

	Runner.constants = constants$1;

	var base = createCommonjsModule(function (module, exports) {
	/**
	 * @module Base
	 */
	/**
	 * Module dependencies.
	 */





	var supportsColor = process.browser ? null : path;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;

	/**
	 * Expose `Base`.
	 */

	exports = module.exports = Base;

	/**
	 * Check if both stdio streams are associated with a tty.
	 */

	var isatty = process.stdout.isTTY && process.stderr.isTTY;

	/**
	 * Save log references to avoid tests interfering (see GH-3604).
	 */
	var consoleLog = console.log;

	/**
	 * Enable coloring by default, except in the browser interface.
	 */

	exports.useColors =
	  !process.browser &&
	  (supportsColor.stdout || process.env.MOCHA_COLORS !== undefined);

	/**
	 * Inline diffs instead of +/-
	 */

	exports.inlineDiffs = false;

	/**
	 * Default color map.
	 */

	exports.colors = {
	  pass: 90,
	  fail: 31,
	  'bright pass': 92,
	  'bright fail': 91,
	  'bright yellow': 93,
	  pending: 36,
	  suite: 0,
	  'error title': 0,
	  'error message': 31,
	  'error stack': 90,
	  checkmark: 32,
	  fast: 90,
	  medium: 33,
	  slow: 31,
	  green: 32,
	  light: 90,
	  'diff gutter': 90,
	  'diff added': 32,
	  'diff removed': 31
	};

	/**
	 * Default symbol map.
	 */

	exports.symbols = {
	  ok: '✓',
	  err: '✖',
	  dot: '․',
	  comma: ',',
	  bang: '!'
	};

	// With node.js on Windows: use symbols available in terminal default fonts
	if (process.platform === 'win32') {
	  exports.symbols.ok = '\u221A';
	  exports.symbols.err = '\u00D7';
	  exports.symbols.dot = '.';
	}

	/**
	 * Color `str` with the given `type`,
	 * allowing colors to be disabled,
	 * as well as user-defined color
	 * schemes.
	 *
	 * @private
	 * @param {string} type
	 * @param {string} str
	 * @return {string}
	 */
	var color = (exports.color = function(type, str) {
	  if (!exports.useColors) {
	    return String(str);
	  }
	  return '\u001b[' + exports.colors[type] + 'm' + str + '\u001b[0m';
	});

	/**
	 * Expose term window size, with some defaults for when stderr is not a tty.
	 */

	exports.window = {
	  width: 75
	};

	if (isatty) {
	  exports.window.width = process.stdout.getWindowSize
	    ? process.stdout.getWindowSize(1)[0]
	    : tty.getWindowSize()[1];
	}

	/**
	 * Expose some basic cursor interactions that are common among reporters.
	 */

	exports.cursor = {
	  hide: function() {
	    isatty && process.stdout.write('\u001b[?25l');
	  },

	  show: function() {
	    isatty && process.stdout.write('\u001b[?25h');
	  },

	  deleteLine: function() {
	    isatty && process.stdout.write('\u001b[2K');
	  },

	  beginningOfLine: function() {
	    isatty && process.stdout.write('\u001b[0G');
	  },

	  CR: function() {
	    if (isatty) {
	      exports.cursor.deleteLine();
	      exports.cursor.beginningOfLine();
	    } else {
	      process.stdout.write('\r');
	    }
	  }
	};

	var showDiff = (exports.showDiff = function(err) {
	  return (
	    err &&
	    err.showDiff !== false &&
	    sameType(err.actual, err.expected) &&
	    err.expected !== undefined
	  );
	});

	function stringifyDiffObjs(err) {
	  if (!utils.isString(err.actual) || !utils.isString(err.expected)) {
	    err.actual = utils.stringify(err.actual);
	    err.expected = utils.stringify(err.expected);
	  }
	}

	/**
	 * Returns a diff between 2 strings with coloured ANSI output.
	 *
	 * @description
	 * The diff will be either inline or unified dependent on the value
	 * of `Base.inlineDiff`.
	 *
	 * @param {string} actual
	 * @param {string} expected
	 * @return {string} Diff
	 */
	var generateDiff = (exports.generateDiff = function(actual, expected) {
	  try {
	    return exports.inlineDiffs
	      ? inlineDiff(actual, expected)
	      : unifiedDiff(actual, expected);
	  } catch (err) {
	    var msg =
	      '\n      ' +
	      color('diff added', '+ expected') +
	      ' ' +
	      color('diff removed', '- actual:  failed to generate Mocha diff') +
	      '\n';
	    return msg;
	  }
	});

	/**
	 * Outputs the given `failures` as a list.
	 *
	 * @public
	 * @memberof Mocha.reporters.Base
	 * @variation 1
	 * @param {Object[]} failures - Each is Test instance with corresponding
	 *     Error property
	 */
	exports.list = function(failures) {
	  var multipleErr, multipleTest;
	  Base.consoleLog();
	  failures.forEach(function(test, i) {
	    // format
	    var fmt =
	      color('error title', '  %s) %s:\n') +
	      color('error message', '     %s') +
	      color('error stack', '\n%s\n');

	    // msg
	    var msg;
	    var err;
	    if (test.err && test.err.multiple) {
	      if (multipleTest !== test) {
	        multipleTest = test;
	        multipleErr = [test.err].concat(test.err.multiple);
	      }
	      err = multipleErr.shift();
	    } else {
	      err = test.err;
	    }
	    var message;
	    if (err.message && typeof err.message.toString === 'function') {
	      message = err.message + '';
	    } else if (typeof err.inspect === 'function') {
	      message = err.inspect() + '';
	    } else {
	      message = '';
	    }
	    var stack = err.stack || message;
	    var index = message ? stack.indexOf(message) : -1;

	    if (index === -1) {
	      msg = message;
	    } else {
	      index += message.length;
	      msg = stack.slice(0, index);
	      // remove msg from stack
	      stack = stack.slice(index + 1);
	    }

	    // uncaught
	    if (err.uncaught) {
	      msg = 'Uncaught ' + msg;
	    }
	    // explicitly show diff
	    if (!exports.hideDiff && showDiff(err)) {
	      stringifyDiffObjs(err);
	      fmt =
	        color('error title', '  %s) %s:\n%s') + color('error stack', '\n%s\n');
	      var match = message.match(/^([^:]+): expected/);
	      msg = '\n      ' + color('error message', match ? match[1] : msg);

	      msg += generateDiff(err.actual, err.expected);
	    }

	    // indent stack trace
	    stack = stack.replace(/^/gm, '  ');

	    // indented test title
	    var testTitle = '';
	    test.titlePath().forEach(function(str, index) {
	      if (index !== 0) {
	        testTitle += '\n     ';
	      }
	      for (var i = 0; i < index; i++) {
	        testTitle += '  ';
	      }
	      testTitle += str;
	    });

	    Base.consoleLog(fmt, i + 1, testTitle, msg, stack);
	  });
	};

	/**
	 * Constructs a new `Base` reporter instance.
	 *
	 * @description
	 * All other reporters generally inherit from this reporter.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Base(runner, options) {
	  var failures = (this.failures = []);

	  if (!runner) {
	    throw new TypeError('Missing runner argument');
	  }
	  this.options = options || {};
	  this.runner = runner;
	  this.stats = runner.stats; // assigned so Reporters keep a closer reference

	  runner.on(EVENT_TEST_PASS, function(test) {
	    if (test.duration > test.slow()) {
	      test.speed = 'slow';
	    } else if (test.duration > test.slow() / 2) {
	      test.speed = 'medium';
	    } else {
	      test.speed = 'fast';
	    }
	  });

	  runner.on(EVENT_TEST_FAIL, function(test, err) {
	    if (showDiff(err)) {
	      stringifyDiffObjs(err);
	    }
	    // more than one error per test
	    if (test.err && err instanceof Error) {
	      test.err.multiple = (test.err.multiple || []).concat(err);
	    } else {
	      test.err = err;
	    }
	    failures.push(test);
	  });
	}

	/**
	 * Outputs common epilogue used by many of the bundled reporters.
	 *
	 * @public
	 * @memberof Mocha.reporters
	 */
	Base.prototype.epilogue = function() {
	  var stats = this.stats;
	  var fmt;

	  Base.consoleLog();

	  // passes
	  fmt =
	    color('bright pass', ' ') +
	    color('green', ' %d passing') +
	    color('light', ' (%s)');

	  Base.consoleLog(fmt, stats.passes || 0, ms(stats.duration));

	  // pending
	  if (stats.pending) {
	    fmt = color('pending', ' ') + color('pending', ' %d pending');

	    Base.consoleLog(fmt, stats.pending);
	  }

	  // failures
	  if (stats.failures) {
	    fmt = color('fail', '  %d failing');

	    Base.consoleLog(fmt, stats.failures);

	    Base.list(this.failures);
	    Base.consoleLog();
	  }

	  Base.consoleLog();
	};

	/**
	 * Pads the given `str` to `len`.
	 *
	 * @private
	 * @param {string} str
	 * @param {string} len
	 * @return {string}
	 */
	function pad(str, len) {
	  str = String(str);
	  return Array(len - str.length + 1).join(' ') + str;
	}

	/**
	 * Returns inline diff between 2 strings with coloured ANSI output.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} Diff
	 */
	function inlineDiff(actual, expected) {
	  var msg = errorDiff(actual, expected);

	  // linenos
	  var lines = msg.split('\n');
	  if (lines.length > 4) {
	    var width = String(lines.length).length;
	    msg = lines
	      .map(function(str, i) {
	        return pad(++i, width) + ' |' + ' ' + str;
	      })
	      .join('\n');
	  }

	  // legend
	  msg =
	    '\n' +
	    color('diff removed', 'actual') +
	    ' ' +
	    color('diff added', 'expected') +
	    '\n\n' +
	    msg +
	    '\n';

	  // indent
	  msg = msg.replace(/^/gm, '      ');
	  return msg;
	}

	/**
	 * Returns unified diff between two strings with coloured ANSI output.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} The diff.
	 */
	function unifiedDiff(actual, expected) {
	  var indent = '      ';
	  function cleanUp(line) {
	    if (line[0] === '+') {
	      return indent + colorLines('diff added', line);
	    }
	    if (line[0] === '-') {
	      return indent + colorLines('diff removed', line);
	    }
	    if (line.match(/@@/)) {
	      return '--';
	    }
	    if (line.match(/\\ No newline/)) {
	      return null;
	    }
	    return indent + line;
	  }
	  function notBlank(line) {
	    return typeof line !== 'undefined' && line !== null;
	  }
	  var msg = diff$1.createPatch('string', actual, expected);
	  var lines = msg.split('\n').splice(5);
	  return (
	    '\n      ' +
	    colorLines('diff added', '+ expected') +
	    ' ' +
	    colorLines('diff removed', '- actual') +
	    '\n\n' +
	    lines
	      .map(cleanUp)
	      .filter(notBlank)
	      .join('\n')
	  );
	}

	/**
	 * Returns character diff for `err`.
	 *
	 * @private
	 * @param {String} actual
	 * @param {String} expected
	 * @return {string} the diff
	 */
	function errorDiff(actual, expected) {
	  return diff$1
	    .diffWordsWithSpace(actual, expected)
	    .map(function(str) {
	      if (str.added) {
	        return colorLines('diff added', str.value);
	      }
	      if (str.removed) {
	        return colorLines('diff removed', str.value);
	      }
	      return str.value;
	    })
	    .join('');
	}

	/**
	 * Colors lines for `str`, using the color `name`.
	 *
	 * @private
	 * @param {string} name
	 * @param {string} str
	 * @return {string}
	 */
	function colorLines(name, str) {
	  return str
	    .split('\n')
	    .map(function(str) {
	      return color(name, str);
	    })
	    .join('\n');
	}

	/**
	 * Object#toString reference.
	 */
	var objToString = Object.prototype.toString;

	/**
	 * Checks that a / b have the same type.
	 *
	 * @private
	 * @param {Object} a
	 * @param {Object} b
	 * @return {boolean}
	 */
	function sameType(a, b) {
	  return objToString.call(a) === objToString.call(b);
	}

	Base.consoleLog = consoleLog;

	Base.abstract = true;
	});
	var base_1 = base.useColors;
	var base_2 = base.inlineDiffs;
	var base_3 = base.colors;
	var base_4 = base.symbols;
	var base_5 = base.color;
	var base_6 = base.window;
	var base_7 = base.cursor;
	var base_8 = base.showDiff;
	var base_9 = base.generateDiff;
	var base_10 = base.list;

	var dot = createCommonjsModule(function (module, exports) {
	/**
	 * @module Dot
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_RUN_END = constants.EVENT_RUN_END;

	/**
	 * Expose `Dot`.
	 */

	exports = module.exports = Dot;

	/**
	 * Constructs a new `Dot` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Dot(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var n = -1;

	  runner.on(EVENT_RUN_BEGIN, function() {
	    process.stdout.write('\n');
	  });

	  runner.on(EVENT_TEST_PENDING, function() {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    process.stdout.write(base.color('pending', base.symbols.comma));
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    if (test.speed === 'slow') {
	      process.stdout.write(base.color('bright yellow', base.symbols.dot));
	    } else {
	      process.stdout.write(base.color(test.speed, base.symbols.dot));
	    }
	  });

	  runner.on(EVENT_TEST_FAIL, function() {
	    if (++n % width === 0) {
	      process.stdout.write('\n  ');
	    }
	    process.stdout.write(base.color('fail', base.symbols.bang));
	  });

	  runner.once(EVENT_RUN_END, function() {
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Dot, base);

	Dot.description = 'dot matrix representation';
	});

	var doc = createCommonjsModule(function (module, exports) {
	/**
	 * @module Doc
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;

	/**
	 * Expose `Doc`.
	 */

	exports = module.exports = Doc;

	/**
	 * Constructs a new `Doc` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Doc(runner, options) {
	  base.call(this, runner, options);

	  var indents = 2;

	  function indent() {
	    return Array(indents).join('  ');
	  }

	  runner.on(EVENT_SUITE_BEGIN, function(suite) {
	    if (suite.root) {
	      return;
	    }
	    ++indents;
	    base.consoleLog('%s<section class="suite">', indent());
	    ++indents;
	    base.consoleLog('%s<h1>%s</h1>', indent(), utils.escape(suite.title));
	    base.consoleLog('%s<dl>', indent());
	  });

	  runner.on(EVENT_SUITE_END, function(suite) {
	    if (suite.root) {
	      return;
	    }
	    base.consoleLog('%s</dl>', indent());
	    --indents;
	    base.consoleLog('%s</section>', indent());
	    --indents;
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    base.consoleLog('%s  <dt>%s</dt>', indent(), utils.escape(test.title));
	    var code = utils.escape(utils.clean(test.body));
	    base.consoleLog('%s  <dd><pre><code>%s</code></pre></dd>', indent(), code);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test, err) {
	    base.consoleLog(
	      '%s  <dt class="error">%s</dt>',
	      indent(),
	      utils.escape(test.title)
	    );
	    var code = utils.escape(utils.clean(test.body));
	    base.consoleLog(
	      '%s  <dd class="error"><pre><code>%s</code></pre></dd>',
	      indent(),
	      code
	    );
	    base.consoleLog(
	      '%s  <dd class="error">%s</dd>',
	      indent(),
	      utils.escape(err)
	    );
	  });
	}

	Doc.description = 'HTML documentation';
	});

	var tap = createCommonjsModule(function (module, exports) {
	/**
	 * @module TAP
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var inherits = utils.inherits;
	var sprintf = util.format;

	/**
	 * Expose `TAP`.
	 */

	exports = module.exports = TAP;

	/**
	 * Constructs a new `TAP` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function TAP(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var n = 1;

	  var tapVersion = '12';
	  if (options && options.reporterOptions) {
	    if (options.reporterOptions.tapVersion) {
	      tapVersion = options.reporterOptions.tapVersion.toString();
	    }
	  }

	  this._producer = createProducer(tapVersion);

	  runner.once(EVENT_RUN_BEGIN, function() {
	    var ntests = runner.grepTotal(runner.suite);
	    self._producer.writeVersion();
	    self._producer.writePlan(ntests);
	  });

	  runner.on(EVENT_TEST_END, function() {
	    ++n;
	  });

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    self._producer.writePending(n, test);
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    self._producer.writePass(n, test);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test, err) {
	    self._producer.writeFail(n, test, err);
	  });

	  runner.once(EVENT_RUN_END, function() {
	    self._producer.writeEpilogue(runner.stats);
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(TAP, base);

	/**
	 * Returns a TAP-safe title of `test`.
	 *
	 * @private
	 * @param {Test} test - Test instance.
	 * @return {String} title with any hash character removed
	 */
	function title(test) {
	  return test.fullTitle().replace(/#/g, '');
	}

	/**
	 * Writes newline-terminated formatted string to reporter output stream.
	 *
	 * @private
	 * @param {string} format - `printf`-like format string
	 * @param {...*} [varArgs] - Format string arguments
	 */
	function println(format, varArgs) {
	  var vargs = Array.from(arguments);
	  vargs[0] += '\n';
	  process.stdout.write(sprintf.apply(null, vargs));
	}

	/**
	 * Returns a `tapVersion`-appropriate TAP producer instance, if possible.
	 *
	 * @private
	 * @param {string} tapVersion - Version of TAP specification to produce.
	 * @returns {TAPProducer} specification-appropriate instance
	 * @throws {Error} if specification version has no associated producer.
	 */
	function createProducer(tapVersion) {
	  var producers = {
	    '12': new TAP12Producer(),
	    '13': new TAP13Producer()
	  };
	  var producer = producers[tapVersion];

	  if (!producer) {
	    throw new Error(
	      'invalid or unsupported TAP version: ' + JSON.stringify(tapVersion)
	    );
	  }

	  return producer;
	}

	/**
	 * @summary
	 * Constructs a new TAPProducer.
	 *
	 * @description
	 * <em>Only</em> to be used as an abstract base class.
	 *
	 * @private
	 * @constructor
	 */
	function TAPProducer() {}

	/**
	 * Writes the TAP version to reporter output stream.
	 *
	 * @abstract
	 */
	TAPProducer.prototype.writeVersion = function() {};

	/**
	 * Writes the plan to reporter output stream.
	 *
	 * @abstract
	 * @param {number} ntests - Number of tests that are planned to run.
	 */
	TAPProducer.prototype.writePlan = function(ntests) {
	  println('%d..%d', 1, ntests);
	};

	/**
	 * Writes that test passed to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that passed.
	 * @param {Test} test - Instance containing test information.
	 */
	TAPProducer.prototype.writePass = function(n, test) {
	  println('ok %d %s', n, title(test));
	};

	/**
	 * Writes that test was skipped to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that was skipped.
	 * @param {Test} test - Instance containing test information.
	 */
	TAPProducer.prototype.writePending = function(n, test) {
	  println('ok %d %s # SKIP -', n, title(test));
	};

	/**
	 * Writes that test failed to reporter output stream.
	 *
	 * @abstract
	 * @param {number} n - Index of test that failed.
	 * @param {Test} test - Instance containing test information.
	 * @param {Error} err - Reason the test failed.
	 */
	TAPProducer.prototype.writeFail = function(n, test, err) {
	  println('not ok %d %s', n, title(test));
	};

	/**
	 * Writes the summary epilogue to reporter output stream.
	 *
	 * @abstract
	 * @param {Object} stats - Object containing run statistics.
	 */
	TAPProducer.prototype.writeEpilogue = function(stats) {
	  // :TBD: Why is this not counting pending tests?
	  println('# tests ' + (stats.passes + stats.failures));
	  println('# pass ' + stats.passes);
	  // :TBD: Why are we not showing pending results?
	  println('# fail ' + stats.failures);
	};

	/**
	 * @summary
	 * Constructs a new TAP12Producer.
	 *
	 * @description
	 * Produces output conforming to the TAP12 specification.
	 *
	 * @private
	 * @constructor
	 * @extends TAPProducer
	 * @see {@link https://testanything.org/tap-specification.html|Specification}
	 */
	function TAP12Producer() {
	  /**
	   * Writes that test failed to reporter output stream, with error formatting.
	   * @override
	   */
	  this.writeFail = function(n, test, err) {
	    TAPProducer.prototype.writeFail.call(this, n, test, err);
	    if (err.message) {
	      println(err.message.replace(/^/gm, '  '));
	    }
	    if (err.stack) {
	      println(err.stack.replace(/^/gm, '  '));
	    }
	  };
	}

	/**
	 * Inherit from `TAPProducer.prototype`.
	 */
	inherits(TAP12Producer, TAPProducer);

	/**
	 * @summary
	 * Constructs a new TAP13Producer.
	 *
	 * @description
	 * Produces output conforming to the TAP13 specification.
	 *
	 * @private
	 * @constructor
	 * @extends TAPProducer
	 * @see {@link https://testanything.org/tap-version-13-specification.html|Specification}
	 */
	function TAP13Producer() {
	  /**
	   * Writes the TAP version to reporter output stream.
	   * @override
	   */
	  this.writeVersion = function() {
	    println('TAP version 13');
	  };

	  /**
	   * Writes that test failed to reporter output stream, with error formatting.
	   * @override
	   */
	  this.writeFail = function(n, test, err) {
	    TAPProducer.prototype.writeFail.call(this, n, test, err);
	    var emitYamlBlock = err.message != null || err.stack != null;
	    if (emitYamlBlock) {
	      println(indent(1) + '---');
	      if (err.message) {
	        println(indent(2) + 'message: |-');
	        println(err.message.replace(/^/gm, indent(3)));
	      }
	      if (err.stack) {
	        println(indent(2) + 'stack: |-');
	        println(err.stack.replace(/^/gm, indent(3)));
	      }
	      println(indent(1) + '...');
	    }
	  };

	  function indent(level) {
	    return Array(level + 1).join('  ');
	  }
	}

	/**
	 * Inherit from `TAPProducer.prototype`.
	 */
	inherits(TAP13Producer, TAPProducer);

	TAP.description = 'TAP-compatible output';
	});

	var json = createCommonjsModule(function (module, exports) {
	/**
	 * @module JSON
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;

	/**
	 * Expose `JSON`.
	 */

	exports = module.exports = JSONReporter;

	/**
	 * Constructs a new `JSON` reporter instance.
	 *
	 * @public
	 * @class JSON
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function JSONReporter(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var tests = [];
	  var pending = [];
	  var failures = [];
	  var passes = [];

	  runner.on(EVENT_TEST_END, function(test) {
	    tests.push(test);
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    passes.push(test);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test) {
	    failures.push(test);
	  });

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    pending.push(test);
	  });

	  runner.once(EVENT_RUN_END, function() {
	    var obj = {
	      stats: self.stats,
	      tests: tests.map(clean),
	      pending: pending.map(clean),
	      failures: failures.map(clean),
	      passes: passes.map(clean)
	    };

	    runner.testResults = obj;

	    process.stdout.write(JSON.stringify(obj, null, 2));
	  });
	}

	/**
	 * Return a plain-object representation of `test`
	 * free of cyclic properties etc.
	 *
	 * @private
	 * @param {Object} test
	 * @return {Object}
	 */
	function clean(test) {
	  var err = test.err || {};
	  if (err instanceof Error) {
	    err = errorJSON(err);
	  }

	  return {
	    title: test.title,
	    fullTitle: test.fullTitle(),
	    duration: test.duration,
	    currentRetry: test.currentRetry(),
	    err: cleanCycles(err)
	  };
	}

	/**
	 * Replaces any circular references inside `obj` with '[object Object]'
	 *
	 * @private
	 * @param {Object} obj
	 * @return {Object}
	 */
	function cleanCycles(obj) {
	  var cache = [];
	  return JSON.parse(
	    JSON.stringify(obj, function(key, value) {
	      if (typeof value === 'object' && value !== null) {
	        if (cache.indexOf(value) !== -1) {
	          // Instead of going in a circle, we'll print [object Object]
	          return '' + value;
	        }
	        cache.push(value);
	      }

	      return value;
	    })
	  );
	}

	/**
	 * Transform an Error object into a JSON object.
	 *
	 * @private
	 * @param {Error} err
	 * @return {Object}
	 */
	function errorJSON(err) {
	  var res = {};
	  Object.getOwnPropertyNames(err).forEach(function(key) {
	    res[key] = err[key];
	  }, err);
	  return res;
	}

	JSONReporter.description = 'single JSON object';
	});

	/**
	 * Expose `Progress`.
	 */

	var progress = Progress;

	/**
	 * Initialize a new `Progress` indicator.
	 */
	function Progress() {
	  this.percent = 0;
	  this.size(0);
	  this.fontSize(11);
	  this.font('helvetica, arial, sans-serif');
	}

	/**
	 * Set progress size to `size`.
	 *
	 * @public
	 * @param {number} size
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.size = function(size) {
	  this._size = size;
	  return this;
	};

	/**
	 * Set text to `text`.
	 *
	 * @public
	 * @param {string} text
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.text = function(text) {
	  this._text = text;
	  return this;
	};

	/**
	 * Set font size to `size`.
	 *
	 * @public
	 * @param {number} size
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.fontSize = function(size) {
	  this._fontSize = size;
	  return this;
	};

	/**
	 * Set font to `family`.
	 *
	 * @param {string} family
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.font = function(family) {
	  this._font = family;
	  return this;
	};

	/**
	 * Update percentage to `n`.
	 *
	 * @param {number} n
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.update = function(n) {
	  this.percent = n;
	  return this;
	};

	/**
	 * Draw on `ctx`.
	 *
	 * @param {CanvasRenderingContext2d} ctx
	 * @return {Progress} Progress instance.
	 */
	Progress.prototype.draw = function(ctx) {
	  try {
	    var percent = Math.min(this.percent, 100);
	    var size = this._size;
	    var half = size / 2;
	    var x = half;
	    var y = half;
	    var rad = half - 1;
	    var fontSize = this._fontSize;

	    ctx.font = fontSize + 'px ' + this._font;

	    var angle = Math.PI * 2 * (percent / 100);
	    ctx.clearRect(0, 0, size, size);

	    // outer circle
	    ctx.strokeStyle = '#9f9f9f';
	    ctx.beginPath();
	    ctx.arc(x, y, rad, 0, angle, false);
	    ctx.stroke();

	    // inner circle
	    ctx.strokeStyle = '#eee';
	    ctx.beginPath();
	    ctx.arc(x, y, rad - 1, 0, angle, true);
	    ctx.stroke();

	    // text
	    var text = this._text || (percent | 0) + '%';
	    var w = ctx.measureText(text).width;

	    ctx.fillText(text, x - w / 2 + 1, y + fontSize / 2 - 1);
	  } catch (ignore) {
	    // don't fail if we can't render progress
	  }
	  return this;
	};

	var html = createCommonjsModule(function (module, exports) {

	/* eslint-env browser */
	/**
	 * @module HTML
	 */
	/**
	 * Module dependencies.
	 */





	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var escape = utils.escape;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */

	var Date = commonjsGlobal.Date;

	/**
	 * Expose `HTML`.
	 */

	exports = module.exports = HTML;

	/**
	 * Stats template.
	 */

	var statsTemplate =
	  '<ul id="mocha-stats">' +
	  '<li class="progress"><canvas width="40" height="40"></canvas></li>' +
	  '<li class="passes"><a href="javascript:void(0);">passes:</a> <em>0</em></li>' +
	  '<li class="failures"><a href="javascript:void(0);">failures:</a> <em>0</em></li>' +
	  '<li class="duration">duration: <em>0</em>s</li>' +
	  '</ul>';

	var playIcon = '&#x2023;';

	/**
	 * Constructs a new `HTML` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function HTML(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var stats = this.stats;
	  var stat = fragment(statsTemplate);
	  var items = stat.getElementsByTagName('li');
	  var passes = items[1].getElementsByTagName('em')[0];
	  var passesLink = items[1].getElementsByTagName('a')[0];
	  var failures = items[2].getElementsByTagName('em')[0];
	  var failuresLink = items[2].getElementsByTagName('a')[0];
	  var duration = items[3].getElementsByTagName('em')[0];
	  var canvas = stat.getElementsByTagName('canvas')[0];
	  var report = fragment('<ul id="mocha-report"></ul>');
	  var stack = [report];
	  var progress$1;
	  var ctx;
	  var root = document.getElementById('mocha');

	  if (canvas.getContext) {
	    var ratio = window.devicePixelRatio || 1;
	    canvas.style.width = canvas.width;
	    canvas.style.height = canvas.height;
	    canvas.width *= ratio;
	    canvas.height *= ratio;
	    ctx = canvas.getContext('2d');
	    ctx.scale(ratio, ratio);
	    progress$1 = new progress();
	  }

	  if (!root) {
	    return error('#mocha div missing, add it to your document');
	  }

	  // pass toggle
	  on(passesLink, 'click', function(evt) {
	    evt.preventDefault();
	    unhide();
	    var name = /pass/.test(report.className) ? '' : ' pass';
	    report.className = report.className.replace(/fail|pass/g, '') + name;
	    if (report.className.trim()) {
	      hideSuitesWithout('test pass');
	    }
	  });

	  // failure toggle
	  on(failuresLink, 'click', function(evt) {
	    evt.preventDefault();
	    unhide();
	    var name = /fail/.test(report.className) ? '' : ' fail';
	    report.className = report.className.replace(/fail|pass/g, '') + name;
	    if (report.className.trim()) {
	      hideSuitesWithout('test fail');
	    }
	  });

	  root.appendChild(stat);
	  root.appendChild(report);

	  if (progress$1) {
	    progress$1.size(40);
	  }

	  runner.on(EVENT_SUITE_BEGIN, function(suite) {
	    if (suite.root) {
	      return;
	    }

	    // suite
	    var url = self.suiteURL(suite);
	    var el = fragment(
	      '<li class="suite"><h1><a href="%s">%s</a></h1></li>',
	      url,
	      escape(suite.title)
	    );

	    // container
	    stack[0].appendChild(el);
	    stack.unshift(document.createElement('ul'));
	    el.appendChild(stack[0]);
	  });

	  runner.on(EVENT_SUITE_END, function(suite) {
	    if (suite.root) {
	      updateStats();
	      return;
	    }
	    stack.shift();
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    var url = self.testURL(test);
	    var markup =
	      '<li class="test pass %e"><h2>%e<span class="duration">%ems</span> ' +
	      '<a href="%s" class="replay">' +
	      playIcon +
	      '</a></h2></li>';
	    var el = fragment(markup, test.speed, test.title, test.duration, url);
	    self.addCodeToggle(el, test.body);
	    appendToStack(el);
	    updateStats();
	  });

	  runner.on(EVENT_TEST_FAIL, function(test) {
	    var el = fragment(
	      '<li class="test fail"><h2>%e <a href="%e" class="replay">' +
	        playIcon +
	        '</a></h2></li>',
	      test.title,
	      self.testURL(test)
	    );
	    var stackString; // Note: Includes leading newline
	    var message = test.err.toString();

	    // <=IE7 stringifies to [Object Error]. Since it can be overloaded, we
	    // check for the result of the stringifying.
	    if (message === '[object Error]') {
	      message = test.err.message;
	    }

	    if (test.err.stack) {
	      var indexOfMessage = test.err.stack.indexOf(test.err.message);
	      if (indexOfMessage === -1) {
	        stackString = test.err.stack;
	      } else {
	        stackString = test.err.stack.substr(
	          test.err.message.length + indexOfMessage
	        );
	      }
	    } else if (test.err.sourceURL && test.err.line !== undefined) {
	      // Safari doesn't give you a stack. Let's at least provide a source line.
	      stackString = '\n(' + test.err.sourceURL + ':' + test.err.line + ')';
	    }

	    stackString = stackString || '';

	    if (test.err.htmlMessage && stackString) {
	      el.appendChild(
	        fragment(
	          '<div class="html-error">%s\n<pre class="error">%e</pre></div>',
	          test.err.htmlMessage,
	          stackString
	        )
	      );
	    } else if (test.err.htmlMessage) {
	      el.appendChild(
	        fragment('<div class="html-error">%s</div>', test.err.htmlMessage)
	      );
	    } else {
	      el.appendChild(
	        fragment('<pre class="error">%e%e</pre>', message, stackString)
	      );
	    }

	    self.addCodeToggle(el, test.body);
	    appendToStack(el);
	    updateStats();
	  });

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    var el = fragment(
	      '<li class="test pass pending"><h2>%e</h2></li>',
	      test.title
	    );
	    appendToStack(el);
	    updateStats();
	  });

	  function appendToStack(el) {
	    // Don't call .appendChild if #mocha-report was already .shift()'ed off the stack.
	    if (stack[0]) {
	      stack[0].appendChild(el);
	    }
	  }

	  function updateStats() {
	    // TODO: add to stats
	    var percent = ((stats.tests / runner.total) * 100) | 0;
	    if (progress$1) {
	      progress$1.update(percent).draw(ctx);
	    }

	    // update stats
	    var ms = new Date() - stats.start;
	    text(passes, stats.passes);
	    text(failures, stats.failures);
	    text(duration, (ms / 1000).toFixed(2));
	  }
	}

	/**
	 * Makes a URL, preserving querystring ("search") parameters.
	 *
	 * @param {string} s
	 * @return {string} A new URL.
	 */
	function makeUrl(s) {
	  var search = window.location.search;

	  // Remove previous grep query parameter if present
	  if (search) {
	    search = search.replace(/[?&]grep=[^&\s]*/g, '').replace(/^&/, '?');
	  }

	  return (
	    window.location.pathname +
	    (search ? search + '&' : '?') +
	    'grep=' +
	    encodeURIComponent(escapeStringRegexp(s))
	  );
	}

	/**
	 * Provide suite URL.
	 *
	 * @param {Object} [suite]
	 */
	HTML.prototype.suiteURL = function(suite) {
	  return makeUrl(suite.fullTitle());
	};

	/**
	 * Provide test URL.
	 *
	 * @param {Object} [test]
	 */
	HTML.prototype.testURL = function(test) {
	  return makeUrl(test.fullTitle());
	};

	/**
	 * Adds code toggle functionality for the provided test's list element.
	 *
	 * @param {HTMLLIElement} el
	 * @param {string} contents
	 */
	HTML.prototype.addCodeToggle = function(el, contents) {
	  var h2 = el.getElementsByTagName('h2')[0];

	  on(h2, 'click', function() {
	    pre.style.display = pre.style.display === 'none' ? 'block' : 'none';
	  });

	  var pre = fragment('<pre><code>%e</code></pre>', utils.clean(contents));
	  el.appendChild(pre);
	  pre.style.display = 'none';
	};

	/**
	 * Display error `msg`.
	 *
	 * @param {string} msg
	 */
	function error(msg) {
	  document.body.appendChild(fragment('<div id="mocha-error">%s</div>', msg));
	}

	/**
	 * Return a DOM fragment from `html`.
	 *
	 * @param {string} html
	 */
	function fragment(html) {
	  var args = arguments;
	  var div = document.createElement('div');
	  var i = 1;

	  div.innerHTML = html.replace(/%([se])/g, function(_, type) {
	    switch (type) {
	      case 's':
	        return String(args[i++]);
	      case 'e':
	        return escape(args[i++]);
	      // no default
	    }
	  });

	  return div.firstChild;
	}

	/**
	 * Check for suites that do not have elements
	 * with `classname`, and hide them.
	 *
	 * @param {text} classname
	 */
	function hideSuitesWithout(classname) {
	  var suites = document.getElementsByClassName('suite');
	  for (var i = 0; i < suites.length; i++) {
	    var els = suites[i].getElementsByClassName(classname);
	    if (!els.length) {
	      suites[i].className += ' hidden';
	    }
	  }
	}

	/**
	 * Unhide .hidden suites.
	 */
	function unhide() {
	  var els = document.getElementsByClassName('suite hidden');
	  while (els.length > 0) {
	    els[0].className = els[0].className.replace('suite hidden', 'suite');
	  }
	}

	/**
	 * Set an element's text contents.
	 *
	 * @param {HTMLElement} el
	 * @param {string} contents
	 */
	function text(el, contents) {
	  if (el.textContent) {
	    el.textContent = contents;
	  } else {
	    el.innerText = contents;
	  }
	}

	/**
	 * Listen on `event` with callback `fn`.
	 */
	function on(el, event, fn) {
	  if (el.addEventListener) {
	    el.addEventListener(event, fn, false);
	  } else {
	    el.attachEvent('on' + event, fn);
	  }
	}

	HTML.browserOnly = true;
	});

	var list = createCommonjsModule(function (module, exports) {
	/**
	 * @module List
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_BEGIN = constants.EVENT_TEST_BEGIN;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var color = base.color;
	var cursor = base.cursor;

	/**
	 * Expose `List`.
	 */

	exports = module.exports = List;

	/**
	 * Constructs a new `List` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function List(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var n = 0;

	  runner.on(EVENT_RUN_BEGIN, function() {
	    base.consoleLog();
	  });

	  runner.on(EVENT_TEST_BEGIN, function(test) {
	    process.stdout.write(color('pass', '    ' + test.fullTitle() + ': '));
	  });

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    var fmt = color('checkmark', '  -') + color('pending', ' %s');
	    base.consoleLog(fmt, test.fullTitle());
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    var fmt =
	      color('checkmark', '  ' + base.symbols.ok) +
	      color('pass', ' %s: ') +
	      color(test.speed, '%dms');
	    cursor.CR();
	    base.consoleLog(fmt, test.fullTitle(), test.duration);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test) {
	    cursor.CR();
	    base.consoleLog(color('fail', '  %d) %s'), ++n, test.fullTitle());
	  });

	  runner.once(EVENT_RUN_END, self.epilogue.bind(self));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(List, base);

	List.description = 'like "spec" reporter but flat';
	});

	var min = createCommonjsModule(function (module, exports) {
	/**
	 * @module Min
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;

	/**
	 * Expose `Min`.
	 */

	exports = module.exports = Min;

	/**
	 * Constructs a new `Min` reporter instance.
	 *
	 * @description
	 * This minimal test reporter is best used with '--watch'.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Min(runner, options) {
	  base.call(this, runner, options);

	  runner.on(EVENT_RUN_BEGIN, function() {
	    // clear screen
	    process.stdout.write('\u001b[2J');
	    // set cursor position
	    process.stdout.write('\u001b[1;3H');
	  });

	  runner.once(EVENT_RUN_END, this.epilogue.bind(this));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Min, base);

	Min.description = 'essentially just a summary';
	});

	var spec = createCommonjsModule(function (module, exports) {
	/**
	 * @module Spec
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var inherits = utils.inherits;
	var color = base.color;

	/**
	 * Expose `Spec`.
	 */

	exports = module.exports = Spec;

	/**
	 * Constructs a new `Spec` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Spec(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var indents = 0;
	  var n = 0;

	  function indent() {
	    return Array(indents).join('  ');
	  }

	  runner.on(EVENT_RUN_BEGIN, function() {
	    base.consoleLog();
	  });

	  runner.on(EVENT_SUITE_BEGIN, function(suite) {
	    ++indents;
	    base.consoleLog(color('suite', '%s%s'), indent(), suite.title);
	  });

	  runner.on(EVENT_SUITE_END, function() {
	    --indents;
	    if (indents === 1) {
	      base.consoleLog();
	    }
	  });

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    var fmt = indent() + color('pending', '  - %s');
	    base.consoleLog(fmt, test.title);
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    var fmt;
	    if (test.speed === 'fast') {
	      fmt =
	        indent() +
	        color('checkmark', '  ' + base.symbols.ok) +
	        color('pass', ' %s');
	      base.consoleLog(fmt, test.title);
	    } else {
	      fmt =
	        indent() +
	        color('checkmark', '  ' + base.symbols.ok) +
	        color('pass', ' %s') +
	        color(test.speed, ' (%dms)');
	      base.consoleLog(fmt, test.title, test.duration);
	    }
	  });

	  runner.on(EVENT_TEST_FAIL, function(test) {
	    base.consoleLog(indent() + color('fail', '  %d) %s'), ++n, test.title);
	  });

	  runner.once(EVENT_RUN_END, self.epilogue.bind(self));
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Spec, base);

	Spec.description = 'hierarchical & verbose [default]';
	});

	var nyan = createCommonjsModule(function (module, exports) {
	/**
	 * @module Nyan
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var inherits = utils.inherits;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;

	/**
	 * Expose `Dot`.
	 */

	exports = module.exports = NyanCat;

	/**
	 * Constructs a new `Nyan` reporter instance.
	 *
	 * @public
	 * @class Nyan
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function NyanCat(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var nyanCatWidth = (this.nyanCatWidth = 11);

	  this.colorIndex = 0;
	  this.numberOfLines = 4;
	  this.rainbowColors = self.generateColors();
	  this.scoreboardWidth = 5;
	  this.tick = 0;
	  this.trajectories = [[], [], [], []];
	  this.trajectoryWidthMax = width - nyanCatWidth;

	  runner.on(EVENT_RUN_BEGIN, function() {
	    base.cursor.hide();
	    self.draw();
	  });

	  runner.on(EVENT_TEST_PENDING, function() {
	    self.draw();
	  });

	  runner.on(EVENT_TEST_PASS, function() {
	    self.draw();
	  });

	  runner.on(EVENT_TEST_FAIL, function() {
	    self.draw();
	  });

	  runner.once(EVENT_RUN_END, function() {
	    base.cursor.show();
	    for (var i = 0; i < self.numberOfLines; i++) {
	      write('\n');
	    }
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(NyanCat, base);

	/**
	 * Draw the nyan cat
	 *
	 * @private
	 */

	NyanCat.prototype.draw = function() {
	  this.appendRainbow();
	  this.drawScoreboard();
	  this.drawRainbow();
	  this.drawNyanCat();
	  this.tick = !this.tick;
	};

	/**
	 * Draw the "scoreboard" showing the number
	 * of passes, failures and pending tests.
	 *
	 * @private
	 */

	NyanCat.prototype.drawScoreboard = function() {
	  var stats = this.stats;

	  function draw(type, n) {
	    write(' ');
	    write(base.color(type, n));
	    write('\n');
	  }

	  draw('green', stats.passes);
	  draw('fail', stats.failures);
	  draw('pending', stats.pending);
	  write('\n');

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Append the rainbow.
	 *
	 * @private
	 */

	NyanCat.prototype.appendRainbow = function() {
	  var segment = this.tick ? '_' : '-';
	  var rainbowified = this.rainbowify(segment);

	  for (var index = 0; index < this.numberOfLines; index++) {
	    var trajectory = this.trajectories[index];
	    if (trajectory.length >= this.trajectoryWidthMax) {
	      trajectory.shift();
	    }
	    trajectory.push(rainbowified);
	  }
	};

	/**
	 * Draw the rainbow.
	 *
	 * @private
	 */

	NyanCat.prototype.drawRainbow = function() {
	  var self = this;

	  this.trajectories.forEach(function(line) {
	    write('\u001b[' + self.scoreboardWidth + 'C');
	    write(line.join(''));
	    write('\n');
	  });

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Draw the nyan cat
	 *
	 * @private
	 */
	NyanCat.prototype.drawNyanCat = function() {
	  var self = this;
	  var startWidth = this.scoreboardWidth + this.trajectories[0].length;
	  var dist = '\u001b[' + startWidth + 'C';
	  var padding = '';

	  write(dist);
	  write('_,------,');
	  write('\n');

	  write(dist);
	  padding = self.tick ? '  ' : '   ';
	  write('_|' + padding + '/\\_/\\ ');
	  write('\n');

	  write(dist);
	  padding = self.tick ? '_' : '__';
	  var tail = self.tick ? '~' : '^';
	  write(tail + '|' + padding + this.face() + ' ');
	  write('\n');

	  write(dist);
	  padding = self.tick ? ' ' : '  ';
	  write(padding + '""  "" ');
	  write('\n');

	  this.cursorUp(this.numberOfLines);
	};

	/**
	 * Draw nyan cat face.
	 *
	 * @private
	 * @return {string}
	 */

	NyanCat.prototype.face = function() {
	  var stats = this.stats;
	  if (stats.failures) {
	    return '( x .x)';
	  } else if (stats.pending) {
	    return '( o .o)';
	  } else if (stats.passes) {
	    return '( ^ .^)';
	  }
	  return '( - .-)';
	};

	/**
	 * Move cursor up `n`.
	 *
	 * @private
	 * @param {number} n
	 */

	NyanCat.prototype.cursorUp = function(n) {
	  write('\u001b[' + n + 'A');
	};

	/**
	 * Move cursor down `n`.
	 *
	 * @private
	 * @param {number} n
	 */

	NyanCat.prototype.cursorDown = function(n) {
	  write('\u001b[' + n + 'B');
	};

	/**
	 * Generate rainbow colors.
	 *
	 * @private
	 * @return {Array}
	 */
	NyanCat.prototype.generateColors = function() {
	  var colors = [];

	  for (var i = 0; i < 6 * 7; i++) {
	    var pi3 = Math.floor(Math.PI / 3);
	    var n = i * (1.0 / 6);
	    var r = Math.floor(3 * Math.sin(n) + 3);
	    var g = Math.floor(3 * Math.sin(n + 2 * pi3) + 3);
	    var b = Math.floor(3 * Math.sin(n + 4 * pi3) + 3);
	    colors.push(36 * r + 6 * g + b + 16);
	  }

	  return colors;
	};

	/**
	 * Apply rainbow to the given `str`.
	 *
	 * @private
	 * @param {string} str
	 * @return {string}
	 */
	NyanCat.prototype.rainbowify = function(str) {
	  if (!base.useColors) {
	    return str;
	  }
	  var color = this.rainbowColors[this.colorIndex % this.rainbowColors.length];
	  this.colorIndex += 1;
	  return '\u001b[38;5;' + color + 'm' + str + '\u001b[0m';
	};

	/**
	 * Stdout helper.
	 *
	 * @param {string} string A message to write to stdout.
	 */
	function write(string) {
	  process.stdout.write(string);
	}

	NyanCat.description = '"nyan cat"';
	});

	var xunit = createCommonjsModule(function (module, exports) {
	/**
	 * @module XUnit
	 */
	/**
	 * Module dependencies.
	 */







	var createUnsupportedError = errors.createUnsupportedError;
	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_PENDING = constants.EVENT_TEST_PENDING;
	var STATE_FAILED = runnable.constants.STATE_FAILED;
	var inherits = utils.inherits;
	var escape = utils.escape;

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */
	var Date = commonjsGlobal.Date;

	/**
	 * Expose `XUnit`.
	 */

	exports = module.exports = XUnit;

	/**
	 * Constructs a new `XUnit` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function XUnit(runner, options) {
	  base.call(this, runner, options);

	  var stats = this.stats;
	  var tests = [];
	  var self = this;

	  // the name of the test suite, as it will appear in the resulting XML file
	  var suiteName;

	  // the default name of the test suite if none is provided
	  var DEFAULT_SUITE_NAME = 'Mocha Tests';

	  if (options && options.reporterOptions) {
	    if (options.reporterOptions.output) {
	      if (!path.createWriteStream) {
	        throw createUnsupportedError('file output not supported in browser');
	      }

	      mkdirp.sync(path.dirname(options.reporterOptions.output));
	      self.fileStream = path.createWriteStream(options.reporterOptions.output);
	    }

	    // get the suite name from the reporter options (if provided)
	    suiteName = options.reporterOptions.suiteName;
	  }

	  // fall back to the default suite name
	  suiteName = suiteName || DEFAULT_SUITE_NAME;

	  runner.on(EVENT_TEST_PENDING, function(test) {
	    tests.push(test);
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    tests.push(test);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test) {
	    tests.push(test);
	  });

	  runner.once(EVENT_RUN_END, function() {
	    self.write(
	      tag(
	        'testsuite',
	        {
	          name: suiteName,
	          tests: stats.tests,
	          failures: 0,
	          errors: stats.failures,
	          skipped: stats.tests - stats.failures - stats.passes,
	          timestamp: new Date().toUTCString(),
	          time: stats.duration / 1000 || 0
	        },
	        false
	      )
	    );

	    tests.forEach(function(t) {
	      self.test(t);
	    });

	    self.write('</testsuite>');
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(XUnit, base);

	/**
	 * Override done to close the stream (if it's a file).
	 *
	 * @param failures
	 * @param {Function} fn
	 */
	XUnit.prototype.done = function(failures, fn) {
	  if (this.fileStream) {
	    this.fileStream.end(function() {
	      fn(failures);
	    });
	  } else {
	    fn(failures);
	  }
	};

	/**
	 * Write out the given line.
	 *
	 * @param {string} line
	 */
	XUnit.prototype.write = function(line) {
	  if (this.fileStream) {
	    this.fileStream.write(line + '\n');
	  } else if (typeof process === 'object' && process.stdout) {
	    process.stdout.write(line + '\n');
	  } else {
	    base.consoleLog(line);
	  }
	};

	/**
	 * Output tag for the given `test.`
	 *
	 * @param {Test} test
	 */
	XUnit.prototype.test = function(test) {
	  base.useColors = false;

	  var attrs = {
	    classname: test.parent.fullTitle(),
	    name: test.title,
	    time: test.duration / 1000 || 0
	  };

	  if (test.state === STATE_FAILED) {
	    var err = test.err;
	    var diff =
	      !base.hideDiff && base.showDiff(err)
	        ? '\n' + base.generateDiff(err.actual, err.expected)
	        : '';
	    this.write(
	      tag(
	        'testcase',
	        attrs,
	        false,
	        tag(
	          'failure',
	          {},
	          false,
	          escape(err.message) + escape(diff) + '\n' + escape(err.stack)
	        )
	      )
	    );
	  } else if (test.isPending()) {
	    this.write(tag('testcase', attrs, false, tag('skipped', {}, true)));
	  } else {
	    this.write(tag('testcase', attrs, true));
	  }
	};

	/**
	 * HTML tag helper.
	 *
	 * @param name
	 * @param attrs
	 * @param close
	 * @param content
	 * @return {string}
	 */
	function tag(name, attrs, close, content) {
	  var end = close ? '/>' : '>';
	  var pairs = [];
	  var tag;

	  for (var key in attrs) {
	    if (Object.prototype.hasOwnProperty.call(attrs, key)) {
	      pairs.push(key + '="' + escape(attrs[key]) + '"');
	    }
	  }

	  tag = '<' + name + (pairs.length ? ' ' + pairs.join(' ') : '') + end;
	  if (content) {
	    tag += content + '</' + name + end;
	  }
	  return tag;
	}

	XUnit.description = 'XUnit-compatible XML output';
	});

	var markdown = createCommonjsModule(function (module, exports) {
	/**
	 * @module Markdown
	 */
	/**
	 * Module dependencies.
	 */



	var constants = runner.constants;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_SUITE_BEGIN = constants.EVENT_SUITE_BEGIN;
	var EVENT_SUITE_END = constants.EVENT_SUITE_END;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;

	/**
	 * Constants
	 */

	var SUITE_PREFIX = '$';

	/**
	 * Expose `Markdown`.
	 */

	exports = module.exports = Markdown;

	/**
	 * Constructs a new `Markdown` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Markdown(runner, options) {
	  base.call(this, runner, options);

	  var level = 0;
	  var buf = '';

	  function title(str) {
	    return Array(level).join('#') + ' ' + str;
	  }

	  function mapTOC(suite, obj) {
	    var ret = obj;
	    var key = SUITE_PREFIX + suite.title;

	    obj = obj[key] = obj[key] || {suite: suite};
	    suite.suites.forEach(function(suite) {
	      mapTOC(suite, obj);
	    });

	    return ret;
	  }

	  function stringifyTOC(obj, level) {
	    ++level;
	    var buf = '';
	    var link;
	    for (var key in obj) {
	      if (key === 'suite') {
	        continue;
	      }
	      if (key !== SUITE_PREFIX) {
	        link = ' - [' + key.substring(1) + ']';
	        link += '(#' + utils.slug(obj[key].suite.fullTitle()) + ')\n';
	        buf += Array(level).join('  ') + link;
	      }
	      buf += stringifyTOC(obj[key], level);
	    }
	    return buf;
	  }

	  function generateTOC(suite) {
	    var obj = mapTOC(suite, {});
	    return stringifyTOC(obj, 0);
	  }

	  generateTOC(runner.suite);

	  runner.on(EVENT_SUITE_BEGIN, function(suite) {
	    ++level;
	    var slug = utils.slug(suite.fullTitle());
	    buf += '<a name="' + slug + '"></a>' + '\n';
	    buf += title(suite.title) + '\n';
	  });

	  runner.on(EVENT_SUITE_END, function() {
	    --level;
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    var code = utils.clean(test.body);
	    buf += test.title + '.\n';
	    buf += '\n```js\n';
	    buf += code + '\n';
	    buf += '```\n\n';
	  });

	  runner.once(EVENT_RUN_END, function() {
	    process.stdout.write('# TOC\n');
	    process.stdout.write(generateTOC(runner.suite));
	    process.stdout.write(buf);
	  });
	}

	Markdown.description = 'GitHub Flavored Markdown';
	});

	var progress$1 = createCommonjsModule(function (module, exports) {
	/**
	 * @module Progress
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var inherits = utils.inherits;
	var color = base.color;
	var cursor = base.cursor;

	/**
	 * Expose `Progress`.
	 */

	exports = module.exports = Progress;

	/**
	 * General progress bar color.
	 */

	base.colors.progress = 90;

	/**
	 * Constructs a new `Progress` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Progress(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var width = (base.window.width * 0.5) | 0;
	  var total = runner.total;
	  var complete = 0;
	  var lastN = -1;

	  // default chars
	  options = options || {};
	  var reporterOptions = options.reporterOptions || {};

	  options.open = reporterOptions.open || '[';
	  options.complete = reporterOptions.complete || '▬';
	  options.incomplete = reporterOptions.incomplete || base.symbols.dot;
	  options.close = reporterOptions.close || ']';
	  options.verbose = reporterOptions.verbose || false;

	  // tests started
	  runner.on(EVENT_RUN_BEGIN, function() {
	    process.stdout.write('\n');
	    cursor.hide();
	  });

	  // tests complete
	  runner.on(EVENT_TEST_END, function() {
	    complete++;

	    var percent = complete / total;
	    var n = (width * percent) | 0;
	    var i = width - n;

	    if (n === lastN && !options.verbose) {
	      // Don't re-render the line if it hasn't changed
	      return;
	    }
	    lastN = n;

	    cursor.CR();
	    process.stdout.write('\u001b[J');
	    process.stdout.write(color('progress', '  ' + options.open));
	    process.stdout.write(Array(n).join(options.complete));
	    process.stdout.write(Array(i).join(options.incomplete));
	    process.stdout.write(color('progress', options.close));
	    if (options.verbose) {
	      process.stdout.write(color('progress', ' ' + complete + ' of ' + total));
	    }
	  });

	  // tests are complete, output some stats
	  // and the failures if any
	  runner.once(EVENT_RUN_END, function() {
	    cursor.show();
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Progress, base);

	Progress.description = 'a progress bar';
	});

	var landing = createCommonjsModule(function (module, exports) {
	/**
	 * @module Landing
	 */
	/**
	 * Module dependencies.
	 */


	var inherits = utils.inherits;
	var constants = runner.constants;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;
	var EVENT_TEST_END = constants.EVENT_TEST_END;
	var STATE_FAILED = runnable.constants.STATE_FAILED;

	var cursor = base.cursor;
	var color = base.color;

	/**
	 * Expose `Landing`.
	 */

	exports = module.exports = Landing;

	/**
	 * Airplane color.
	 */

	base.colors.plane = 0;

	/**
	 * Airplane crash color.
	 */

	base.colors['plane crash'] = 31;

	/**
	 * Runway color.
	 */

	base.colors.runway = 90;

	/**
	 * Constructs a new `Landing` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function Landing(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var width = (base.window.width * 0.75) | 0;
	  var total = runner.total;
	  var stream = process.stdout;
	  var plane = color('plane', '✈');
	  var crashed = -1;
	  var n = 0;

	  function runway() {
	    var buf = Array(width).join('-');
	    return '  ' + color('runway', buf);
	  }

	  runner.on(EVENT_RUN_BEGIN, function() {
	    stream.write('\n\n\n  ');
	    cursor.hide();
	  });

	  runner.on(EVENT_TEST_END, function(test) {
	    // check if the plane crashed
	    var col = crashed === -1 ? ((width * ++n) / total) | 0 : crashed;

	    // show the crash
	    if (test.state === STATE_FAILED) {
	      plane = color('plane crash', '✈');
	      crashed = col;
	    }

	    // render landing strip
	    stream.write('\u001b[' + (width + 1) + 'D\u001b[2A');
	    stream.write(runway());
	    stream.write('\n  ');
	    stream.write(color('runway', Array(col).join('⋅')));
	    stream.write(plane);
	    stream.write(color('runway', Array(width - col).join('⋅') + '\n'));
	    stream.write(runway());
	    stream.write('\u001b[0m');
	  });

	  runner.once(EVENT_RUN_END, function() {
	    cursor.show();
	    process.stdout.write('\n');
	    self.epilogue();
	  });
	}

	/**
	 * Inherit from `Base.prototype`.
	 */
	inherits(Landing, base);

	Landing.description = 'Unicode landing strip';
	});

	var jsonStream = createCommonjsModule(function (module, exports) {
	/**
	 * @module JSONStream
	 */
	/**
	 * Module dependencies.
	 */


	var constants = runner.constants;
	var EVENT_TEST_PASS = constants.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants.EVENT_TEST_FAIL;
	var EVENT_RUN_BEGIN = constants.EVENT_RUN_BEGIN;
	var EVENT_RUN_END = constants.EVENT_RUN_END;

	/**
	 * Expose `JSONStream`.
	 */

	exports = module.exports = JSONStream;

	/**
	 * Constructs a new `JSONStream` reporter instance.
	 *
	 * @public
	 * @class
	 * @memberof Mocha.reporters
	 * @extends Mocha.reporters.Base
	 * @param {Runner} runner - Instance triggers reporter actions.
	 * @param {Object} [options] - runner options
	 */
	function JSONStream(runner, options) {
	  base.call(this, runner, options);

	  var self = this;
	  var total = runner.total;

	  runner.once(EVENT_RUN_BEGIN, function() {
	    writeEvent(['start', {total: total}]);
	  });

	  runner.on(EVENT_TEST_PASS, function(test) {
	    writeEvent(['pass', clean(test)]);
	  });

	  runner.on(EVENT_TEST_FAIL, function(test, err) {
	    test = clean(test);
	    test.err = err.message;
	    test.stack = err.stack || null;
	    writeEvent(['fail', test]);
	  });

	  runner.once(EVENT_RUN_END, function() {
	    writeEvent(['end', self.stats]);
	  });
	}

	/**
	 * Mocha event to be written to the output stream.
	 * @typedef {Array} JSONStream~MochaEvent
	 */

	/**
	 * Writes Mocha event to reporter output stream.
	 *
	 * @private
	 * @param {JSONStream~MochaEvent} event - Mocha event to be output.
	 */
	function writeEvent(event) {
	  process.stdout.write(JSON.stringify(event) + '\n');
	}

	/**
	 * Returns an object literal representation of `test`
	 * free of cyclic properties, etc.
	 *
	 * @private
	 * @param {Test} test - Instance used as data source.
	 * @return {Object} object containing pared-down test instance data
	 */
	function clean(test) {
	  return {
	    title: test.title,
	    fullTitle: test.fullTitle(),
	    duration: test.duration,
	    currentRetry: test.currentRetry()
	  };
	}

	JSONStream.description = 'newline delimited JSON events';
	});

	var reporters = createCommonjsModule(function (module, exports) {

	// Alias exports to a their normalized format Mocha#reporter to prevent a need
	// for dynamic (try/catch) requires, which Browserify doesn't handle.
	exports.Base = exports.base = base;
	exports.Dot = exports.dot = dot;
	exports.Doc = exports.doc = doc;
	exports.TAP = exports.tap = tap;
	exports.JSON = exports.json = json;
	exports.HTML = exports.html = html;
	exports.List = exports.list = list;
	exports.Min = exports.min = min;
	exports.Spec = exports.spec = spec;
	exports.Nyan = exports.nyan = nyan;
	exports.XUnit = exports.xunit = xunit;
	exports.Markdown = exports.markdown = markdown;
	exports.Progress = exports.progress = progress$1;
	exports.Landing = exports.landing = landing;
	exports.JSONStream = exports['json-stream'] = jsonStream;
	});
	var reporters_1 = reporters.Base;
	var reporters_2 = reporters.base;
	var reporters_3 = reporters.Dot;
	var reporters_4 = reporters.dot;
	var reporters_5 = reporters.Doc;
	var reporters_6 = reporters.doc;
	var reporters_7 = reporters.TAP;
	var reporters_8 = reporters.tap;
	var reporters_9 = reporters.JSON;
	var reporters_10 = reporters.json;
	var reporters_11 = reporters.HTML;
	var reporters_12 = reporters.html;
	var reporters_13 = reporters.List;
	var reporters_14 = reporters.list;
	var reporters_15 = reporters.Min;
	var reporters_16 = reporters.min;
	var reporters_17 = reporters.Spec;
	var reporters_18 = reporters.spec;
	var reporters_19 = reporters.Nyan;
	var reporters_20 = reporters.nyan;
	var reporters_21 = reporters.XUnit;
	var reporters_22 = reporters.xunit;
	var reporters_23 = reporters.Markdown;
	var reporters_24 = reporters.markdown;
	var reporters_25 = reporters.Progress;
	var reporters_26 = reporters.progress;
	var reporters_27 = reporters.Landing;
	var reporters_28 = reporters.landing;
	var reporters_29 = reporters.JSONStream;

	/**
	 * Desktop Notifications module.
	 * @module Growl
	 */



	var which = which$1.sync;
	var ref = runner.constants;
	var EVENT_RUN_END = ref.EVENT_RUN_END;

	/**
	 * @summary
	 * Checks if Growl notification support seems likely.
	 *
	 * @description
	 * Glosses over the distinction between an unsupported platform
	 * and one that lacks prerequisite software installations.
	 *
	 * @public
	 * @see {@link https://github.com/tj/node-growl/blob/master/README.md|Prerequisite Installs}
	 * @see {@link Mocha#growl}
	 * @see {@link Mocha#isGrowlCapable}
	 * @return {boolean} whether Growl notification support can be expected
	 */
	var isCapable = function () {
	  if (!process.browser) {
	    return getSupportBinaries().reduce(
	      function (acc, binary) { return acc || Boolean(which(binary, {nothrow: true})); },
	      false
	    );
	  }
	  return false;
	};

	/**
	 * Implements desktop notifications as a pseudo-reporter.
	 *
	 * @public
	 * @see {@link Mocha#_growl}
	 * @param {Runner} runner - Runner instance.
	 */
	var notify = function (runner) {
	  runner.once(EVENT_RUN_END, function () {
	    display(runner);
	  });
	};

	/**
	 * Displays the notification.
	 *
	 * @private
	 * @param {Runner} runner - Runner instance.
	 */
	var display = function (runner) {
	  var growl = growl$1;
	  var stats = runner.stats;
	  var symbol = {
	    cross: '\u274C',
	    tick: '\u2705'
	  };
	  var _message;
	  var message;
	  var title;

	  if (stats.failures) {
	    _message = (stats.failures) + " of " + (stats.tests) + " tests failed";
	    message = (symbol.cross) + " " + _message;
	    title = 'Failed';
	  } else {
	    _message = (stats.passes) + " tests passed in " + (stats.duration) + "ms";
	    message = (symbol.tick) + " " + _message;
	    title = 'Passed';
	  }

	  // Send notification
	  var options = {
	    image: logo(),
	    name: 'mocha',
	    title: title
	  };
	  growl(message, options, onCompletion);
	};

	/**
	 * @summary
	 * Callback for result of attempted Growl notification.
	 *
	 * @description
	 * Despite its appearance, this is <strong>not</strong> an Error-first
	 * callback -- all parameters are populated regardless of success.
	 *
	 * @private
	 * @callback Growl~growlCB
	 * @param {*} err - Error object, or <code>null</code> if successful.
	 */
	function onCompletion(err) {
	  if (err) {
	    // As notifications are tangential to our purpose, just log the error.
	    var message =
	      err.code === 'ENOENT' ? 'prerequisite software not found' : err.message;
	    console.error('notification error:', message);
	  }
	}

	/**
	 * Returns Mocha logo image path.
	 *
	 * @private
	 * @return {string} Pathname of Mocha logo
	 */
	var logo = function () {
	  return path.join(__dirname, '..', 'assets', 'mocha-logo-96.png');
	};

	/**
	 * @summary
	 * Gets platform-specific Growl support binaries.
	 *
	 * @description
	 * Somewhat brittle dependency on `growl` package implementation, but it
	 * rarely changes.
	 *
	 * @private
	 * @see {@link https://github.com/tj/node-growl/blob/master/lib/growl.js#L28-L126|setupCmd}
	 * @return {string[]} names of Growl support binaries
	 */
	var getSupportBinaries = function () {
	  var binaries = {
	    Darwin: ['terminal-notifier', 'growlnotify'],
	    Linux: ['notify-send', 'growl'],
	    Windows_NT: ['growlnotify.exe']
	  };
	  return binaries[os.type()] || [];
	};

	var growl = {
		isCapable: isCapable,
		notify: notify
	};

	var diff = true;
	var extension = [
		"js"
	];
	var opts = "./test/mocha.opts";
	var reporter = "spec";
	var slow = 75;
	var timeout = 2000;
	var ui = "bdd";
	var mocharc = {
		diff: diff,
		extension: extension,
		opts: opts,
		"package": "./package.json",
		reporter: reporter,
		slow: slow,
		timeout: timeout,
		ui: ui,
		"watch-ignore": [
		"node_modules",
		".git"
	]
	};

	var mocharc$1 = /*#__PURE__*/Object.freeze({
		diff: diff,
		extension: extension,
		opts: opts,
		reporter: reporter,
		slow: slow,
		timeout: timeout,
		ui: ui,
		'default': mocharc
	});

	/**
	 * Provides a factory function for a {@link StatsCollector} object.
	 * @module
	 */

	var constants$2 = runner.constants;
	var EVENT_TEST_PASS = constants$2.EVENT_TEST_PASS;
	var EVENT_TEST_FAIL = constants$2.EVENT_TEST_FAIL;
	var EVENT_SUITE_BEGIN = constants$2.EVENT_SUITE_BEGIN;
	var EVENT_RUN_BEGIN = constants$2.EVENT_RUN_BEGIN;
	var EVENT_TEST_PENDING = constants$2.EVENT_TEST_PENDING;
	var EVENT_RUN_END$1 = constants$2.EVENT_RUN_END;
	var EVENT_TEST_END = constants$2.EVENT_TEST_END;

	/**
	 * Test statistics collector.
	 *
	 * @public
	 * @typedef {Object} StatsCollector
	 * @property {number} suites - integer count of suites run.
	 * @property {number} tests - integer count of tests run.
	 * @property {number} passes - integer count of passing tests.
	 * @property {number} pending - integer count of pending tests.
	 * @property {number} failures - integer count of failed tests.
	 * @property {Date} start - time when testing began.
	 * @property {Date} end - time when testing concluded.
	 * @property {number} duration - number of msecs that testing took.
	 */

	var Date$1 = commonjsGlobal.Date;

	/**
	 * Provides stats such as test duration, number of tests passed / failed etc., by listening for events emitted by `runner`.
	 *
	 * @private
	 * @param {Runner} runner - Runner instance
	 * @throws {TypeError} If falsy `runner`
	 */
	function createStatsCollector(runner) {
	  /**
	   * @type StatsCollector
	   */
	  var stats = {
	    suites: 0,
	    tests: 0,
	    passes: 0,
	    pending: 0,
	    failures: 0
	  };

	  if (!runner) {
	    throw new TypeError('Missing runner argument');
	  }

	  runner.stats = stats;

	  runner.once(EVENT_RUN_BEGIN, function() {
	    stats.start = new Date$1();
	  });
	  runner.on(EVENT_SUITE_BEGIN, function(suite) {
	    suite.root || stats.suites++;
	  });
	  runner.on(EVENT_TEST_PASS, function() {
	    stats.passes++;
	  });
	  runner.on(EVENT_TEST_FAIL, function() {
	    stats.failures++;
	  });
	  runner.on(EVENT_TEST_PENDING, function() {
	    stats.pending++;
	  });
	  runner.on(EVENT_TEST_END, function() {
	    stats.tests++;
	  });
	  runner.once(EVENT_RUN_END$1, function() {
	    stats.end = new Date$1();
	    stats.duration = stats.end - stats.start;
	  });
	}

	var statsCollector = createStatsCollector;

	var createInvalidArgumentTypeError$1 = errors.createInvalidArgumentTypeError;
	var isString = utils.isString;

	var test = Test;

	/**
	 * Initialize a new `Test` with the given `title` and callback `fn`.
	 *
	 * @public
	 * @class
	 * @extends Runnable
	 * @param {String} title - Test title (required)
	 * @param {Function} [fn] - Test callback.  If omitted, the Test is considered "pending"
	 */
	function Test(title, fn) {
	  if (!isString(title)) {
	    throw createInvalidArgumentTypeError$1(
	      'Test argument "title" should be a string. Received type "' +
	        typeof title +
	        '"',
	      'title',
	      'string'
	    );
	  }
	  runnable.call(this, title, fn);
	  this.pending = !fn;
	  this.type = 'test';
	}

	/**
	 * Inherit from `Runnable.prototype`.
	 */
	utils.inherits(Test, runnable);

	Test.prototype.clone = function() {
	  var test = new Test(this.title, this.fn);
	  test.timeout(this.timeout());
	  test.slow(this.slow());
	  test.enableTimeouts(this.enableTimeouts());
	  test.retries(this.retries());
	  test.currentRetry(this.currentRetry());
	  test.globals(this.globals());
	  test.parent = this.parent;
	  test.file = this.file;
	  test.ctx = this.ctx;
	  return test;
	};

	var createMissingArgumentError$1 = errors.createMissingArgumentError;

	/**
	 * Functions common to more than one interface.
	 *
	 * @param {Suite[]} suites
	 * @param {Context} context
	 * @param {Mocha} mocha
	 * @return {Object} An object containing common functions.
	 */
	var common = function(suites, context, mocha) {
	  /**
	   * Check if the suite should be tested.
	   *
	   * @private
	   * @param {Suite} suite - suite to check
	   * @returns {boolean}
	   */
	  function shouldBeTested(suite) {
	    return (
	      !mocha.options.grep ||
	      (mocha.options.grep &&
	        mocha.options.grep.test(suite.fullTitle()) &&
	        !mocha.options.invert)
	    );
	  }

	  return {
	    /**
	     * This is only present if flag --delay is passed into Mocha. It triggers
	     * root suite execution.
	     *
	     * @param {Suite} suite The root suite.
	     * @return {Function} A function which runs the root suite
	     */
	    runWithSuite: function runWithSuite(suite) {
	      return function run() {
	        suite.run();
	      };
	    },

	    /**
	     * Execute before running tests.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    before: function(name, fn) {
	      suites[0].beforeAll(name, fn);
	    },

	    /**
	     * Execute after running tests.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    after: function(name, fn) {
	      suites[0].afterAll(name, fn);
	    },

	    /**
	     * Execute before each test case.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    beforeEach: function(name, fn) {
	      suites[0].beforeEach(name, fn);
	    },

	    /**
	     * Execute after each test case.
	     *
	     * @param {string} name
	     * @param {Function} fn
	     */
	    afterEach: function(name, fn) {
	      suites[0].afterEach(name, fn);
	    },

	    suite: {
	      /**
	       * Create an exclusive Suite; convenience function
	       * See docstring for create() below.
	       *
	       * @param {Object} opts
	       * @returns {Suite}
	       */
	      only: function only(opts) {
	        opts.isOnly = true;
	        return this.create(opts);
	      },

	      /**
	       * Create a Suite, but skip it; convenience function
	       * See docstring for create() below.
	       *
	       * @param {Object} opts
	       * @returns {Suite}
	       */
	      skip: function skip(opts) {
	        opts.pending = true;
	        return this.create(opts);
	      },

	      /**
	       * Creates a suite.
	       *
	       * @param {Object} opts Options
	       * @param {string} opts.title Title of Suite
	       * @param {Function} [opts.fn] Suite Function (not always applicable)
	       * @param {boolean} [opts.pending] Is Suite pending?
	       * @param {string} [opts.file] Filepath where this Suite resides
	       * @param {boolean} [opts.isOnly] Is Suite exclusive?
	       * @returns {Suite}
	       */
	      create: function create(opts) {
	        var suite$1 = suite.create(suites[0], opts.title);
	        suite$1.pending = Boolean(opts.pending);
	        suite$1.file = opts.file;
	        suites.unshift(suite$1);
	        if (opts.isOnly) {
	          if (mocha.options.forbidOnly && shouldBeTested(suite$1)) {
	            throw new Error('`.only` forbidden');
	          }

	          suite$1.parent.appendOnlySuite(suite$1);
	        }
	        if (suite$1.pending) {
	          if (mocha.options.forbidPending && shouldBeTested(suite$1)) {
	            throw new Error('Pending test forbidden');
	          }
	        }
	        if (typeof opts.fn === 'function') {
	          opts.fn.call(suite$1);
	          suites.shift();
	        } else if (typeof opts.fn === 'undefined' && !suite$1.pending) {
	          throw createMissingArgumentError$1(
	            'Suite "' +
	              suite$1.fullTitle() +
	              '" was defined but no callback was supplied. ' +
	              'Supply a callback or explicitly skip the suite.',
	            'callback',
	            'function'
	          );
	        } else if (!opts.fn && suite$1.pending) {
	          suites.shift();
	        }

	        return suite$1;
	      }
	    },

	    test: {
	      /**
	       * Exclusive test-case.
	       *
	       * @param {Object} mocha
	       * @param {Function} test
	       * @returns {*}
	       */
	      only: function(mocha, test) {
	        test.parent.appendOnlyTest(test);
	        return test;
	      },

	      /**
	       * Pending test case.
	       *
	       * @param {string} title
	       */
	      skip: function(title) {
	        context.test(title);
	      },

	      /**
	       * Number of retry attempts
	       *
	       * @param {number} n
	       */
	      retries: function(n) {
	        context.retries(n);
	      }
	    }
	  };
	};

	var EVENT_FILE_PRE_REQUIRE = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * BDD-style interface:
	 *
	 *      describe('Array', function() {
	 *        describe('#indexOf()', function() {
	 *          it('should return -1 when not present', function() {
	 *            // ...
	 *          });
	 *
	 *          it('should return the index when present', function() {
	 *            // ...
	 *          });
	 *        });
	 *      });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var bdd = function bddInterface(suite) {
	  var suites = [suite];

	  suite.on(EVENT_FILE_PRE_REQUIRE, function(context, file, mocha) {
	    var common$1 = common(suites, context, mocha);

	    context.before = common$1.before;
	    context.after = common$1.after;
	    context.beforeEach = common$1.beforeEach;
	    context.afterEach = common$1.afterEach;
	    context.run = mocha.options.delay && common$1.runWithSuite(suite);
	    /**
	     * Describe a "suite" with the given `title`
	     * and callback `fn` containing nested suites
	     * and/or tests.
	     */

	    context.describe = context.context = function(title, fn) {
	      return common$1.suite.create({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Pending describe.
	     */

	    context.xdescribe = context.xcontext = context.describe.skip = function(
	      title,
	      fn
	    ) {
	      return common$1.suite.skip({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Exclusive suite.
	     */

	    context.describe.only = function(title, fn) {
	      return common$1.suite.only({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Describe a specification or test-case
	     * with the given `title` and callback `fn`
	     * acting as a thunk.
	     */

	    context.it = context.specify = function(title, fn) {
	      var suite = suites[0];
	      if (suite.isPending()) {
	        fn = null;
	      }
	      var test$1 = new test(title, fn);
	      test$1.file = file;
	      suite.addTest(test$1);
	      return test$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.it.only = function(title, fn) {
	      return common$1.test.only(mocha, context.it(title, fn));
	    };

	    /**
	     * Pending test case.
	     */

	    context.xit = context.xspecify = context.it.skip = function(title) {
	      return context.it(title);
	    };

	    /**
	     * Number of attempts to retry.
	     */
	    context.it.retries = function(n) {
	      context.retries(n);
	    };
	  });
	};

	var description = 'BDD or RSpec style [default]';
	bdd.description = description;

	var EVENT_FILE_PRE_REQUIRE$1 = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * TDD-style interface:
	 *
	 *      suite('Array', function() {
	 *        suite('#indexOf()', function() {
	 *          suiteSetup(function() {
	 *
	 *          });
	 *
	 *          test('should return -1 when not present', function() {
	 *
	 *          });
	 *
	 *          test('should return the index when present', function() {
	 *
	 *          });
	 *
	 *          suiteTeardown(function() {
	 *
	 *          });
	 *        });
	 *      });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var tdd = function(suite) {
	  var suites = [suite];

	  suite.on(EVENT_FILE_PRE_REQUIRE$1, function(context, file, mocha) {
	    var common$1 = common(suites, context, mocha);

	    context.setup = common$1.beforeEach;
	    context.teardown = common$1.afterEach;
	    context.suiteSetup = common$1.before;
	    context.suiteTeardown = common$1.after;
	    context.run = mocha.options.delay && common$1.runWithSuite(suite);

	    /**
	     * Describe a "suite" with the given `title` and callback `fn` containing
	     * nested suites and/or tests.
	     */
	    context.suite = function(title, fn) {
	      return common$1.suite.create({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Pending suite.
	     */
	    context.suite.skip = function(title, fn) {
	      return common$1.suite.skip({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Exclusive test-case.
	     */
	    context.suite.only = function(title, fn) {
	      return common$1.suite.only({
	        title: title,
	        file: file,
	        fn: fn
	      });
	    };

	    /**
	     * Describe a specification or test-case with the given `title` and
	     * callback `fn` acting as a thunk.
	     */
	    context.test = function(title, fn) {
	      var suite = suites[0];
	      if (suite.isPending()) {
	        fn = null;
	      }
	      var test$1 = new test(title, fn);
	      test$1.file = file;
	      suite.addTest(test$1);
	      return test$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.test.only = function(title, fn) {
	      return common$1.test.only(mocha, context.test(title, fn));
	    };

	    context.test.skip = common$1.test.skip;
	    context.test.retries = common$1.test.retries;
	  });
	};

	var description$1 =
	  'traditional "suite"/"test" instead of BDD\'s "describe"/"it"';
	tdd.description = description$1;

	var EVENT_FILE_PRE_REQUIRE$2 = suite.constants
	  .EVENT_FILE_PRE_REQUIRE;

	/**
	 * QUnit-style interface:
	 *
	 *     suite('Array');
	 *
	 *     test('#length', function() {
	 *       var arr = [1,2,3];
	 *       ok(arr.length == 3);
	 *     });
	 *
	 *     test('#indexOf()', function() {
	 *       var arr = [1,2,3];
	 *       ok(arr.indexOf(1) == 0);
	 *       ok(arr.indexOf(2) == 1);
	 *       ok(arr.indexOf(3) == 2);
	 *     });
	 *
	 *     suite('String');
	 *
	 *     test('#length', function() {
	 *       ok('foo'.length == 3);
	 *     });
	 *
	 * @param {Suite} suite Root suite.
	 */
	var qunit = function qUnitInterface(suite) {
	  var suites = [suite];

	  suite.on(EVENT_FILE_PRE_REQUIRE$2, function(context, file, mocha) {
	    var common$1 = common(suites, context, mocha);

	    context.before = common$1.before;
	    context.after = common$1.after;
	    context.beforeEach = common$1.beforeEach;
	    context.afterEach = common$1.afterEach;
	    context.run = mocha.options.delay && common$1.runWithSuite(suite);
	    /**
	     * Describe a "suite" with the given `title`.
	     */

	    context.suite = function(title) {
	      if (suites.length > 1) {
	        suites.shift();
	      }
	      return common$1.suite.create({
	        title: title,
	        file: file,
	        fn: false
	      });
	    };

	    /**
	     * Exclusive Suite.
	     */

	    context.suite.only = function(title) {
	      if (suites.length > 1) {
	        suites.shift();
	      }
	      return common$1.suite.only({
	        title: title,
	        file: file,
	        fn: false
	      });
	    };

	    /**
	     * Describe a specification or test-case
	     * with the given `title` and callback `fn`
	     * acting as a thunk.
	     */

	    context.test = function(title, fn) {
	      var test$1 = new test(title, fn);
	      test$1.file = file;
	      suites[0].addTest(test$1);
	      return test$1;
	    };

	    /**
	     * Exclusive test-case.
	     */

	    context.test.only = function(title, fn) {
	      return common$1.test.only(mocha, context.test(title, fn));
	    };

	    context.test.skip = common$1.test.skip;
	    context.test.retries = common$1.test.retries;
	  });
	};

	var description$2 = 'QUnit style';
	qunit.description = description$2;

	/**
	 * Exports-style (as Node.js module) interface:
	 *
	 *     exports.Array = {
	 *       '#indexOf()': {
	 *         'should return -1 when the value is not present': function() {
	 *
	 *         },
	 *
	 *         'should return the correct index when the value is present': function() {
	 *
	 *         }
	 *       }
	 *     };
	 *
	 * @param {Suite} suite Root suite.
	 */
	var exports$1 = function(suite$1) {
	  var suites = [suite$1];

	  suite$1.on(suite.constants.EVENT_FILE_REQUIRE, visit);

	  function visit(obj, file) {
	    var suite$1;
	    for (var key in obj) {
	      if (typeof obj[key] === 'function') {
	        var fn = obj[key];
	        switch (key) {
	          case 'before':
	            suites[0].beforeAll(fn);
	            break;
	          case 'after':
	            suites[0].afterAll(fn);
	            break;
	          case 'beforeEach':
	            suites[0].beforeEach(fn);
	            break;
	          case 'afterEach':
	            suites[0].afterEach(fn);
	            break;
	          default:
	            var test$1 = new test(key, fn);
	            test$1.file = file;
	            suites[0].addTest(test$1);
	        }
	      } else {
	        suite$1 = suite.create(suites[0], key);
	        suites.unshift(suite$1);
	        visit(obj[key], file);
	        suites.shift();
	      }
	    }
	  }
	};

	var description$3 = 'Node.js module ("exports") style';
	exports$1.description = description$3;

	var bdd$1 = bdd;
	var tdd$1 = tdd;
	var qunit$1 = qunit;
	var exports$2 = exports$1;

	var interfaces = {
		bdd: bdd$1,
		tdd: tdd$1,
		qunit: qunit$1,
		exports: exports$2
	};

	/**
	 * @module Context
	 */
	/**
	 * Expose `Context`.
	 */

	var context = Context;

	/**
	 * Initialize a new `Context`.
	 *
	 * @private
	 */
	function Context() {}

	/**
	 * Set or get the context `Runnable` to `runnable`.
	 *
	 * @private
	 * @param {Runnable} runnable
	 * @return {Context} context
	 */
	Context.prototype.runnable = function(runnable) {
	  if (!arguments.length) {
	    return this._runnable;
	  }
	  this.test = this._runnable = runnable;
	  return this;
	};

	/**
	 * Set or get test timeout `ms`.
	 *
	 * @private
	 * @param {number} ms
	 * @return {Context} self
	 */
	Context.prototype.timeout = function(ms) {
	  if (!arguments.length) {
	    return this.runnable().timeout();
	  }
	  this.runnable().timeout(ms);
	  return this;
	};

	/**
	 * Set test timeout `enabled`.
	 *
	 * @private
	 * @param {boolean} enabled
	 * @return {Context} self
	 */
	Context.prototype.enableTimeouts = function(enabled) {
	  if (!arguments.length) {
	    return this.runnable().enableTimeouts();
	  }
	  this.runnable().enableTimeouts(enabled);
	  return this;
	};

	/**
	 * Set or get test slowness threshold `ms`.
	 *
	 * @private
	 * @param {number} ms
	 * @return {Context} self
	 */
	Context.prototype.slow = function(ms) {
	  if (!arguments.length) {
	    return this.runnable().slow();
	  }
	  this.runnable().slow(ms);
	  return this;
	};

	/**
	 * Mark a test as skipped.
	 *
	 * @private
	 * @throws Pending
	 */
	Context.prototype.skip = function() {
	  this.runnable().skip();
	};

	/**
	 * Set or get a number of allowed retries on failed tests
	 *
	 * @private
	 * @param {number} n
	 * @return {Context} self
	 */
	Context.prototype.retries = function(n) {
	  if (!arguments.length) {
	    return this.runnable().retries();
	  }
	  this.runnable().retries(n);
	  return this;
	};

	var name = "mocha";
	var version = "7.0.1";
	var description$4 = "simple, flexible, fun test framework";
	var keywords = [
		"mocha",
		"test",
		"bdd",
		"tdd",
		"tap"
	];
	var funding = {
		type: "opencollective",
		url: "https://opencollective.com/mochajs"
	};
	var author = "TJ Holowaychuk <tj@vision-media.ca>";
	var contributors = [
		"38elements <mh19820223@gmail.com>",
		"Aaron Brady <aaron@mori.com>",
		"Aaron Hamid <aaron.hamid@gmail.com>",
		"Aaron Heckmann <aaron.heckmann+github@gmail.com>",
		"Aaron Krause <aaronjkrause@gmail.com>",
		"Aaron Petcoff <hello@aaronpetcoff.me>",
		"abrkn <a@abrkn.com>",
		"Adam Crabtree <adam.crabtree@redrobotlabs.com>",
		"Adam Ginzberg <aginzberg@gmail.com>",
		"Adam Gruber <talknmime@gmail.com>",
		"Adrian Ludwig <me@adrianludwig.pl>",
		"Ahmad Bamieh <ahmadbamieh@gmail.com>",
		"airportyh <airportyh@gmail.com>",
		"Ajay Kodali <ajay.kodali@citrix.com>",
		"Al Scott <al.scott@atomicobject.com>",
		"Alex Bainter <metalex9@users.noreply.github.com>",
		"Alexander Early <alexander.early@gmail.com>",
		"Alexander Shepelin <Brightcor@gmail.com>",
		"Alhadis <gardnerjohng@gmail.com>",
		"amsul <reach@amsul.ca>",
		"Anders Olsen Sandvik <Andersos@users.noreply.github.com>",
		"Andreas Brekken <andreas@opuno.com>",
		"Andreas Lind <andreaslindpetersen@gmail.com>",
		"Andreas Lind Petersen <andreas@one.com>",
		"Andrew Bradley <abradley@brightcove.com>",
		"Andrew Bradley <cspotcode@gmail.com>",
		"Andrew Krawchyk <903716+akrawchyk@users.noreply.github.com>",
		"Andrew Nesbitt <andrewnez@gmail.com>",
		"Andrey Popp <8mayday@gmail.com>",
		"Andrii Shumada <eagleeyes91@gmail.com>",
		"andy matthews <andy@commadelimited.com>",
		"Angelica Valenta <angelicavalenta@gmail.com>",
		"Anis Safine <anis.safine.ext@francetv.fr>",
		"Anish Karandikar <anishkny@gmail.com>",
		"Anna Henningsen <github@addaleax.net>",
		"Anthony <keppi@o2.pl>",
		"Anton <anton.redfox@gmail.com>",
		"anton <anton.valickij@gmail.com>",
		"APerson <danielhglus@gmail.com>",
		"Arian Stolwijk <arian@aryweb.nl>",
		"Ariel Mashraki <ariel@mashraki.co.il>",
		"Arnaud Brousseau <arnaud.brousseau@gmail.com>",
		"Artem Govorov <artem.govorov@gmail.com>",
		"Atsuya Takagi <asoftonight@gmail.com>",
		"Attila Domokos <adomokos@gmail.com>",
		"Austin Birch <mraustinbirch@gmail.com>",
		"Avi Vahl <avi.vahl@wix.com>",
		"badunk <baduncaduncan@gmail.com>",
		"Bamieh <ahmadbamieh@gmail.com>",
		"Ben Bradley <ben@bradleyit.com>",
		"Ben Glassman <benglass@users.noreply.github.com>",
		"Ben Harris <benhdev@gmail.com>",
		"Ben Hutchison <ben@aldaviva.com>",
		"Ben Lindsey <ben.lindsey@vungle.com>",
		"Ben Noordhuis <info@bnoordhuis.nl>",
		"Ben Vinegar <ben@benv.ca>",
		"Benjamin Eidelman <beneidel@gmail.com>",
		"Benjie Gillam <benjie@jemjie.com>",
		"Benoit Larroque <zeta.ben@gmail.com>",
		"Benoît Zugmeyer <bzugmeyer@gmail.com>",
		"Benson Trent <bensontrent@gmail.com>",
		"Berker Peksag <berker.peksag@gmail.com>",
		"berni <berni@extensa.pl>",
		"Bjørge Næss <bjoerge@origo.no>",
		"Bjorn Stromberg <bjorn@bjornstar.com>",
		"Brendan Nee <brendan.nee@gmail.com>",
		"Brian Beck <exogen@gmail.com>",
		"Brian Lagerman <49239617+brian-lagerman@users.noreply.github.com>",
		"Brian Lalor <blalor@bravo5.org>",
		"Brian M. Carlson <brian.m.carlson@gmail.com>",
		"Brian Moore <guardbionic-github@yahoo.com>",
		"Brian Tomlin <tendonstrength@gmail.com>",
		"Brittany Moore <moore.brittanyann@gmail.com>",
		"Bryan Donovan <bdondo@gmail.com>",
		"Buck Doyle <b@chromatin.ca>",
		"C. Scott Ananian <cscott@cscott.net>",
		"Callum Macrae <callum@macr.ae>",
		"Can Oztokmak <can@zeplin.io>",
		"Capacitor Set <CapacitorSet@users.noreply.github.com>",
		"Carl-Erik Kopseng <carlerik@gmail.com>",
		"Casey Foster <casey@caseywebdev.com>",
		"Charles Lowell <cowboyd@frontside.io>",
		"Charles Merriam <charles.merriam@gmail.com>",
		"Charles Samborski <demurgos@demurgos.net>",
		"Charlie Rudolph <charles.w.rudolph@gmail.com>",
		"Chen Yangjian <252317+cyjake@users.noreply.github.com>",
		"Chris <chrisleck@users.noreply.github.com>",
		"Chris Buckley <chris@cmbuckley.co.uk>",
		"Chris Lamb <chris@chris-lamb.co.uk>",
		"Christian <me@rndm.de>",
		"Christian Holm <christian@peakon.com>",
		"Christoffer Hallas <christoffer.hallas@gmail.com>",
		"Christoph Neuroth <christoph.neuroth@gmail.com>",
		"Christopher Hiller <boneskull@boneskull.com>",
		"ChrisWren <cthewren@gmail.com>",
		"claudyus <claudyus@HEX.(none)>",
		"Connor Dunn <connorhd@gmail.com>",
		"Corey Butler <corey@coreybutler.com>",
		"Corey Farrell <git@cfware.com>",
		"Cory Thomas <cory.thomas@bazaarvoice.com>",
		"Craig Taub <craigtaub@gmail.com>",
		"Cube <maty21@gmail.com>",
		"Daniel Ruf <827205+DanielRuf@users.noreply.github.com>",
		"Daniel Ruf <daniel@daniel-ruf.de>",
		"Daniel St. Jules <danielst.jules@gmail.com>",
		"Daniel Stockman <daniel.stockman@gmail.com>",
		"Darryl Pogue <dvpdiner2@gmail.com>",
		"Dave McKenna <davemckenna01@gmail.com>",
		"David da Silva Contín <dasilvacontin@gmail.com>",
		"David Henderson <david.henderson@triggeredmessaging.com>",
		"David M. Lee <leedm777@yahoo.com>",
		"David Neubauer <davidneub@gmail.com>",
		"DavidLi119 <han.david.li@gmail.com>",
		"DavNej <davnej.dev@gmail.com>",
		"Denis Bardadym <bardadymchik@gmail.com>",
		"Devin Weaver <suki@tritarget.org>",
		"dfberry <dinaberry@outlook.com>",
		"Di Wu <dwu@palantir.com>",
		"Dina Berry <dfberry@users.noreply.github.com>",
		"Diogo Monteiro <diogo.gmt@gmail.com>",
		"Dmitrii Sorin <info@staypositive.ru>",
		"Dmitriy Simushev <simushevds@gmail.com>",
		"Dmitry Shirokov <deadrunk@gmail.com>",
		"Dmitry Sorin <info@staypositive.ru>",
		"Domenic Denicola <domenic@domenicdenicola.com>",
		"Dominic Barnes <dominic@dbarnes.info>",
		"Dominique Quatravaux <dominique@quatravaux.org>",
		"Douglas Christopher Wilson <doug@somethingdoug.com>",
		"Duncan Beevers <duncan@dweebd.com>",
		"eiji.ienaga <eiji.ienaga@gmail.com>",
		"elergy <elergy@yandex-team.ru>",
		"Eli Skeggs <skeggse@users.noreply.github.com>",
		"ELLIOTTCABLE <me@ell.io>",
		"Emanuele <my.burning@gmail.com>",
		"Enric Pallerols <enric@pallerols.cat>",
		"Erik Eng <mail@ptz0n.se>",
		"Eugene Tiutiunnyk <eugene.tiutiunnyk@lookout.com>",
		"EunChan Park <pec9399@naver.com>",
		"Fabio M. Costa <fabiomcosta@gmail.com>",
		"Fábio Santos <fabiosantosart@gmail.com>",
		"Fagner Brack <github3@fagnermartins.com>",
		"fargies <fargies@users.noreply.github.com>",
		"FARKAS Máté <mate.farkas@virtual-call-center.eu>",
		"fcrisci <fabio.crisci@amadeus.com>",
		"Fede Ramirez <i@2fd.me>",
		"Fedor Indutny <fedor.indutny@gmail.com>",
		"fengmk2 <fengmk2@gmail.com>",
		"Fin Chen <finfin@gmail.com>",
		"Florian Margaine <florian@margaine.com>",
		"FND <FND@users.noreply.github.com>",
		"fool2fish <fool2fish@gmail.com>",
		"Forbes Lindesay <forbes@lindesay.co.uk>",
		"Frank Leon Rose <frankleonrose@gmail.com>",
		"Frederico Silva <frederico.silva@gmail.com>",
		"Fredrik Enestad <fredrik@devloop.se>",
		"Fredrik Lindin <fredriklindin@gmail.com>",
		"Fumiaki MATSUSHIMA <mtsmfm@gmail.com>",
		"Gabe Gorelick <gabegorelick@gmail.com>",
		"Gabriel Silk <gabesilk@gmail.com>",
		"Gareth Aye <gaye@mozilla.com>",
		"Gareth Murphy <gareth.cpm@gmail.com>",
		"Gastón I. Silva <givanse@gmail.com>",
		"Gavin Mogan <GavinM@airg.com>",
		"gaye <gaye@mozilla.com>",
		"gigadude <gigadude@users.noreply.github.com>",
		"Giovanni Bassi <giggio@giggio.net>",
		"gizemkeser <44727928+gizemkeser@users.noreply.github.com>",
		"Glen Huang <curvedmark@gmail.com>",
		"Glen Mailer <glenjamin@gmail.com>",
		"grasGendarme <me@grasgendar.me>",
		"Greg Perkins <gregperkins@alum.mit.edu>",
		"Guangcong Luo <guangcongluo@gmail.com>",
		"Guillermo Rauch <rauchg@gmail.com>",
		"Guy Arye <arye.guy@gmail.com>",
		"Gyandeep Singh <gyandeeps@gmail.com>",
		"Harish <hyeluri@gmail.com>",
		"Harry Brundage <harry.brundage@gmail.com>",
		"Harry Sarson <harry.sarson@hotmail.co.uk>",
		"Harry Wolff <hswolff@users.noreply.github.com>",
		"Herman Junge <herman@geekli.st>",
		"hokaccha <k.hokamura@gmail.com>",
		"Honza Javorek <mail@honzajavorek.cz>",
		"Hugo Giraudel <hugo.giraudel@gmail.com>",
		"Hugo Kim <k7120792@gmail.com>",
		"HYUNSANG HAN <gustkd3@gmail.com>",
		"HyunSangHan <gustkd3@gmail.com>",
		"Ian Storm Taylor <ian@ianstormtaylor.com>",
		"Ian W. Remmel <design@ianwremmel.com>",
		"Ian Young <ian.greenleaf@gmail.com>",
		"Ian Zamojc <ian@thesecretlocation.net>",
		"Igwe Kalu <igwe.kalu@live.com>",
		"ImgBot <31427850+ImgBotApp@users.noreply.github.com>",
		"inxorable <inxorable@codewren.ch>",
		"Ivan <ivan@kinvey.com>",
		"Jaakko Salonen <jaakko.salonen@iki.fi>",
		"Jacob Wejendorp <jacob@wejendorp.dk>",
		"Jake Craige <james.craige@gmail.com>",
		"Jake Marsh <jakemmarsh@gmail.com>",
		"Jakob Krigovsky <jakob@krigovsky.com>",
		"Jakub Nešetřil <jakub@apiary.io>",
		"James Bowes <jbowes@repl.ca>",
		"James Carr <james.r.carr@gmail.com>",
		"James D. Rogers <jd2rogers2@gmail.com>",
		"James G. Kim <jgkim@jayg.org>",
		"James Lal <james@lightsofapollo.com>",
		"James Nylen <jnylen@gmail.com>",
		"Jan Kopriva <jan.kopriva@gooddata.com>",
		"Jan Krems <jan.krems@groupon.com>",
		"Jan Lehnardt <jan@apache.org>",
		"Jan-Philip Gehrcke <jgehrcke@googlemail.com>",
		"Jason Barry <jay@jcbarry.com>",
		"Jason Lai <jason@getpebble.com>",
		"Jason Leyba <jmleyba@gmail.com>",
		"Javier Aranda <javierav@javierav.com>",
		"Jayasankar <jayasankar.m@gmail.com>",
		"Jean Ponchon <gelule@gmail.com>",
		"Jeff Kunkle <jeff.kunkle@nearinfinity.com>",
		"Jeff Schilling <jeff.schilling@q2ebanking.com>",
		"JeongHoon Byun (aka Outsider) <outsideris@gmail.com>",
		"Jérémie Astori <jeremie@astori.fr>",
		"Jeremy Martin <jmar777@gmail.com>",
		"Jerry Muzsik <jerrymuzsik@icloud.com>",
		"Jesse Dailey <jesse.dailey@gmail.com>",
		"jimenglish81 <jimenglish81@gmail.com>",
		"Jimmy Cuadra <jimmy@jimmycuadra.com>",
		"Jo Liss <joliss42@gmail.com>",
		"Joao Moreno <mail@joaomoreno.com>",
		"Joel Kemp <mrjoelkemp@gmail.com>",
		"Joey Cozza <joey@grow.com>",
		"John Doty <jrhdoty@gmail.com>",
		"John Firebaugh <john.firebaugh@gmail.com>",
		"John Reeves <github@jonnyreeves.co.uk>",
		"Johnathon Sanders <outdooricon@gmail.com>",
		"Jon Surrell <jon.surrell@automattic.com>",
		"Jonas Dohse <jonas@mbr-targeting.com>",
		"Jonas Westerlund <jonas.westerlund@me.com>",
		"Jonathan Creamer <matrixhasyou2k4@gmail.com>",
		"Jonathan Delgado <jdelgado@rewip.com>",
		"Jonathan Kim <jkimbo@gmail.com>",
		"Jonathan Ong <jonathanrichardong@gmail.com>",
		"Jonathan Park <jpark@daptiv.com>",
		"Jonathan Rajavuori <jrajav@gmail.com>",
		"Jordan Sexton <jordan@jordansexton.com>",
		"Joseph Lin <josephlin55555@gmail.com>",
		"Josh Eversmann <josh.eversmann@gmail.com>",
		"Josh Lory <josh.lory@code.org>",
		"Josh Soref <jsoref@users.noreply.github.com>",
		"Joshua Appelman <jappelman@xebia.com>",
		"Joshua Krall <joshuakrall@pobox.com>",
		"JP Bochi <jpbochi@gmail.com>",
		"jsdevel <js.developer.undefined@gmail.com>",
		"Juerg B <44573692+juergba@users.noreply.github.com>",
		"juergba <filodron@gmail.com>",
		"Julien Wajsberg <felash@gmail.com>",
		"Jupp Müller <jupp0r@gmail.com>",
		"Jussi Virtanen <jussi.k.virtanen@gmail.com>",
		"Justin DuJardin <justin.dujardin@sococo.com>",
		"Juzer Ali <er.juzerali@gmail.com>",
		"Katie Gengler <katiegengler@gmail.com>",
		"kavun <kevin.a.reed@gmail.com>",
		"Kazuhito Hokamura <k.hokamura@gmail.com>",
		"Keith Cirkel <github@keithcirkel.co.uk>",
		"Kelong Wang <buaawkl@gmail.com>",
		"Kent C. Dodds <kent+github@doddsfamily.us>",
		"Kevin Burke <kev@inburke.com>",
		"Kevin Conway <kevinjacobconway@gmail.com>",
		"Kevin Kirsche <Kev.Kirsche+GitHub@gmail.com>",
		"Kevin Partington <platinum.azure@kernelpanicstudios.com>",
		"Kevin Wang <kevin@fossa.io>",
		"Kirill Korolyov <kirill.korolyov@gmail.com>",
		"klaemo <klaemo@fastmail.fm>",
		"Koen Punt <koen@koenpunt.nl>",
		"Konstantin Käfer <github@kkaefer.com>",
		"Kris Rasmussen <kristopher.rasmussen@gmail.com>",
		"Kunal Nagpal <kunagpal@users.noreply.github.com>",
		"Kyle Fuller <kyle@fuller.li>",
		"Kyle Mitchell <kyle@kemitchell.com>",
		"KyoungWan <kyngwan@gmail.com>",
		"lakmeer <lakmeerkravid@gmail.com>",
		"Lane Kelly <lanekelly16@gmail.com>",
		"László Bácsi <lackac@lackac.hu>",
		"Laurence Rowe <lrowe@netflix.com>",
		"Liam Newman <bitwiseman@gmail.com>",
		"Lindsay-Needs-Sleep <51773923+Lindsay-Needs-Sleep@users.noreply.github.com>",
		"Linus Unnebäck <linus@folkdatorn.se>",
		"lodr <salva@unoyunodiez.com>",
		"Long Ho <longlho@users.noreply.github.com>",
		"Maciej Małecki <maciej.malecki@notimplemented.org>",
		"Mal Graty <mal.graty@googlemail.com>",
		"Marais Rossouw <me@maraisr.com>",
		"Marc Kuo <kuomarc2@gmail.com>",
		"Marc Udoff <mlucool@gmail.com>",
		"Marcello Bastea-Forte <marcello@cellosoft.com>",
		"Mario Díaz Ceñera <46492068+MarioDiaz98@users.noreply.github.com>",
		"Mark Banner <standard8@mozilla.com>",
		"Mark Owsiak <mark.owsiak@gmail.com>",
		"Markus Tacker <m@coderbyheart.com>",
		"Martijn Cuppens <martijn.cuppens@intracto.com>",
		"Martin Marko <marcus@gratex.com>",
		"Mathieu Desvé <mathieudesve@MacBook-Pro-de-Mathieu.local>",
		"Matija Marohnić <matija.marohnic@gmail.com>",
		"Matt Bierner <mattbierner@gmail.com>",
		"Matt Giles <matt.giles@cerner.com>",
		"Matt Robenolt <matt@ydekproductions.com>",
		"Matt Smith <matthewgarysmith@gmail.com>",
		"Matthew Shanley <matthewshanley@littlesecretsrecords.com>",
		"Mattias Tidlund <mattias.tidlund@learningwell.se>",
		"Max Goodman <c@chromakode.com>",
		"Maximilian Antoni <mail@maxantoni.de>",
		"Merrick Christensen <merrick.christensen@gmail.com>",
		"Mia <miajeongdev@gmail.com>",
		"Michael Demmer <demmer@jut.io>",
		"Michael Jackson <mjijackson@gmail.com>",
		"Michael Olson <mwolson@member.fsf.org>",
		"Michael Riley <michael.riley@autodesk.com>",
		"Michael Schoonmaker <michael.r.schoonmaker@gmail.com>",
		"Michal Charemza <michalcharemza@gmail.com>",
		"Michiel de Jong <michiel@unhosted.org>",
		"Mick Brooks <mick.brooks@sinking.in>",
		"Mike Pennisi <mike@mikepennisi.com>",
		"Mislav Marohnić <mislav.marohnic@gmail.com>",
		"monowerker <monowerker@gmail.com>",
		"Moshe Kolodny <mkolodny@integralads.com>",
		"mrShturman <mrshturman@gmail.com>",
		"Nathan Alderson <nathan.alderson@adtran.com>",
		"Nathan Black <nathan@nathanblack.org>",
		"Nathan Bowser <nathan.bowser@spiderstrategies.com>",
		"Nathan Houle <nathan@nathanhoule.com>",
		"Nathan Rajlich <nathan@tootallnate.net>",
		"nexdrew <andrew.goode@nextraq.com>",
		"Nick Fitzgerald <fitzgen@gmail.com>",
		"Nicolas Girault <nic.girault@gmail.com>",
		"Nicolo Taddei <taddei.uk@gmail.com>",
		"Nik Nyby <nnyby@columbia.edu>",
		"Nikolaos Georgiou <Nikolaos.Georgiou@gmail.com>",
		"nishigori <Takuya_Nishigori@voyagegroup.com>",
		"Noshir Patel <nosh@blackpiano.com>",
		"not-an-aardvark <not-an-aardvark@users.noreply.github.com>",
		"OlegTsyba <oleg.tsyba.ua@gmail.com>",
		"Oliver Salzburg <oliver.salzburg@gmail.com>",
		"olsonpm <olsonpm@users.noreply.github.com>",
		"omardelarosa <thedelarosa@gmail.com>",
		"Oscar Godson <oscargodson@outlook.com>",
		"Outsider <outsideris@gmail.com>",
		"oveddan <stangogh@gmail.com>",
		"P. Roebuck <plroebuck@users.noreply.github.com>",
		"Panu Horsmalahti <panu.horsmalahti@iki.fi>",
		"Park Seong-beom <parkgds@gmail.com>",
		"Parker Moore <parkrmoore@gmail.com>",
		"Pascal <pascal@pascal.com>",
		"Pat Finnigan <patrick.k.finnigan@gmail.com>",
		"Paul Armstrong <paul@paularmstrongdesigns.com>",
		"Paul Miller <paul@paulmillr.com>",
		"Paul Roebuck <plroebuck@users.noreply.github.com>",
		"Pavel Zubkou <pavel.zubkou@gmail.com>",
		"Pete Hawkins <pete@petes-imac.frontinternal.net>",
		"Peter Müller <munter@fumle.dk>",
		"Peter Rust <peter@cornerstonenw.com>",
		"Peter Schmidt <peter@peterjs.com>",
		"Phil Sung <psung@dnanexus.com>",
		"Philip M. White <philip@mailworks.org>",
		"Piotr Kuczynski <piotr.kuczynski@gmail.com>",
		"PoppinL <poppinlp@gmail.com>",
		"Poprádi Árpád <popradi.arpad11@gmail.com>",
		"Prayag Verma <prayag.verma@gmail.com>",
		"qiuzuhui <qiuzuhui@users.noreply.github.com>",
		"Quang Van <quangvvv@gmail.com>",
		"Quanlong He <kyan.ql.he@gmail.com>",
		"R56 <rviskus@gmail.com>",
		"Raynos <raynos2@gmail.com>",
		"Refael Ackermann <refael@empeeric.com>",
		"Rens Groothuijsen <l.groothuijsen@alumni.maastrichtuniversity.nl>",
		"Rich Trott <rtrott@gmail.com>",
		"Richard Dingwall <rdingwall@gmail.com>",
		"Richard Knop <RichardKnop@users.noreply.github.com>",
		"Rico Sta. Cruz <rstacruz@users.noreply.github.com>",
		"rmacklin <richard.github@nrm.com>",
		"Rob Loach <robloach@gmail.com>",
		"Rob Raux <rraux@peachworks.com>",
		"Rob Wu <rob@robwu.nl>",
		"Robert Kieffer <robert@broofa.com>",
		"Robert Rossmann <rr.rossmann@me.com>",
		"Romain Prieto <romain.prieto@gmail.com>",
		"Roman Neuhauser <rneuhauser@suse.cz>",
		"Roman Shtylman <shtylman@gmail.com>",
		"Ross Warren <rosswarren4@gmail.com>",
		"rotemdan <rotemdan@gmail.com>",
		"Russ Bradberry <devdazed@me.com>",
		"Russell Munson <rmunson@github.com>",
		"Rustem Mustafin <mustafin.rustem@gmail.com>",
		"Ryan Hubbard <ryanmhubbard@gmail.com>",
		"Ryan Shaw <ryan.shaw@min.vc>",
		"Ryan Tablada <ryan.tablada@gmail.com>",
		"Ryunosuke SATO <tricknotes.rs@gmail.com>",
		"ryym <ryym.64@gmail.com>",
		"Saerom Bang <saerombang11@gmail.com>",
		"Salehen Shovon Rahman <salehen.rahman@gmail.com>",
		"Sam Mussell <smussell@gmail.com>",
		"samuel goldszmidt <samuel.goldszmidt@gmail.com>",
		"sarehag <joakim.sarehag@gmail.com>",
		"Sasha Koss <koss@nocorp.me>",
		"Scott Kao <Scottkao85@users.noreply.github.com>",
		"Scott Santucci <ScottFreeCode@users.noreply.github.com>",
		"ScottFreeCode <ScottFreeCode@users.noreply.github.com>",
		"Sean Lang <slang800@gmail.com>",
		"Sebastian Van Sande <sebastian@vansande.org>",
		"sebv <seb.vincent@gmail.com>",
		"Seiya Konno <nulltask@gmail.com>",
		"Sergey Simonchik <sergey.simonchik@jetbrains.com>",
		"Sergio Santoro <santoro.srg@gmail.com>",
		"Shaine Hatch <shaine@squidtree.com>",
		"Shawn Krisman <telaviv@github>",
		"SheetJSDev <dev@sheetjs.com>",
		"Shinnosuke Watanabe <snnskwtnb@gmail.com>",
		"silentcloud <rjmuqiang@gmail.com>",
		"Silvio Massari <silvio.massari@auth0.com>",
		"Simon Gaeremynck <gaeremyncks@gmail.com>",
		"Simon Goumaz <simon@attentif.ch>",
		"simov <simeonvelichkov@gmail.com>",
		"Sindre Sorhus <sindresorhus@gmail.com>",
		"Slobodan Mišković <slobodan@miskovic.ca>",
		"slyg <syl.faucherand@gmail.com>",
		"Soel <shachar.soel@sap.com>",
		"solodynamo <bittuf3@gmail.com>",
		"Sona Lee <mojosoeun@gmail.com>",
		"Soobin Bak <qls014738@gmail.com>",
		"Sorin Iclanzan <sorin@iclanzan.com>",
		"Standa Opichal <opichals@gmail.com>",
		"startswithaj <jake.mc@icloud.com>",
		"Stephen Hess <trescube@users.noreply.github.com>",
		"Stephen Mathieson <smath23@gmail.com>",
		"Steve Mason <stevem@brandwatch.com>",
		"Stewart Taylor <stewart.taylor1@gmail.com>",
		"Stone <baoshi.li@adleida.com>",
		"Sulabh Bista <sul4bh@gmail.com>",
		"Sune Simonsen <sune@we-knowhow.dk>",
		"Svetlana <39729453+Lana-Light@users.noreply.github.com>",
		"Sylvain <sstephant+github@gmail.com>",
		"Sylvester Keil <sylvester@keil.or.at>",
		"Szauka <33459309+Szauka@users.noreply.github.com>",
		"Tapiwa Kelvin <tapiwa@munzwa.tk>",
		"Ted Yavuzkurt <hello@TedY.io>",
		"Teddy Zeenny <teddyzeenny@gmail.com>",
		"tgautier@yahoo.com <tgautier@gmail.com>",
		"Thedark1337 <thedark1337@thedark1337.com>",
		"Thomas Broadley <buriedunderbooks@hotmail.com>",
		"Thomas Grainger <tagrain@gmail.com>",
		"Thomas Scholtes <thomas-scholtes@gmx.de>",
		"Thomas Vantuycom <thomasvantuycom@protonmail.com>",
		"Tim Ehat <timehat@gmail.com>",
		"Tim Harshman <goteamtim+git@gmail.com>",
		"Timo Tijhof <krinklemail@gmail.com>",
		"Timothy Gu <timothygu99@gmail.com>",
		"Tingan Ho <tingan87@gmail.com>",
		"tmont <tommy.mont@gmail.com>",
		"Tobias Bieniek <tobias.bieniek@gmail.com>",
		"Tobias Mollstam <tobias@mollstam.com>",
		"Todd Agulnick <tagulnick@onjack.com>",
		"Tom Coquereau <tom@thau.me>",
		"Tom Hughes <tom@compton.nu>",
		"Tomer Eskenazi <tomer.eskenazi@ironsrc.com>",
		"toyjhlee <toyjhlee@gmail.com>",
		"traleig1 <darkphoenix739@gmail.com>",
		"Travis Jeffery <tj@travisjeffery.com>",
		"tripu <t@tripu.info>",
		"Tyson Tate <tyson@tysontate.com>",
		"Vadim Nikitin <vnikiti@ncsu.edu>",
		"Valentin Agachi <github-com@agachi.name>",
		"Valeri Karpov <val@karpov.io>",
		"Victor <victor@turo.com>",
		"Victor Costan <costan@gmail.com>",
		"Ville Saukkonen <villesau@users.noreply.github.com>",
		"Vivek Ganesan <caliberoviv@gmail.com>",
		"vlad <iamvlad@gmail.com>",
		"Vlad Magdalin <vlad@webflow.com>",
		"Volker Buzek <volker.buzek@sap.com>",
		"Wanseob Lim <email@wanseob.com>",
		"Wil Moore III <wil.moore@wilmoore.com>",
		"Will Langstroth <will@langstroth.com>",
		"wsw <wsw0108@gmail.com>",
		"Xavier Antoviaque <xavier@antoviaque.org>",
		"Xavier Damman <xdamman@gmail.com>",
		"XhmikosR <xhmikosr@gmail.com>",
		"XhmikosR <xhmikosr@users.sourceforge.net>",
		"Yanis Wang <yanis.wang@gmail.com>",
		"yehiyam <yehiyam@users.noreply.github.com>",
		"Yoshiya Hinosawa <hinosawa@waku-2.com>",
		"Yuest Wang <yuestwang@gmail.com>",
		"yuitest <yuitest@cjhat.net>",
		"zhiyelee <zhiyelee@gmail.com>",
		"Zirak <zirakertan@gmail.com>",
		"Zsolt Takács <zsolt@takacs.cc>",
		"现充 <qixiang.cqx@alibaba-inc.com>"
	];
	var license = "MIT";
	var repository = {
		type: "git",
		url: "https://github.com/mochajs/mocha.git"
	};
	var bugs = {
		url: "https://github.com/mochajs/mocha/issues/"
	};
	var homepage = "https://mochajs.org/";
	var logo$1 = "https://cldup.com/S9uQ-cOLYz.svg";
	var notifyLogo = "https://ibin.co/4QuRuGjXvl36.png";
	var bin = {
		mocha: "./bin/mocha",
		_mocha: "./bin/_mocha"
	};
	var directories = {
		lib: "./lib",
		test: "./test"
	};
	var engines = {
		node: ">= 8.0.0"
	};
	var scripts = {
		prepublishOnly: "nps test clean build",
		start: "nps",
		test: "nps test",
		version: "nps version"
	};
	var dependencies = {
		"ansi-colors": "3.2.3",
		"browser-stdout": "1.3.1",
		chokidar: "3.3.0",
		debug: "3.2.6",
		diff: "3.5.0",
		"escape-string-regexp": "1.0.5",
		"find-up": "3.0.0",
		glob: "7.1.3",
		growl: "1.10.5",
		he: "1.2.0",
		"js-yaml": "3.13.1",
		"log-symbols": "2.2.0",
		minimatch: "3.0.4",
		mkdirp: "0.5.1",
		ms: "2.1.1",
		"node-environment-flags": "1.0.6",
		"object.assign": "4.1.0",
		"strip-json-comments": "2.0.1",
		"supports-color": "6.0.0",
		which: "1.3.1",
		"wide-align": "1.1.3",
		yargs: "13.3.0",
		"yargs-parser": "13.1.1",
		"yargs-unparser": "1.6.0"
	};
	var devDependencies = {
		"@11ty/eleventy": "^0.8.3",
		"@mocha/contributors": "^1.0.4",
		"@mocha/docdash": "^2.1.2",
		acorn: "^7.0.0",
		"assetgraph-builder": "^6.10.1",
		autoprefixer: "^9.6.0",
		browserify: "^16.2.3",
		"browserify-package-json": "^1.0.1",
		chai: "^4.2.0",
		"coffee-script": "^1.12.7",
		coveralls: "^3.0.3",
		"cross-env": "^5.2.0",
		"cross-spawn": "^6.0.5",
		eslint: "^5.16.0",
		"eslint-config-prettier": "^3.6.0",
		"eslint-config-semistandard": "^13.0.0",
		"eslint-config-standard": "^12.0.0",
		"eslint-plugin-import": "^2.17.3",
		"eslint-plugin-node": "^8.0.1",
		"eslint-plugin-prettier": "^3.1.0",
		"eslint-plugin-promise": "^4.1.1",
		"eslint-plugin-standard": "^4.0.0",
		"fs-extra": "^8.0.1",
		husky: "^1.3.1",
		hyperlink: "^4.3.1",
		jsdoc: "^3.6.3",
		karma: "^4.1.0",
		"karma-browserify": "^6.0.0",
		"karma-chrome-launcher": "^2.2.0",
		"karma-mocha": "^1.3.0",
		"karma-mocha-reporter": "^2.2.5",
		"karma-sauce-launcher": "^2.0.2",
		"lint-staged": "^8.1.7",
		"markdown-it": "^8.4.2",
		"markdown-it-anchor": "^5.2.4",
		"markdown-it-attrs": "^2.4.1",
		"markdown-it-prism": "^2.0.2",
		"markdown-magic": "^0.1.25",
		"markdown-magic-package-json": "^2.0.0",
		"markdown-toc": "^1.2.0",
		"markdownlint-cli": "^0.14.1",
		nps: "^5.9.5",
		nyc: "^14.1.1",
		prettier: "^1.17.1",
		remark: "^10.0.1",
		"remark-github": "^7.0.6",
		"remark-inline-links": "^3.1.2",
		rewiremock: "^3.13.7",
		rimraf: "^2.6.3",
		sinon: "^7.3.2",
		"strip-ansi": "^5.2.0",
		svgo: "^1.2.2",
		through2: "^3.0.1",
		"to-vfile": "^5.0.3",
		unexpected: "^10.40.2",
		"unexpected-eventemitter": "^1.1.3",
		"unexpected-sinon": "^10.11.2",
		uslug: "^1.0.4",
		watchify: "^3.11.1"
	};
	var files = [
		"bin/*mocha",
		"assets/growl/*.png",
		"lib/**/*.{js,html,json}",
		"index.js",
		"mocha.css",
		"mocha.js",
		"browser-entry.js"
	];
	var browserify = {
		transform: [
			"./scripts/package-json-cullify"
		]
	};
	var browser = {
		"./index.js": "./browser-entry.js",
		"./lib/growl.js": "./lib/browser/growl.js",
		tty: "./lib/browser/tty.js",
		"./lib/cli/*.js": false,
		chokidar: false,
		fs: false,
		glob: false,
		path: false,
		"supports-color": false
	};
	var prettier = {
		singleQuote: true,
		bracketSpacing: false,
		endOfLine: "auto"
	};
	var gitter = "https://gitter.im/mochajs/mocha";
	var husky = {
		hooks: {
			"pre-commit": "lint-staged"
		}
	};
	var _package = {
		name: name,
		version: version,
		description: description$4,
		keywords: keywords,
		funding: funding,
		author: author,
		contributors: contributors,
		license: license,
		repository: repository,
		bugs: bugs,
		homepage: homepage,
		logo: logo$1,
		notifyLogo: notifyLogo,
		bin: bin,
		directories: directories,
		engines: engines,
		scripts: scripts,
		dependencies: dependencies,
		devDependencies: devDependencies,
		files: files,
		browserify: browserify,
		browser: browser,
		prettier: prettier,
		gitter: gitter,
		"@mocha/contributors": {
		exclude: [
			"greenkeeperio-bot <support@greenkeeper.io>",
			"greenkeeper[bot] <greenkeeper[bot]@users.noreply.github.com>",
			"TJ Holowaychuk <tj@vision-media.ca>"
		]
	},
		husky: husky
	};

	var _package$1 = /*#__PURE__*/Object.freeze({
		name: name,
		version: version,
		description: description$4,
		keywords: keywords,
		funding: funding,
		author: author,
		contributors: contributors,
		license: license,
		repository: repository,
		bugs: bugs,
		homepage: homepage,
		logo: logo$1,
		notifyLogo: notifyLogo,
		bin: bin,
		directories: directories,
		engines: engines,
		scripts: scripts,
		dependencies: dependencies,
		devDependencies: devDependencies,
		files: files,
		browserify: browserify,
		browser: browser,
		prettier: prettier,
		gitter: gitter,
		husky: husky,
		'default': _package
	});

	var mocharc$2 = getCjsExportFromNamespace(mocharc$1);

	var require$$6 = getCjsExportFromNamespace(_package$1);

	var mocha = createCommonjsModule(function (module, exports) {

	/*!
	 * mocha
	 * Copyright(c) 2011 TJ Holowaychuk <tj@vision-media.ca>
	 * MIT Licensed
	 */










	var createInvalidReporterError = errors.createInvalidReporterError;
	var createInvalidInterfaceError = errors.createInvalidInterfaceError;
	var EVENT_FILE_PRE_REQUIRE = suite.constants.EVENT_FILE_PRE_REQUIRE;
	var EVENT_FILE_POST_REQUIRE = suite.constants.EVENT_FILE_POST_REQUIRE;
	var EVENT_FILE_REQUIRE = suite.constants.EVENT_FILE_REQUIRE;
	var sQuote = utils.sQuote;

	exports = module.exports = Mocha;

	/**
	 * To require local UIs and reporters when running in node.
	 */

	if (!process.browser) {
	  var cwd = process.cwd();
	  module.paths.push(cwd, path.join(cwd, 'node_modules'));
	}

	/**
	 * Expose internals.
	 */

	/**
	 * @public
	 * @class utils
	 * @memberof Mocha
	 */
	exports.utils = utils;
	exports.interfaces = interfaces;
	/**
	 * @public
	 * @memberof Mocha
	 */
	exports.reporters = reporters;
	exports.Runnable = runnable;
	exports.Context = context;
	/**
	 *
	 * @memberof Mocha
	 */
	exports.Runner = runner;
	exports.Suite = suite;
	exports.Hook = hook;
	exports.Test = test;

	/**
	 * Constructs a new Mocha instance with `options`.
	 *
	 * @public
	 * @class Mocha
	 * @param {Object} [options] - Settings object.
	 * @param {boolean} [options.allowUncaught] - Propagate uncaught errors?
	 * @param {boolean} [options.asyncOnly] - Force `done` callback or promise?
	 * @param {boolean} [options.bail] - Bail after first test failure?
	 * @param {boolean} [options.checkLeaks] - Check for global variable leaks?
	 * @param {boolean} [options.color] - Color TTY output from reporter?
	 * @param {boolean} [options.delay] - Delay root suite execution?
	 * @param {boolean} [options.diff] - Show diff on failure?
	 * @param {string} [options.fgrep] - Test filter given string.
	 * @param {boolean} [options.forbidOnly] - Tests marked `only` fail the suite?
	 * @param {boolean} [options.forbidPending] - Pending tests fail the suite?
	 * @param {boolean} [options.fullTrace] - Full stacktrace upon failure?
	 * @param {string[]} [options.global] - Variables expected in global scope.
	 * @param {RegExp|string} [options.grep] - Test filter given regular expression.
	 * @param {boolean} [options.growl] - Enable desktop notifications?
	 * @param {boolean} [options.inlineDiffs] - Display inline diffs?
	 * @param {boolean} [options.invert] - Invert test filter matches?
	 * @param {boolean} [options.noHighlighting] - Disable syntax highlighting?
	 * @param {string|constructor} [options.reporter] - Reporter name or constructor.
	 * @param {Object} [options.reporterOption] - Reporter settings object.
	 * @param {number} [options.retries] - Number of times to retry failed tests.
	 * @param {number} [options.slow] - Slow threshold value.
	 * @param {number|string} [options.timeout] - Timeout threshold value.
	 * @param {string} [options.ui] - Interface name.
	 */
	function Mocha(options) {
	  options = utils.assign({}, mocharc$2, options || {});
	  this.files = [];
	  this.options = options;
	  // root suite
	  this.suite = new exports.Suite('', new exports.Context(), true);

	  this.grep(options.grep)
	    .fgrep(options.fgrep)
	    .ui(options.ui)
	    .reporter(
	      options.reporter,
	      options.reporterOption || options.reporterOptions // reporterOptions was previously the only way to specify options to reporter
	    )
	    .slow(options.slow)
	    .global(options.global);

	  // this guard exists because Suite#timeout does not consider `undefined` to be valid input
	  if (typeof options.timeout !== 'undefined') {
	    this.timeout(options.timeout === false ? 0 : options.timeout);
	  }

	  if ('retries' in options) {
	    this.retries(options.retries);
	  }

	  [
	    'allowUncaught',
	    'asyncOnly',
	    'bail',
	    'checkLeaks',
	    'color',
	    'delay',
	    'diff',
	    'forbidOnly',
	    'forbidPending',
	    'fullTrace',
	    'growl',
	    'inlineDiffs',
	    'invert'
	  ].forEach(function(opt) {
	    if (options[opt]) {
	      this[opt]();
	    }
	  }, this);
	}

	/**
	 * Enables or disables bailing on the first failure.
	 *
	 * @public
	 * @see [CLI option](../#-bail-b)
	 * @param {boolean} [bail=true] - Whether to bail on first error.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.bail = function(bail) {
	  this.suite.bail(bail !== false);
	  return this;
	};

	/**
	 * @summary
	 * Adds `file` to be loaded for execution.
	 *
	 * @description
	 * Useful for generic setup code that must be included within test suite.
	 *
	 * @public
	 * @see [CLI option](../#-file-filedirectoryglob)
	 * @param {string} file - Pathname of file to be loaded.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.addFile = function(file) {
	  this.files.push(file);
	  return this;
	};

	/**
	 * Sets reporter to `reporter`, defaults to "spec".
	 *
	 * @public
	 * @see [CLI option](../#-reporter-name-r-name)
	 * @see [Reporters](../#reporters)
	 * @param {String|Function} reporter - Reporter name or constructor.
	 * @param {Object} [reporterOptions] - Options used to configure the reporter.
	 * @returns {Mocha} this
	 * @chainable
	 * @throws {Error} if requested reporter cannot be loaded
	 * @example
	 *
	 * // Use XUnit reporter and direct its output to file
	 * mocha.reporter('xunit', { output: '/path/to/testspec.xunit.xml' });
	 */
	Mocha.prototype.reporter = function(reporter, reporterOptions) {
	  if (typeof reporter === 'function') {
	    this._reporter = reporter;
	  } else {
	    reporter = reporter || 'spec';
	    var _reporter;
	    // Try to load a built-in reporter.
	    if (reporters[reporter]) {
	      _reporter = reporters[reporter];
	    }
	    // Try to load reporters from process.cwd() and node_modules
	    if (!_reporter) {
	      try {
	        _reporter = commonjsRequire(reporter);
	      } catch (err) {
	        if (
	          err.code !== 'MODULE_NOT_FOUND' ||
	          err.message.indexOf('Cannot find module') !== -1
	        ) {
	          // Try to load reporters from a path (absolute or relative)
	          try {
	            _reporter = commonjsRequire(path.resolve(process.cwd(), reporter));
	          } catch (_err) {
	            _err.code !== 'MODULE_NOT_FOUND' ||
	            _err.message.indexOf('Cannot find module') !== -1
	              ? console.warn(sQuote(reporter) + ' reporter not found')
	              : console.warn(
	                  sQuote(reporter) +
	                    ' reporter blew up with error:\n' +
	                    err.stack
	                );
	          }
	        } else {
	          console.warn(
	            sQuote(reporter) + ' reporter blew up with error:\n' + err.stack
	          );
	        }
	      }
	    }
	    if (!_reporter) {
	      throw createInvalidReporterError(
	        'invalid reporter ' + sQuote(reporter),
	        reporter
	      );
	    }
	    this._reporter = _reporter;
	  }
	  this.options.reporterOption = reporterOptions;
	  // alias option name is used in public reporters xunit/tap/progress
	  this.options.reporterOptions = reporterOptions;
	  return this;
	};

	/**
	 * Sets test UI `name`, defaults to "bdd".
	 *
	 * @public
	 * @see [CLI option](../#-ui-name-u-name)
	 * @see [Interface DSLs](../#interfaces)
	 * @param {string|Function} [ui=bdd] - Interface name or class.
	 * @returns {Mocha} this
	 * @chainable
	 * @throws {Error} if requested interface cannot be loaded
	 */
	Mocha.prototype.ui = function(ui) {
	  var bindInterface;
	  if (typeof ui === 'function') {
	    bindInterface = ui;
	  } else {
	    ui = ui || 'bdd';
	    bindInterface = exports.interfaces[ui];
	    if (!bindInterface) {
	      try {
	        bindInterface = commonjsRequire(ui);
	      } catch (err) {
	        throw createInvalidInterfaceError(
	          'invalid interface ' + sQuote(ui),
	          ui
	        );
	      }
	    }
	  }
	  bindInterface(this.suite);

	  this.suite.on(EVENT_FILE_PRE_REQUIRE, function(context) {
	    exports.afterEach = context.afterEach || context.teardown;
	    exports.after = context.after || context.suiteTeardown;
	    exports.beforeEach = context.beforeEach || context.setup;
	    exports.before = context.before || context.suiteSetup;
	    exports.describe = context.describe || context.suite;
	    exports.it = context.it || context.test;
	    exports.xit = context.xit || (context.test && context.test.skip);
	    exports.setup = context.setup || context.beforeEach;
	    exports.suiteSetup = context.suiteSetup || context.before;
	    exports.suiteTeardown = context.suiteTeardown || context.after;
	    exports.suite = context.suite || context.describe;
	    exports.teardown = context.teardown || context.afterEach;
	    exports.test = context.test || context.it;
	    exports.run = context.run;
	  });

	  return this;
	};

	/**
	 * Loads `files` prior to execution.
	 *
	 * @description
	 * The implementation relies on Node's `require` to execute
	 * the test interface functions and will be subject to its cache.
	 *
	 * @private
	 * @see {@link Mocha#addFile}
	 * @see {@link Mocha#run}
	 * @see {@link Mocha#unloadFiles}
	 * @param {Function} [fn] - Callback invoked upon completion.
	 */
	Mocha.prototype.loadFiles = function(fn) {
	  var self = this;
	  var suite = this.suite;
	  this.files.forEach(function(file) {
	    file = path.resolve(file);
	    suite.emit(EVENT_FILE_PRE_REQUIRE, commonjsGlobal, file, self);
	    suite.emit(EVENT_FILE_REQUIRE, commonjsRequire(file), file, self);
	    suite.emit(EVENT_FILE_POST_REQUIRE, commonjsGlobal, file, self);
	  });
	  fn && fn();
	};

	/**
	 * Removes a previously loaded file from Node's `require` cache.
	 *
	 * @private
	 * @static
	 * @see {@link Mocha#unloadFiles}
	 * @param {string} file - Pathname of file to be unloaded.
	 */
	Mocha.unloadFile = function(file) {
	  delete commonjsRequire.cache[commonjsRequire.resolve(file)];
	};

	/**
	 * Unloads `files` from Node's `require` cache.
	 *
	 * @description
	 * This allows files to be "freshly" reloaded, providing the ability
	 * to reuse a Mocha instance programmatically.
	 *
	 * <strong>Intended for consumers &mdash; not used internally</strong>
	 *
	 * @public
	 * @see {@link Mocha#run}
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.unloadFiles = function() {
	  this.files.forEach(Mocha.unloadFile);
	  return this;
	};

	/**
	 * Sets `grep` filter after escaping RegExp special characters.
	 *
	 * @public
	 * @see {@link Mocha#grep}
	 * @param {string} str - Value to be converted to a regexp.
	 * @returns {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title begins with `"foo"` followed by a period
	 * mocha.fgrep('foo.');
	 */
	Mocha.prototype.fgrep = function(str) {
	  if (!str) {
	    return this;
	  }
	  return this.grep(new RegExp(escapeStringRegexp(str)));
	};

	/**
	 * @summary
	 * Sets `grep` filter used to select specific tests for execution.
	 *
	 * @description
	 * If `re` is a regexp-like string, it will be converted to regexp.
	 * The regexp is tested against the full title of each test (i.e., the
	 * name of the test preceded by titles of each its ancestral suites).
	 * As such, using an <em>exact-match</em> fixed pattern against the
	 * test name itself will not yield any matches.
	 * <br>
	 * <strong>Previous filter value will be overwritten on each call!</strong>
	 *
	 * @public
	 * @see [CLI option](../#-grep-regexp-g-regexp)
	 * @see {@link Mocha#fgrep}
	 * @see {@link Mocha#invert}
	 * @param {RegExp|String} re - Regular expression used to select tests.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title contains `"match"`, ignoring case
	 * mocha.grep(/match/i);
	 * @example
	 *
	 * // Same as above but with regexp-like string argument
	 * mocha.grep('/match/i');
	 * @example
	 *
	 * // ## Anti-example
	 * // Given embedded test `it('only-this-test')`...
	 * mocha.grep('/^only-this-test$/');    // NO! Use `.only()` to do this!
	 */
	Mocha.prototype.grep = function(re) {
	  if (utils.isString(re)) {
	    // extract args if it's regex-like, i.e: [string, pattern, flag]
	    var arg = re.match(/^\/(.*)\/(g|i|)$|.*/);
	    this.options.grep = new RegExp(arg[1] || arg[0], arg[2]);
	  } else {
	    this.options.grep = re;
	  }
	  return this;
	};

	/**
	 * Inverts `grep` matches.
	 *
	 * @public
	 * @see {@link Mocha#grep}
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Select tests whose full title does *not* contain `"match"`, ignoring case
	 * mocha.grep(/match/i).invert();
	 */
	Mocha.prototype.invert = function() {
	  this.options.invert = true;
	  return this;
	};

	/**
	 * Enables or disables ignoring global leaks.
	 *
	 * @deprecated since v7.0.0
	 * @public
	 * @see {@link Mocha#checkLeaks}
	 * @param {boolean} [ignoreLeaks=false] - Whether to ignore global leaks.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.ignoreLeaks = function(ignoreLeaks) {
	  utils.deprecate(
	    '"ignoreLeaks()" is DEPRECATED, please use "checkLeaks()" instead.'
	  );
	  this.options.checkLeaks = !ignoreLeaks;
	  return this;
	};

	/**
	 * Enables or disables checking for global variables leaked while running tests.
	 *
	 * @public
	 * @see [CLI option](../#-check-leaks)
	 * @param {boolean} [checkLeaks=true] - Whether to check for global variable leaks.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.checkLeaks = function(checkLeaks) {
	  this.options.checkLeaks = checkLeaks !== false;
	  return this;
	};

	/**
	 * Displays full stack trace upon test failure.
	 *
	 * @public
	 * @see [CLI option](../#-full-trace)
	 * @param {boolean} [fullTrace=true] - Whether to print full stacktrace upon failure.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.fullTrace = function(fullTrace) {
	  this.options.fullTrace = fullTrace !== false;
	  return this;
	};

	/**
	 * Enables desktop notification support if prerequisite software installed.
	 *
	 * @public
	 * @see [CLI option](../#-growl-g)
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.growl = function() {
	  this.options.growl = this.isGrowlCapable();
	  if (!this.options.growl) {
	    var detail = process.browser
	      ? 'notification support not available in this browser...'
	      : 'notification support prerequisites not installed...';
	    console.error(detail + ' cannot enable!');
	  }
	  return this;
	};

	/**
	 * @summary
	 * Determines if Growl support seems likely.
	 *
	 * @description
	 * <strong>Not available when run in browser.</strong>
	 *
	 * @private
	 * @see {@link Growl#isCapable}
	 * @see {@link Mocha#growl}
	 * @return {boolean} whether Growl support can be expected
	 */
	Mocha.prototype.isGrowlCapable = growl.isCapable;

	/**
	 * Implements desktop notifications using a pseudo-reporter.
	 *
	 * @private
	 * @see {@link Mocha#growl}
	 * @see {@link Growl#notify}
	 * @param {Runner} runner - Runner instance.
	 */
	Mocha.prototype._growl = growl.notify;

	/**
	 * Specifies whitelist of variable names to be expected in global scope.
	 *
	 * @public
	 * @see [CLI option](../#-global-variable-name)
	 * @see {@link Mocha#checkLeaks}
	 * @param {String[]|String} global - Accepted global variable name(s).
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Specify variables to be expected in global scope
	 * mocha.global(['jQuery', 'MyLib']);
	 */
	Mocha.prototype.global = function(global) {
	  this.options.global = (this.options.global || [])
	    .concat(global)
	    .filter(Boolean)
	    .filter(function(elt, idx, arr) {
	      return arr.indexOf(elt) === idx;
	    });
	  return this;
	};
	// for backwards compability, 'globals' is an alias of 'global'
	Mocha.prototype.globals = Mocha.prototype.global;

	/**
	 * Enables or disables TTY color output by screen-oriented reporters.
	 *
	 * @deprecated since v7.0.0
	 * @public
	 * @see {@link Mocha#color}
	 * @param {boolean} colors - Whether to enable color output.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.useColors = function(colors) {
	  utils.deprecate('"useColors()" is DEPRECATED, please use "color()" instead.');
	  if (colors !== undefined) {
	    this.options.color = colors;
	  }
	  return this;
	};

	/**
	 * Enables or disables TTY color output by screen-oriented reporters.
	 *
	 * @public
	 * @see [CLI option](../#-color-c-colors)
	 * @param {boolean} [color=true] - Whether to enable color output.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.color = function(color) {
	  this.options.color = color !== false;
	  return this;
	};

	/**
	 * Determines if reporter should use inline diffs (rather than +/-)
	 * in test failure output.
	 *
	 * @deprecated since v7.0.0
	 * @public
	 * @see {@link Mocha#inlineDiffs}
	 * @param {boolean} [inlineDiffs=false] - Whether to use inline diffs.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.useInlineDiffs = function(inlineDiffs) {
	  utils.deprecate(
	    '"useInlineDiffs()" is DEPRECATED, please use "inlineDiffs()" instead.'
	  );
	  this.options.inlineDiffs = inlineDiffs !== undefined && inlineDiffs;
	  return this;
	};

	/**
	 * Enables or disables reporter to use inline diffs (rather than +/-)
	 * in test failure output.
	 *
	 * @public
	 * @see [CLI option](../#-inline-diffs)
	 * @param {boolean} [inlineDiffs=true] - Whether to use inline diffs.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.inlineDiffs = function(inlineDiffs) {
	  this.options.inlineDiffs = inlineDiffs !== false;
	  return this;
	};

	/**
	 * Determines if reporter should include diffs in test failure output.
	 *
	 * @deprecated since v7.0.0
	 * @public
	 * @see {@link Mocha#diff}
	 * @param {boolean} [hideDiff=false] - Whether to hide diffs.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.hideDiff = function(hideDiff) {
	  utils.deprecate('"hideDiff()" is DEPRECATED, please use "diff()" instead.');
	  this.options.diff = !(hideDiff === true);
	  return this;
	};

	/**
	 * Enables or disables reporter to include diff in test failure output.
	 *
	 * @public
	 * @see [CLI option](../#-diff)
	 * @param {boolean} [diff=true] - Whether to show diff on failure.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.diff = function(diff) {
	  this.options.diff = diff !== false;
	  return this;
	};

	/**
	 * @summary
	 * Sets timeout threshold value.
	 *
	 * @description
	 * A string argument can use shorthand (such as "2s") and will be converted.
	 * If the value is `0`, timeouts will be disabled.
	 *
	 * @public
	 * @see [CLI option](../#-timeout-ms-t-ms)
	 * @see [Timeouts](../#timeouts)
	 * @see {@link Mocha#enableTimeouts}
	 * @param {number|string} msecs - Timeout threshold value.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Sets timeout to one second
	 * mocha.timeout(1000);
	 * @example
	 *
	 * // Same as above but using string argument
	 * mocha.timeout('1s');
	 */
	Mocha.prototype.timeout = function(msecs) {
	  this.suite.timeout(msecs);
	  return this;
	};

	/**
	 * Sets the number of times to retry failed tests.
	 *
	 * @public
	 * @see [CLI option](../#-retries-n)
	 * @see [Retry Tests](../#retry-tests)
	 * @param {number} retry - Number of times to retry failed tests.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Allow any failed test to retry one more time
	 * mocha.retries(1);
	 */
	Mocha.prototype.retries = function(n) {
	  this.suite.retries(n);
	  return this;
	};

	/**
	 * Sets slowness threshold value.
	 *
	 * @public
	 * @see [CLI option](../#-slow-ms-s-ms)
	 * @param {number} msecs - Slowness threshold value.
	 * @return {Mocha} this
	 * @chainable
	 * @example
	 *
	 * // Sets "slow" threshold to half a second
	 * mocha.slow(500);
	 * @example
	 *
	 * // Same as above but using string argument
	 * mocha.slow('0.5s');
	 */
	Mocha.prototype.slow = function(msecs) {
	  this.suite.slow(msecs);
	  return this;
	};

	/**
	 * Enables or disables timeouts.
	 *
	 * @public
	 * @see [CLI option](../#-timeout-ms-t-ms)
	 * @param {boolean} enableTimeouts - Whether to enable timeouts.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.enableTimeouts = function(enableTimeouts) {
	  this.suite.enableTimeouts(
	    arguments.length && enableTimeouts !== undefined ? enableTimeouts : true
	  );
	  return this;
	};

	/**
	 * Forces all tests to either accept a `done` callback or return a promise.
	 *
	 * @public
	 * @see [CLI option](../#-async-only-a)
	 * @param {boolean} [asyncOnly=true] - Wether to force `done` callback or promise.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.asyncOnly = function(asyncOnly) {
	  this.options.asyncOnly = asyncOnly !== false;
	  return this;
	};

	/**
	 * Disables syntax highlighting (in browser).
	 *
	 * @public
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.noHighlighting = function() {
	  this.options.noHighlighting = true;
	  return this;
	};

	/**
	 * Enables or disables uncaught errors to propagate.
	 *
	 * @public
	 * @see [CLI option](../#-allow-uncaught)
	 * @param {boolean} [allowUncaught=true] - Whether to propagate uncaught errors.
	 * @return {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.allowUncaught = function(allowUncaught) {
	  this.options.allowUncaught = allowUncaught !== false;
	  return this;
	};

	/**
	 * @summary
	 * Delays root suite execution.
	 *
	 * @description
	 * Used to perform asynch operations before any suites are run.
	 *
	 * @public
	 * @see [delayed root suite](../#delayed-root-suite)
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.delay = function delay() {
	  this.options.delay = true;
	  return this;
	};

	/**
	 * Causes tests marked `only` to fail the suite.
	 *
	 * @public
	 * @see [CLI option](../#-forbid-only)
	 * @param {boolean} [forbidOnly=true] - Whether tests marked `only` fail the suite.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.forbidOnly = function(forbidOnly) {
	  this.options.forbidOnly = forbidOnly !== false;
	  return this;
	};

	/**
	 * Causes pending tests and tests marked `skip` to fail the suite.
	 *
	 * @public
	 * @see [CLI option](../#-forbid-pending)
	 * @param {boolean} [forbidPending=true] - Whether pending tests fail the suite.
	 * @returns {Mocha} this
	 * @chainable
	 */
	Mocha.prototype.forbidPending = function(forbidPending) {
	  this.options.forbidPending = forbidPending !== false;
	  return this;
	};

	/**
	 * Mocha version as specified by "package.json".
	 *
	 * @name Mocha#version
	 * @type string
	 * @readonly
	 */
	Object.defineProperty(Mocha.prototype, 'version', {
	  value: require$$6.version,
	  configurable: false,
	  enumerable: true,
	  writable: false
	});

	/**
	 * Callback to be invoked when test execution is complete.
	 *
	 * @callback DoneCB
	 * @param {number} failures - Number of failures that occurred.
	 */

	/**
	 * Runs root suite and invokes `fn()` when complete.
	 *
	 * @description
	 * To run tests multiple times (or to run tests in files that are
	 * already in the `require` cache), make sure to clear them from
	 * the cache first!
	 *
	 * @public
	 * @see {@link Mocha#unloadFiles}
	 * @see {@link Runner#run}
	 * @param {DoneCB} [fn] - Callback invoked when test execution completed.
	 * @return {Runner} runner instance
	 */
	Mocha.prototype.run = function(fn) {
	  if (this.files.length) {
	    this.loadFiles();
	  }
	  var suite = this.suite;
	  var options = this.options;
	  options.files = this.files;
	  var runner = new exports.Runner(suite, options.delay);
	  statsCollector(runner);
	  var reporter = new this._reporter(runner, options);
	  runner.checkLeaks = options.checkLeaks === true;
	  runner.fullStackTrace = options.fullTrace;
	  runner.asyncOnly = options.asyncOnly;
	  runner.allowUncaught = options.allowUncaught;
	  runner.forbidOnly = options.forbidOnly;
	  runner.forbidPending = options.forbidPending;
	  if (options.grep) {
	    runner.grep(options.grep, options.invert);
	  }
	  if (options.global) {
	    runner.globals(options.global);
	  }
	  if (options.growl) {
	    this._growl(runner);
	  }
	  if (options.color !== undefined) {
	    exports.reporters.Base.useColors = options.color;
	  }
	  exports.reporters.Base.inlineDiffs = options.inlineDiffs;
	  exports.reporters.Base.hideDiff = !options.diff;

	  function done(failures) {
	    fn = fn || utils.noop;
	    if (reporter.done) {
	      reporter.done(failures, fn);
	    } else {
	      fn(failures);
	    }
	  }

	  return runner.run(done);
	};
	});
	var mocha_1 = mocha.utils;
	var mocha_2 = mocha.interfaces;
	var mocha_3 = mocha.reporters;
	var mocha_4 = mocha.Runnable;
	var mocha_5 = mocha.Context;
	var mocha_6 = mocha.Runner;
	var mocha_7 = mocha.Suite;
	var mocha_8 = mocha.Hook;
	var mocha_9 = mocha.Test;
	var mocha_10 = mocha.afterEach;
	var mocha_11 = mocha.after;
	var mocha_12 = mocha.beforeEach;
	var mocha_13 = mocha.before;
	var mocha_14 = mocha.describe;
	var mocha_15 = mocha.it;
	var mocha_16 = mocha.xit;
	var mocha_17 = mocha.setup;
	var mocha_18 = mocha.suiteSetup;
	var mocha_19 = mocha.suiteTeardown;
	var mocha_20 = mocha.suite;
	var mocha_21 = mocha.teardown;
	var mocha_22 = mocha.test;
	var mocha_23 = mocha.run;

	/* eslint no-unused-vars: off */
	/* eslint-env commonjs */

	/**
	 * Shim process.stdout.
	 */

	process.stdout = browserStdout({label: false});



	/**
	 * Create a Mocha instance.
	 *
	 * @return {undefined}
	 */

	var mocha$1 = new mocha({reporter: 'html'});

	/**
	 * Save timer references to avoid Sinon interfering (see GH-237).
	 */

	var Date$2 = commonjsGlobal.Date;
	var setTimeout$1 = commonjsGlobal.setTimeout;
	var setInterval = commonjsGlobal.setInterval;
	var clearTimeout$1 = commonjsGlobal.clearTimeout;
	var clearInterval = commonjsGlobal.clearInterval;

	var uncaughtExceptionHandlers = [];

	var originalOnerrorHandler = commonjsGlobal.onerror;

	/**
	 * Remove uncaughtException listener.
	 * Revert to original onerror handler if previously defined.
	 */

	process.removeListener = function(e, fn) {
	  if (e === 'uncaughtException') {
	    if (originalOnerrorHandler) {
	      commonjsGlobal.onerror = originalOnerrorHandler;
	    } else {
	      commonjsGlobal.onerror = function() {};
	    }
	    var i = uncaughtExceptionHandlers.indexOf(fn);
	    if (i !== -1) {
	      uncaughtExceptionHandlers.splice(i, 1);
	    }
	  }
	};

	/**
	 * Implements uncaughtException listener.
	 */

	process.on = function(e, fn) {
	  if (e === 'uncaughtException') {
	    commonjsGlobal.onerror = function(err, url, line) {
	      fn(new Error(err + ' (' + url + ':' + line + ')'));
	      return !mocha$1.allowUncaught;
	    };
	    uncaughtExceptionHandlers.push(fn);
	  }
	};

	// The BDD UI is registered by default, but no UI will be functional in the
	// browser without an explicit call to the overridden `mocha.ui` (see below).
	// Ensure that this default UI does not expose its methods to the global scope.
	mocha$1.suite.removeAllListeners('pre-require');

	var immediateQueue = [];
	var immediateTimeout;

	function timeslice() {
	  var immediateStart = new Date$2().getTime();
	  while (immediateQueue.length && new Date$2().getTime() - immediateStart < 100) {
	    immediateQueue.shift()();
	  }
	  if (immediateQueue.length) {
	    immediateTimeout = setTimeout$1(timeslice, 0);
	  } else {
	    immediateTimeout = null;
	  }
	}

	/**
	 * High-performance override of Runner.immediately.
	 */

	mocha.Runner.immediately = function(callback) {
	  immediateQueue.push(callback);
	  if (!immediateTimeout) {
	    immediateTimeout = setTimeout$1(timeslice, 0);
	  }
	};

	/**
	 * Function to allow assertion libraries to throw errors directly into mocha.
	 * This is useful when running tests in a browser because window.onerror will
	 * only receive the 'message' attribute of the Error.
	 */
	mocha$1.throwError = function(err) {
	  uncaughtExceptionHandlers.forEach(function(fn) {
	    fn(err);
	  });
	  throw err;
	};

	/**
	 * Override ui to ensure that the ui functions are initialized.
	 * Normally this would happen in Mocha.prototype.loadFiles.
	 */

	mocha$1.ui = function(ui) {
	  mocha.prototype.ui.call(this, ui);
	  this.suite.emit('pre-require', commonjsGlobal, null, this);
	  return this;
	};

	/**
	 * Setup mocha with the given setting options.
	 */

	mocha$1.setup = function(opts) {
	  if (typeof opts === 'string') {
	    opts = {ui: opts};
	  }
	  for (var opt in opts) {
	    if (opts.hasOwnProperty(opt)) {
	      this[opt](opts[opt]);
	    }
	  }
	  return this;
	};

	/**
	 * Run mocha, returning the Runner.
	 */

	mocha$1.run = function(fn) {
	  var options = mocha$1.options;
	  mocha$1.globals('location');

	  var query = mocha.utils.parseQuery(commonjsGlobal.location.search || '');
	  if (query.grep) {
	    mocha$1.grep(query.grep);
	  }
	  if (query.fgrep) {
	    mocha$1.fgrep(query.fgrep);
	  }
	  if (query.invert) {
	    mocha$1.invert();
	  }

	  return mocha.prototype.run.call(mocha$1, function(err) {
	    // The DOM Document is not available in Web Workers.
	    var document = commonjsGlobal.document;
	    if (
	      document &&
	      document.getElementById('mocha') &&
	      options.noHighlighting !== true
	    ) {
	      mocha.utils.highlightTags('code');
	    }
	    if (fn) {
	      fn(err);
	    }
	  });
	};

	/**
	 * Expose the process shim.
	 * https://github.com/mochajs/mocha/pull/916
	 */

	mocha.process = process;

	/**
	 * Expose mocha.
	 */

	commonjsGlobal.Mocha = mocha;
	commonjsGlobal.mocha = mocha$1;

	// this allows test/acceptance/required-tokens.js to pass; thus,
	// you can now do `const describe = require('mocha').describe` in a
	// browser context (assuming browserification).  should fix #880
	var browserEntry = commonjsGlobal;

	return browserEntry;

}));
